package com.unis.accountability.businessmanagement.client;

import com.unis.accountability.businessmanagement.common.vo.cityPhbm.CityPhbmPage;
import com.unis.accountability.businessmanagement.common.vo.cityPhbm.PhbmUpdateVO;
import com.unis.accountability.businessmanagement.common.vo.cityZpbm.CityZpbmPage;
import com.unis.accountability.businessmanagement.common.vo.cityZpbm.CityZpbmPublishVO;
import com.unis.accountability.businessmanagement.common.vo.cityZpbm.ZpbmUpdateVO;
import com.unis.common.utils.ResponseWrapper;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

/**粮食安全省长责任制--州市自评部门审核
 * @Auther:张新亮
 * @Date: 2019/9/21 0021 09:58
 * @Description:
 */
@FeignClient(name = "accountability-service")
@Component
public interface BizRespCityPhbmClient {


    /**
     * 粮食安全行政首长责任制----市级配合部门----分页
     * @param cityPhbmPage
     * @param page
     * @param size
     * @return
     */
    @RequestMapping(method = RequestMethod.POST, value = "/cityPhbm/findByPage/{page}/{size}")
    ResponseWrapper findByPage(@RequestBody CityPhbmPage cityPhbmPage, @PathVariable Integer page, @PathVariable Integer size);

    /**
     * 粮食安全行政首长责任制----市级配合部门----查看
     * @param id
     * @return
     */
    @RequestMapping(method = RequestMethod.GET, value = "/cityPhbm/findById/{id}/{deptId}")
    ResponseWrapper findById(@PathVariable("id") String id,@PathVariable("deptId") String deptId);




    /**
     * 粮食安全行政首长责任制----市级配合部门---编辑
     */
    @RequestMapping(method = RequestMethod.POST, value = "/cityPhbm/update")
    ResponseWrapper update(@RequestBody PhbmUpdateVO phbmUpdateVO);


    /**
     * 粮食安全行政首长责任制----市级配合部门---发布
     */
    @RequestMapping(method = RequestMethod.POST, value = "/cityPhbm/publish")
    ResponseWrapper publish(@RequestBody CityZpbmPublishVO cityZpbmPublishVO);


    /**
     * 粮食安全行政首长责任制----市级配合部门---批量发布
     */
    @RequestMapping(method = RequestMethod.POST, value = "/cityPhbm/publishALL")
    ResponseWrapper publishALL(@RequestBody CityZpbmPublishVO cityZpbmPublishVO);


    /**
     * 粮食安全行政首长责任制----市级配合部门---根据年份部门状态查询明细
     */
    @RequestMapping(method = RequestMethod.POST, value = "/cityPhbm/fidByYearAndDeptIdAndStatus")
    ResponseWrapper fidByYearAndDeptIdAndStatus(@RequestBody CityPhbmPage cityPhbmPage);





}