package com.unis.accountability.businessmanagement.client;

import com.unis.accountability.businessmanagement.common.vo.cityPhbm.CityPhbmPage;
import com.unis.accountability.businessmanagement.common.vo.cityPhbm.PhbmUpdateVO;
import com.unis.accountability.businessmanagement.common.vo.cityQtbm.CityQtbmPage;
import com.unis.accountability.businessmanagement.common.vo.cityQtbm.QtbmUpdateVO;
import com.unis.accountability.businessmanagement.common.vo.cityZpbm.CityZpbmPublishVO;
import com.unis.common.utils.ResponseWrapper;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

/**粮食安全省长责任制--州市自评部门审核
 * @Auther:张新亮
 * @Date: 2019/9/21 0021 09:58
 * @Description:
 */
@FeignClient(name = "accountability-service")
@Component
public interface BizRespCityQtbmClient {


    /**
     * 粮食安全行政首长责任制----市级牵头部门----分页
     * @param cityQtbmPage
     * @param page
     * @param size
     * @return
     */
    @RequestMapping(method = RequestMethod.POST, value = "/cityQtbm/findByPage/{page}/{size}")
    ResponseWrapper findByPage(@RequestBody CityQtbmPage cityQtbmPage, @PathVariable Integer page, @PathVariable Integer size);

    /**
     * 粮食安全行政首长责任制----市级牵头部门----查看
     * @param id
     * @return
     */
    @RequestMapping(method = RequestMethod.GET, value = "/cityQtbm/findById/{id}/{deptId}")
    ResponseWrapper findById(@PathVariable("id") String id, @PathVariable("deptId") String deptId);


    /**
     * 粮食安全行政首长责任制----市级牵头部门----查看
     * @param taskId
     * @return
     */
    @RequestMapping(method = RequestMethod.GET, value = "/cityQtbm/findByTaskIdAndAreaCode/{taskId}/{areaCode}")
    ResponseWrapper findByTaskIdAndAreaCode(@PathVariable("taskId") String taskId,@PathVariable("areaCode") String areaCode);


    /**
     * 粮食安全行政首长责任制----市级牵头部门---编辑
     */
    @RequestMapping(method = RequestMethod.POST, value = "/cityQtbm/update")
    ResponseWrapper update(@RequestBody QtbmUpdateVO qtbmUpdateVO);


    /**
     * 粮食安全行政首长责任制----市级牵头部门---发布
     */
    @RequestMapping(method = RequestMethod.POST, value = "/cityQtbm/publish")
    ResponseWrapper publish(@RequestBody CityZpbmPublishVO cityZpbmPublishVO);


    /**
     * 粮食安全行政首长责任制----市级牵头部门---批量发布
     */
    @RequestMapping(method = RequestMethod.POST, value = "/cityQtbm/publishALL")
    ResponseWrapper publishALL(@RequestBody CityZpbmPublishVO cityZpbmPublishVO);


    /**
     * 粮食安全行政首长责任制----市级牵头部门---根据年份部门状态查询明细
     */
    @RequestMapping(method = RequestMethod.POST, value = "/cityQtbm/fidByYearAndDeptIdAndStatus")
    ResponseWrapper fidByYearAndDeptIdAndStatus(@RequestBody CityQtbmPage cityQtbmPage);





}