package com.unis.accountability.businessmanagement.client;

import com.unis.accountability.businessmanagement.common.vo.cityTaskDistribution.CityTaskPage;
import com.unis.accountability.businessmanagement.common.vo.cityTaskDistribution.CityTaskPublishVO;
import com.unis.accountability.businessmanagement.common.vo.cityTaskDistribution.CityTaskUpdateVO;

import com.unis.common.utils.ResponseWrapper;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

/**粮食安全行政首长责任制----州市任务分配管理
 * @Auther:张新亮
 * @Date: 2019/9/20 0020 15:17
 * @Description:
 */
@FeignClient(name = "accountability-service")
@Component
public interface BizRespCityTaskDistributionClient {



    /**
     * 粮食安全行政首长责任制----州市任务分配管理----分页
     * @param cityTaskPage
     * @param page
     * @param size
     * @return
     */
    @RequestMapping(method = RequestMethod.POST, value = "/cityTaskDistribution/findByPage/{page}/{size}")
    ResponseWrapper findByPage(@RequestBody CityTaskPage cityTaskPage, @PathVariable Integer page, @PathVariable Integer size);

    /**
     * 粮食安全行政首长责任制----州市任务分配管理----查看
     * @param id
     * @return
     */
    @RequestMapping(method = RequestMethod.GET, value = "/cityTaskDistribution/findById/{id}")
    ResponseWrapper findById(@PathVariable("id") String id);




    /**
     * 粮食安全行政首长责任制----州市任务分配管理---编辑
     */
    @RequestMapping(method = RequestMethod.POST, value = "/cityTaskDistribution/update")
    ResponseWrapper update( @RequestBody CityTaskUpdateVO cityTaskUpdateVO);


    /**
     * 粮食安全行政首长责任制----州市任务分配管理---发布
     */
    @RequestMapping(method = RequestMethod.POST, value = "/cityTaskDistribution/publish")
    ResponseWrapper publish( @RequestBody CityTaskPublishVO cityTaskPublishVO);


    /**
     * 粮食安全行政首长责任制----州市任务分配管理---批量发布
     */
    @RequestMapping(method = RequestMethod.POST, value = "/cityTaskDistribution/publishALL")
    ResponseWrapper publishALL( @RequestBody CityTaskPublishVO cityTaskPublishVO);



    /**
     * 粮食安全行政首长责任制----区自评查看（市局）----分页
     * @param cityTaskPage
     * @param page
     * @param size
     * @return
     */
    @RequestMapping(method = RequestMethod.POST, value = "/cityTaskDistribution/findZpCityByPage/{page}/{size}")
    ResponseWrapper findZpCityByPage(@RequestBody CityTaskPage cityTaskPage, @PathVariable Integer page, @PathVariable Integer size);

    /**
     * 粮食安全行政首长责任制----区自评查看（市局）---考核分发
     */
    @RequestMapping(method = RequestMethod.POST, value = "/cityTaskDistribution/publishKhff")
    ResponseWrapper publishKhff( @RequestBody CityTaskPublishVO cityTaskPublishVO);


    /**
     * 粮食安全行政首长责任制----区自评查看（市局）---是否考核分发
     */
    @RequestMapping(method = RequestMethod.POST, value = "/cityTaskDistribution/findByIsKhff")
    ResponseWrapper findByIsKhff( @RequestBody CityTaskPublishVO cityTaskPublishVO);

}