package com.unis.accountability.businessmanagement.client;

import com.unis.accountability.businessmanagement.common.vo.cityFf.CityFfPage;
import com.unis.accountability.businessmanagement.common.vo.cityFf.FfPublishVO;
import com.unis.accountability.businessmanagement.common.vo.cityFf.FfUpdateVO;

import com.unis.common.utils.ResponseWrapper;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

/**
 * @Auther:张新亮
 * @Date: 2019/12/13 0013 15:18
 * @Description:
 */
@FeignClient(name = "accountability-service")
@Component
public interface BizRespCityTaskfFClient {
    /**
     * 粮食安全行政首长责任制----评分表分处室考核（市部门）----分页
     * @param cityFfPage
     * @param page
     * @param size
     * @return
     */
    @RequestMapping(method = RequestMethod.POST, value = "/cityTaskfF/findByPage/{page}/{size}")
    ResponseWrapper findByPage(@RequestBody CityFfPage cityFfPage, @PathVariable Integer page, @PathVariable Integer size);

    /**
     * 粮食安全行政首长责任制----评分表分处室考核（市部门）----查看
     * @param id
     * @return
     */
    @RequestMapping(method = RequestMethod.GET, value = "/cityTaskfF/findById/{id}")
    ResponseWrapper findById(@PathVariable("id") String id);




    /**
     * 粮食安全行政首长责任制----评分表分处室考核（市部门）---编辑
     */
    @RequestMapping(method = RequestMethod.POST, value = "/cityTaskfF/update")
    ResponseWrapper update(@RequestBody FfUpdateVO ffUpdateVO);


    /**
     * 粮食安全行政首长责任制----评分表分处室考核（市部门）---发布
     */
    @RequestMapping(method = RequestMethod.POST, value = "/cityTaskfF/publish")
    ResponseWrapper publish(@RequestBody FfPublishVO ffPublishVO);


    /**
     * 粮食安全行政首长责任制----评分表分处室考核（市部门）---批量发布
     */
    @RequestMapping(method = RequestMethod.POST, value = "/cityTaskfF/publishALL")
    ResponseWrapper publishALL(@RequestBody FfPublishVO ffPublishVO);


    /**
     * 粮食安全行政首长责任制----评分表分处室考核（市部门）---查询是否可以提交数据
     */
    @RequestMapping(method = RequestMethod.POST, value = "/cityTaskfF/findByIsSubmit")
    ResponseWrapper findByIsSubmit(@RequestBody FfPublishVO ffPublishVO);
}