package com.unis.accountability.businessmanagement.client;

import com.unis.accountability.businessmanagement.common.vo.CityPublishVO;
import com.unis.accountability.businessmanagement.common.vo.cityZpbm.CityZpbmPage;
import com.unis.accountability.businessmanagement.common.vo.cityZpbm.CityZpbmPublishVO;
import com.unis.accountability.businessmanagement.common.vo.cityZpbm.ZpbmUpdateVO;
import com.unis.common.utils.ResponseWrapper;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.*;

/**粮食安全省长责任制--州市自评部门审核
 * @Auther:张新亮
 * @Date: 2019/9/21 0021 09:58
 * @Description:
 */
@FeignClient(name = "accountability-service")
@Component
public interface BizRespCityZpbmClient {


    /**
     * 粮食安全行政首长责任制----州市自评部门审核----分页
     * @param cityZpbmPage
     * @param page
     * @param size
     * @return
     */
    @RequestMapping(method = RequestMethod.POST, value = "/cityZpbm/findByPage/{page}/{size}")
    ResponseWrapper findByPage(@RequestBody CityZpbmPage cityZpbmPage, @PathVariable Integer page, @PathVariable Integer size);

    /**
     * 粮食安全行政首长责任制----州市自评部门审核----查看
     * @param id
     * @return
     */
    @RequestMapping(method = RequestMethod.GET, value = "/cityZpbm/findById/{id}")
    ResponseWrapper findById(@PathVariable("id") String id);

    /**
     * 粮食安全行政首长责任制----州市自评部门审核----查看
     * @param id
     * @return
     */
    @RequestMapping(method = RequestMethod.GET, value = "/cityZpbm/findByTaskIdAndAreaCode/{taskId}/{areaCode}")
    ResponseWrapper findByTaskIdAndAreaCode(@PathVariable("taskId") String taskId,@PathVariable("areaCode") String areaCode);


    /**
     * 粮食安全行政首长责任制----州市自评部门审核---编辑
     */
    @RequestMapping(method = RequestMethod.POST, value = "/cityZpbm/update")
    ResponseWrapper update( @RequestBody ZpbmUpdateVO zpbmUpdateVO);


    /**
     * 粮食安全行政首长责任制----州市自评部门审核---发布
     */
    @RequestMapping(method = RequestMethod.POST, value = "/cityZpbm/publish")
    ResponseWrapper publish( @RequestBody CityZpbmPublishVO cityZpbmPublishVO);


    /**
     * 粮食安全行政首长责任制----州市自评部门审核---批量发布
     */
    @RequestMapping(method = RequestMethod.POST, value = "/cityZpbm/publishALL")
    ResponseWrapper publishALL( @RequestBody CityZpbmPublishVO cityZpbmPublishVO);


    /**
     * 粮食安全行政首长责任制----州市自评部门审核---根据年份部门状态查询明细
     */
    @RequestMapping(method = RequestMethod.POST, value = "/cityZpbm/fidByYearAndDeptIdAndStatus")
    ResponseWrapper fidByYearAndDeptIdAndStatus( @RequestBody CityZpbmPage cityZpbmPage);
    /**
     * 粮食安全行政首长责任制----州市自评部门审核---更新状态，用于市评分审核审核
     */
    @PostMapping(value = "/cityZpbm/updateStatus")
    ResponseWrapper updateStatus(
            @RequestBody CityPublishVO cityPublishVO
    );





}