package com.unis.accountability.businessmanagement.client;

import com.unis.accountability.businessmanagement.common.vo.examinationContent.ContentPage;
import com.unis.accountability.businessmanagement.common.vo.examinationContent.ContentSaveVO;
import com.unis.accountability.businessmanagement.common.vo.examinationContent.ContentUpdateVO;
import com.unis.common.utils.ResponseWrapper;
import com.unis.accountability.businessmanagement.common.vo.DeleteVO;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

/**粮食安全行政首长责任制----考核内容
 * @Auther:张新亮
 * @Date: 2019/9/18 0018 15:22
 * @Description:
 */
@FeignClient(name = "accountability-service")
@Component
public interface BizRespExaminationContentClient {

    /**
     * 粮食安全行政首长责任制----考核内容----保存
     */
    @RequestMapping(method = RequestMethod.POST, value = "/examinationContent/save")
    ResponseWrapper save( @RequestBody ContentSaveVO contentSaveVO);



    /**
     * 考核评分表管理---分页查询粮食安全行政首长责任制----考核内容----分页
     * @param contentPage
     * @param page
     * @param size
     * @return
     */
    @RequestMapping(method = RequestMethod.POST, value = "/examinationContent/findByPage/{page}/{size}")
    ResponseWrapper findByPage(@RequestBody ContentPage contentPage, @PathVariable Integer page, @PathVariable Integer size);





    /**
     * 粮食安全行政首长责任制----考核内容----修改
     */
    @RequestMapping(method = RequestMethod.POST, value = "/examinationContent/update")
    ResponseWrapper update( @RequestBody ContentUpdateVO updateVO);



    /**
     * 粮食安全行政首长责任制----考核内容----删除
     */
    @RequestMapping(method = RequestMethod.DELETE, value = "/examinationContent/deletes")
    ResponseWrapper deletes(@RequestBody DeleteVO deleteVO);

    /**
     *  粮食安全行政首长责任制----考核内容----根据年份year和组织机构查询好喝内容
     * @param deptId
     * @return
     */
    @RequestMapping(method = RequestMethod.GET, value = "/examinationContent/findByYearAndOrgId/{year}/{responsibilityId}/{orgId}")
    ResponseWrapper findByYearAndOrgId(@PathVariable("year") String year,@PathVariable("responsibilityId") String responsibilityId,@PathVariable("orgId") String orgId);


}