package com.unis.accountability.businessmanagement.client;

import com.unis.accountability.businessmanagement.common.vo.examinationExcel.AreeExcelVO;
import com.unis.accountability.businessmanagement.common.vo.examinationExcel.BizRespExcelSaveNewVO;
import com.unis.common.utils.ResponseWrapper;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

/**
 * @Auther:张新亮
 * @Date: 2019/9/25 0025 14:58
 * @Description:
 */
@FeignClient(name = "accountability-service")
@Component
public interface BizRespExaminationExcelClient {

    /**
     * 粮食安全行政首长责任制--省级任务考查询(省考核办)---州市评分表导出
     * @param shiAreaCode
     * @return
     */
    @RequestMapping(method = RequestMethod.GET, value = "/examinationExcel/exportCityExcel/{year}/{shiAreaCode}/{bizRespResponsibilityId}")
    ResponseWrapper exportCityExcel(@PathVariable("year") String year,@PathVariable("shiAreaCode") String shiAreaCode,@PathVariable("bizRespResponsibilityId") String bizRespResponsibilityId);


    /**
     * 粮食安全行政首长责任制----考核评分表管理----导入评分表
     */
    @RequestMapping(method = RequestMethod.POST, value = "/examinationExcel/saveExcleData")
    ResponseWrapper saveExcleData(@RequestBody BizRespExcelSaveNewVO bizRespExcelSaveVO);

    /**
     * 粮食安全行政首长责任制----考核评分表管理----导出评分表
     * @return
     */
    @RequestMapping(method = RequestMethod.GET, value = "/examinationExcel/exportKhpfbExcel/{bizRespResponsibilityId}")
    ResponseWrapper exportKhpfbExcel(@PathVariable("bizRespResponsibilityId") String bizRespResponsibilityId);

    /**
     * 粮食安全行政首长责任制----考核评分表管理----导出评分表
     * @return
     */
    @RequestMapping(method = RequestMethod.GET, value = "/examinationExcel/exportAreaExcel")
    ResponseWrapper exportAreaExcel(@RequestBody AreeExcelVO areeExcelVO);

}