package com.unis.accountability.businessmanagement.client;

import com.unis.common.utils.ResponseWrapper;
import com.unis.accountability.businessmanagement.common.vo.DeleteVO;
import com.unis.accountability.businessmanagement.common.vo.examinationItem.ItemPage;
import com.unis.accountability.businessmanagement.common.vo.examinationItem.ItemSaveVO;
import com.unis.accountability.businessmanagement.common.vo.examinationItem.ItemUpdateVO;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

/**粮食安全行政首长责任制----考核事项
 * @Auther:张新亮
 * @Date: 2019/9/18 0018 16:11
 * @Description:
 */
@FeignClient(name = "accountability-service")
@Component
public interface BizRespExaminationItemClient {
    /**
     * 粮食安全行政首长责任制----考核事项----保存
     */
    @RequestMapping(method = RequestMethod.POST, value = "/examinationItem/save")
    ResponseWrapper save( @RequestBody ItemSaveVO itemSaveVO);



    /**
     * 考核评分表管理---分页查询粮食安全行政首长责任制----考核事项----分页
     * @param itemPage
     * @param page
     * @param size
     * @return
     */
    @RequestMapping(method = RequestMethod.POST, value = "/examinationItem/findByPage/{page}/{size}")
    ResponseWrapper findByPage(@RequestBody ItemPage itemPage, @PathVariable Integer page, @PathVariable Integer size);





    /**
     * 粮食安全行政首长责任制----考核事项----修改
     */
    @RequestMapping(method = RequestMethod.POST, value = "/examinationItem/update")
    ResponseWrapper update( @RequestBody ItemUpdateVO itemUpdateVO);



    /**
     * 粮食安全行政首长责任制----考核事项----删除
     */
    @RequestMapping(method = RequestMethod.DELETE, value = "/examinationItem/deletes")
    ResponseWrapper deletes(@RequestBody DeleteVO deleteVO);

    /**
     *  粮食安全行政首长责任制----考核事项----根据年份year和组织机构查询好喝内容
     * @param orgId
     * @return
     */
    @RequestMapping(method = RequestMethod.GET, value = "/examinationItem/findByYearAndOrgId/{year}/{responsibilityId}/{orgId}")
    ResponseWrapper findByYearAndOrgId(@PathVariable("year") String year,@PathVariable("responsibilityId") String responsibilityId,@PathVariable("orgId") String orgId);

}