package com.unis.accountability.businessmanagement.client;

import com.unis.common.utils.ResponseWrapper;
import com.unis.accountability.businessmanagement.common.vo.DeleteVO;
import com.unis.accountability.businessmanagement.common.vo.examinationQuota.QuotaSaveVO;
import com.unis.accountability.businessmanagement.common.vo.examinationQuota.QuotaUPdateVO;
import com.unis.accountability.businessmanagement.common.vo.examinationQuota.QutoaPage;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

/**粮食安全行政首长责任制----考核指标
 * @Auther:张新亮
 * @Date: 2019/9/18 0018 16:59
 * @Description:
 */
@FeignClient(name = "accountability-service")
@Component
public interface BizRespExaminationQuotaClient {
    /**
     * 粮食安全行政首长责任制----考核指标----保存
     */
    @RequestMapping(method = RequestMethod.POST, value = "/examinationQuota/save")
    ResponseWrapper save( @RequestBody QuotaSaveVO quotaSaveVO);



    /**
     * 考核评分表管理---分页查询粮食安全行政首长责任制----考核指标----分页
     * @param qutoaPage
     * @param page
     * @param size
     * @return
     */
    @RequestMapping(method = RequestMethod.POST, value = "/examinationQuota/findByPage/{page}/{size}")
    ResponseWrapper findByPage(@RequestBody QutoaPage qutoaPage, @PathVariable Integer page, @PathVariable Integer size);





    /**
     * 粮食安全行政首长责任制----考核指标----修改
     */
    @RequestMapping(method = RequestMethod.POST, value = "/examinationQuota/update")
    ResponseWrapper update( @RequestBody QuotaUPdateVO quotaUPdateVO);



    /**
     * 粮食安全行政首长责任制----考核指标----删除
     */
    @RequestMapping(method = RequestMethod.DELETE, value = "/examinationQuota/deletes")
    ResponseWrapper deletes(@RequestBody DeleteVO deleteVO);

    /**
     *  粮食安全行政首长责任制----考核指标----根据年份year和组织机构查询好喝内容
     * @param deptId
     * @return
     */
    @RequestMapping(method = RequestMethod.GET, value = "/examinationQuota/findByYearAndOrgId/{year}/{responsibilityId}/{orgId}")
    ResponseWrapper findByYearAndOrgId(@PathVariable("year") String year,@PathVariable("responsibilityId") String responsibilityId,@PathVariable("orgId") String orgId);

}