package com.unis.accountability.businessmanagement.client;

import com.unis.accountability.businessmanagement.common.vo.cityPhbm.CityPhbmPage;
import com.unis.accountability.businessmanagement.common.vo.cityPhbm.PhbmUpdateVO;
import com.unis.accountability.businessmanagement.common.vo.cityZpbm.CityZpbmPublishVO;
import com.unis.accountability.businessmanagement.common.vo.provincePhbm.ProvincePhbmPage;
import com.unis.accountability.businessmanagement.common.vo.provincePhbm.ProvincePhbmPublishVO;
import com.unis.common.utils.ResponseWrapper;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

/**粮食安全省长责任制--省级配合部门
 * @Auther:张新亮
 * @Date: 2019/9/21 0021 09:58
 * @Description:
 */
@FeignClient(name = "accountability-service")
@Component
public interface BizRespProvincePhbmClient {


    /**
     * 粮食安全行政首长责任制----省级配合部门----分页
     * @param provincePhbmPage
     * @param page
     * @param size
     * @return
     */
    @RequestMapping(method = RequestMethod.POST, value = "/provincePhbm/findByPage/{page}/{size}")
    ResponseWrapper findByPage(@RequestBody ProvincePhbmPage provincePhbmPage, @PathVariable Integer page, @PathVariable Integer size);

    /**
     * 粮食安全行政首长责任制----省级配合部门----查看
     * @param opId
     * @return
     */
    @RequestMapping(method = RequestMethod.GET, value = "/provincePhbm/findById/{id}")
    ResponseWrapper findById(@PathVariable("id") String opId);




    /**
     * 粮食安全行政首长责任制----省级配合部门---编辑
     */
    @RequestMapping(method = RequestMethod.POST, value = "/provincePhbm/update")
    ResponseWrapper update(@RequestBody PhbmUpdateVO phbmUpdateVO);


    /**
     * 粮食安全行政首长责任制----省级配合部门---发布
     */
    @RequestMapping(method = RequestMethod.POST, value = "/provincePhbm/publish")
    ResponseWrapper publish(@RequestBody ProvincePhbmPublishVO provincePhbmPublishVO);


    /**
     * 粮食安全行政首长责任制----省级配合部门---批量发布
     */
    @RequestMapping(method = RequestMethod.POST, value = "/provincePhbm/publishALL")
    ResponseWrapper publishALL(@RequestBody ProvincePhbmPublishVO provincePhbmPublishVO);







}