package com.unis.accountability.businessmanagement.client;

import com.unis.accountability.businessmanagement.common.vo.cityPhbm.PhbmUpdateVO;
import com.unis.accountability.businessmanagement.common.vo.cityQtbm.QtbmUpdateVO;
import com.unis.accountability.businessmanagement.common.vo.provincePhbm.ProvincePhbmPage;
import com.unis.accountability.businessmanagement.common.vo.provincePhbm.ProvincePhbmPublishVO;
import com.unis.common.utils.ResponseWrapper;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

/**粮食安全省长责任制--省级牵头部门
 * @Auther:张新亮
 * @Date: 2019/9/21 0021 09:58
 * @Description:
 */
@FeignClient(name = "accountability-service")
@Component
public interface BizRespProvinceQtbmClient {


    /**
     * 粮食安全行政首长责任制----省级牵头部门----分页
     * @param provincePhbmPage
     * @param page
     * @param size
     * @return
     */
    @RequestMapping(method = RequestMethod.POST, value = "/provinceQtbm/findByPage/{page}/{size}")
    ResponseWrapper findByPage(@RequestBody ProvincePhbmPage provincePhbmPage, @PathVariable Integer page, @PathVariable Integer size);

    /**
     * 粮食安全行政首长责任制----省级牵头部门----查看
     * @param opId
     * @return
     */
    @RequestMapping(method = RequestMethod.GET, value = "/provinceQtbm/findById/{id}")
    ResponseWrapper findById(@PathVariable("id") String opId);


    /**
     * 粮食安全行政首长责任制----省级牵头部门----查看配合部门明细
     * @param taskId
     * @param type
     * @return
     */
    @RequestMapping(method = RequestMethod.GET, value = "/provinceQtbm/findByPhbmList/{taskId}/{type}")
    ResponseWrapper findByPhbmList(@PathVariable("taskId") String taskId,@PathVariable("type") String type);

    /**
     * 粮食安全行政首长责任制----省级牵头部门----查看配合部门明细
     * @param taskId
     * @param type
     * @return
     */
    @RequestMapping(method = RequestMethod.GET, value = "/provinceQtbm/selectByEntity/{id}/{type}/{areacode}")
    ResponseWrapper selectByEntity(@PathVariable("id") String id,@PathVariable("type") String type,@PathVariable("areacode") String areacode);

    /**
     * 粮食安全行政首长责任制----省级牵头部门---编辑
     */
    @RequestMapping(method = RequestMethod.POST, value = "/provinceQtbm/update")
    ResponseWrapper update(@RequestBody QtbmUpdateVO qtbmUpdateVO);


    /**
     * 粮食安全行政首长责任制----省级牵头部门---发布
     */
    @RequestMapping(method = RequestMethod.POST, value = "/provinceQtbm/publish")
    ResponseWrapper publish(@RequestBody ProvincePhbmPublishVO provincePhbmPublishVO);


    /**
     * 粮食安全行政首长责任制----省级牵头部门---批量发布
     */
    @RequestMapping(method = RequestMethod.POST, value = "/provinceQtbm/publishALL")
    ResponseWrapper publishALL(@RequestBody ProvincePhbmPublishVO provincePhbmPublishVO);







}