package com.unis.accountability.businessmanagement.client;

import com.unis.accountability.businessmanagement.common.vo.cityPhbm.CityPhbmPage;
import com.unis.accountability.businessmanagement.common.vo.provinceTask.ProvinceCityTaskPage;
import com.unis.accountability.businessmanagement.common.vo.provinceTask.ProvinceTaskPage;
import com.unis.accountability.businessmanagement.common.vo.scoringWeight.BizRespScoringWeightPublishVO;
import com.unis.common.utils.ResponseWrapper;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

import java.util.List;

/**粮食安全省长责任制--省级任务考查询(省考核办)
 * @Auther:张新亮
 * @Date: 2019/9/23 0023 17:28
 * @Description:
 */
@FeignClient(name = "accountability-service")
@Component
public interface BizRespProvinceTaskClient {
    /**
     * 粮食安全行政首长责任制----省级任务考查询(省考核办)----分页
     * @param provinceTaskPage
     * @param page
     * @param size
     * @return
     */
    @RequestMapping(method = RequestMethod.POST, value = "/provinceTask/findByPage/{page}/{size}")
    ResponseWrapper findByPage(@RequestBody ProvinceTaskPage provinceTaskPage, @PathVariable Integer page, @PathVariable Integer size);

    /**
     * 粮食安全行政首长责任制----省级任务考查询(省考核办)----州市考核明细
     * @param provinceCityTaskPage
     * @param page
     * @param size
     * @return
     */
    @RequestMapping(method = RequestMethod.POST, value = "/provinceTask/findCityByPage/{page}/{size}")
    ResponseWrapper findCityByPage(@RequestBody ProvinceCityTaskPage provinceCityTaskPage, @PathVariable Integer page, @PathVariable Integer size);

    /**
     * 粮食安全行政首长责任制----结果汇总查看（市局)----分页
     * @param provinceTaskPage
     * @param page
     * @param size
     * @return
     */
    @RequestMapping(method = RequestMethod.POST, value = "/provinceTask/findByHzPage/{page}/{size}")
    ResponseWrapper findByHzPage(@RequestBody ProvinceTaskPage provinceTaskPage, @PathVariable Integer page, @PathVariable Integer size);



    /**
     * 粮食安全行政首长责任制----省级任务考查询(省考核办)---驳回
     * @param shiAreaCode
     * @return
     */
    @RequestMapping(method = RequestMethod.GET, value = "/provinceTask/saveReappraisal/{taskId}/{shiAreaCode}")
    ResponseWrapper saveReappraisal(@PathVariable("taskId") String taskId,@PathVariable("shiAreaCode") String shiAreaCode);

    /**
     * 粮食安全行政首长责任制----省级任务考查询(省考核办)---省级配合部门和牵头部门评价明细
     * @param shiAreaCode
     * @return
     */
    @RequestMapping(method = RequestMethod.GET, value = "/provinceTask/findByProvinceQtbmAndPhbm/{taskId}/{shiAreaCode}")
    ResponseWrapper findByProvinceQtbmAndPhbm(@PathVariable("taskId") String taskId,@PathVariable("shiAreaCode") String shiAreaCode);

    /**
     * 粮食安全行政首长责任制----省级任务考查询(省考核办)---提交
     */
    @RequestMapping(method = RequestMethod.POST, value = "/provinceTask/publish")
    ResponseWrapper publish(@RequestBody ProvinceCityTaskPage provinceCityTaskPage);


    /**
     * 粮食安全行政首长责任制----考核结果查看（市局)---抽查分发
     */
    @RequestMapping(method = RequestMethod.POST, value = "/provinceTask/publishCcFf")
    ResponseWrapper publishCcFf(@RequestBody List<ProvinceCityTaskPage> provinceCityTaskPage);


}