package com.unis.accountability.businessmanagement.client;

import com.unis.accountability.businessmanagement.common.vo.DeleteVO;
import com.unis.accountability.businessmanagement.common.vo.responsibility.*;
import com.unis.common.utils.ResponseWrapper;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

/**粮食安全行政首长责任制-----考核评分表管理
 * @Auther:张新亮
 * @Date: 2019/9/18 0018 11:16
 * @Description:
 */
@FeignClient(name = "accountability-service")
@Component
public interface BizRespResponsibilityClient {

    /**
     * 考核评分表管理---分页查询
     * @param pageVO
     * @param page
     * @param size
     * @return
     */
    @RequestMapping(method = RequestMethod.POST, value = "/responsibility/findByPage/{page}/{size}")
    ResponseWrapper findByPage(@RequestBody BizRespResponsibilityPageVO pageVO, @PathVariable Integer page, @PathVariable Integer size);



    /**
     * 考核评分表管理----根据评分表名称和年分查询数据是否存在
     */
    @RequestMapping(method = RequestMethod.POST, value = "/responsibility/findByPfbmc")
    ResponseWrapper findByPfbmc( @RequestBody BizRespResponsibilityPfbmcVO pfbmcVO);

    /**
     * 考核评分表管理----保存
     */
    @RequestMapping(method = RequestMethod.POST, value = "/responsibility/save")
    ResponseWrapper save( @RequestBody BilitySaveVO bilitySaveVO);

    /**
     * 考核评分表管理----编辑修改评分表名称
     */
    @RequestMapping(method = RequestMethod.POST, value = "/responsibility/update")
    ResponseWrapper update( @RequestBody BilityUpdateVO bilityUpdateVO);

    /**
     *  考核评分表管理------根据id查询明细
     * @param id
     * @return
     */
    @RequestMapping(method = RequestMethod.GET, value = "/responsibility/findById/{year}/{id}/{orgId}")
    ResponseWrapper findById(@PathVariable("year") String year,@PathVariable("id") String id,@PathVariable("orgId") String orgId);


    /**
     *  考核评分表管理------根据id查询明细
     * @param id
     * @return
     */
    @RequestMapping(method = RequestMethod.GET, value = "/responsibility/findByIds/{id}")
    ResponseWrapper findByIds(@PathVariable("id") String id);





    /**
     *  核评分表管理------根据ID查询基本信息
     * @param id
     * @return
     */
    @RequestMapping(method = RequestMethod.GET, value = "/responsibility/findByInfo/{id}")
    ResponseWrapper findByInfo(@PathVariable("id") String id);


    /**
     * 考核评分表管理---删除
     */
    @RequestMapping(method = RequestMethod.DELETE, value = "/responsibility/deletes")
    ResponseWrapper deletes(@RequestBody DeleteVO deleteVO);



    /**
     * 考核评分表管理---发布
     */
    @RequestMapping(method = RequestMethod.POST, value = "/responsibility/publish")
    ResponseWrapper publish( @RequestBody BizRespResponsibilitPublishVO publishVO);

    /**
     * 考核评分表管理---下级州市
     */
    @RequestMapping(method = RequestMethod.POST, value = "/responsibility/findByRespResponsibilityCity")
    ResponseWrapper findByRespResponsibilityCity( @RequestBody BizRespResponsibilityCityVO cityVO);

    /**
     * 考核评分表管理---发布
     */
    @RequestMapping(method = RequestMethod.POST, value = "/responsibility/updatePfb")
    ResponseWrapper updatePfb( @RequestBody BizRespResponsibilityUpdateVO updateVO);

    /**
     * 粮食安全行政首长责任制----考核评分表管理---下发评表明细----修改
     */
    @RequestMapping(method = RequestMethod.POST, value = "/responsibility/findByRespResponsibilityInfo")
    ResponseWrapper findByRespResponsibilityInfo( @RequestBody BizRespResponsibilityPageVO bizRespResponsibilityPageVO);

    /**
     * 粮食安全行政首长责任制----考核评分表管理----复制评分表----保存
     */
    @RequestMapping(method = RequestMethod.POST, value = "/responsibility/saveCopyPfb")
    ResponseWrapper saveCopyPfb( @RequestBody BizRespCopyPfbVO bizRespCopyPfbVO);



    /**
     *   考核评分表管理------根据年分查询基本信息
     * @param year
     * @return
     */
    @RequestMapping(method = RequestMethod.GET, value = "/responsibility/findByYear/{year}")
    ResponseWrapper findByYear(@PathVariable("year") String year);

}