package com.unis.accountability.businessmanagement.client;



import com.unis.accountability.businessmanagement.common.vo.cityQtbm.CityQtbmPage;
import com.unis.accountability.businessmanagement.common.vo.cityTaskDistribution.CityTaskPublishVO;
import com.unis.accountability.businessmanagement.common.vo.examinationTask.BizRespExaminationTaskVO;
import com.unis.accountability.businessmanagement.common.vo.provinceTask.ProvinceTaskPage;
import com.unis.accountability.businessmanagement.common.vo.respScoreInput.BizRespScoreInputSmiitVO;
import com.unis.accountability.businessmanagement.common.vo.responsibility.BizRespResponsibilityPageVO;
import com.unis.common.utils.ResponseWrapper;
import com.unis.accountability.businessmanagement.common.vo.respScoreInput.BizRespRespScoreInputPublishVO;
import io.swagger.annotations.ApiOperation;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.*;

/**粮食安全首长责任制--下发州市考核任务
 * @Auther:张新亮
 * @Date: 2019/9/18 0018 11:16
 * @Description:
 */
@FeignClient(name = "accountability-service")
@Component
public interface BizRespScoreInputClient {
    /**
     * 考核评分表管理---发布
     */
    @RequestMapping(method = RequestMethod.POST, value = "/respScoreInput/publish")
    ResponseWrapper publish(@RequestBody BizRespRespScoreInputPublishVO inputPublishVO);


    /**
     * 粮食安全首长责任制--州市考核任务管理  根据年分 状态 行政区划 查询 州市考核录入数据
     */
    @RequestMapping(method = RequestMethod.POST, value = "/respScoreInput/findByYearAndStatusAndAreaCode")
    ResponseWrapper findByYearAndStatusAndAreaCode(@RequestBody CityTaskPublishVO cityTaskPublishVO);


    /**
     * 粮食安全首长责任制--下发州市考核任务----制定州市考核任务--- 分页查询
     *
     * @param bizRespResponsibilityPageVO
     * @param page
     * @param size
     * @return
     */
    @RequestMapping(method = RequestMethod.POST, value = "/respScoreInput/findTaskByPage/{page}/{size}")
    ResponseWrapper findTaskByPage(@RequestBody BizRespResponsibilityPageVO bizRespResponsibilityPageVO, @PathVariable Integer page, @PathVariable Integer size);


    /**
     * 州市、外部单位牵头部门、配合部门评分--查询是否可以提交数据
     */
    @RequestMapping(method = RequestMethod.POST, value = "/respScoreInput/findByIsSubmit")
    ResponseWrapper findByIsSubmit(@RequestBody BizRespScoreInputSmiitVO bizRespScoreInputSmiitVO);

    @ApiOperation(value = "粮食安全首长责任制--结果汇总查看----发布", notes = "参数：")
    @PostMapping(value = "/respScoreInput/publishByArea")
    ResponseWrapper publishByArea(
            @RequestBody ProvinceTaskPage provinceTaskPage
    );

    @ApiOperation(value = "区考核部门查询", notes = "参数：inputId")
    @GetMapping(value = "/respScoreInput/{id}")
    ResponseWrapper findByInputId(
            @PathVariable("id") String id
    );
}