package com.unis.accountability.businessmanagement.client;

import com.unis.common.utils.ResponseWrapper;
import com.unis.accountability.businessmanagement.common.vo.scoringCity.BizRespScoringCityPublishVO;
import com.unis.accountability.businessmanagement.common.vo.scoringCity.ScoringCityUpdateVO;
import com.unis.accountability.businessmanagement.common.vo.scoringCity.ScoringPage;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

/**粮食安全首长责任制---州市任务填报设置
 * @Auther:张新亮
 * @Date: 2019/9/18 0018 11:16
 * @Description:
 */
@FeignClient(name = "accountability-service")
@Component
public interface BizRespScoringCityClient {

    /**
     * 粮食安全首长责任制--州市任务填报设置----分页
     * @param scoringPage
     * @param page
     * @param size
     * @return
     */
    @RequestMapping(method = RequestMethod.POST, value = "/scoringCity/findByPage/{page}/{size}")
    ResponseWrapper findByPage(@RequestBody ScoringPage scoringPage, @PathVariable Integer page, @PathVariable Integer size);


    /**
     * 粮食安全首长责任制--州市任务填报设置----查看
     * @param id
     * @return
     */
    @RequestMapping(method = RequestMethod.GET, value = "/scoringCity/findByYearAndOrgId/{year}/{orgId}")
    ResponseWrapper findByYearAndOrgId(@PathVariable("year") String year,@PathVariable("orgId") String orgId);

    /**
     * 粮食安全首长责任制--州市任务填报设置----查看
     * @param id
     * @return
     */
    @RequestMapping(method = RequestMethod.GET, value = "/scoringCity/findById/{id}")
    ResponseWrapper findById(@PathVariable("id") String id);


    /**
     * 粮食安全首长责任制--州市任务填报设置---编辑
     */
    @RequestMapping(method = RequestMethod.POST, value = "/scoringCity/update")
    ResponseWrapper update( @RequestBody ScoringCityUpdateVO scoringCityUpdateVO);

    /**
     * 粮食安全首长责任制--州市考核任务管理----发布
     */
    @RequestMapping(method = RequestMethod.POST, value = "/scoringCity/publish")
    ResponseWrapper publish(@RequestBody BizRespScoringCityPublishVO publishVO);

    /**
     * 粮食安全首长责任制--州市任务填报设置----根据年分和状态---考核评分权重--对象
     * @param id
     * @return
     */
    @RequestMapping(method = RequestMethod.GET, value = "/scoringCity/findByYearAndStatus/{year}/{status}/{areaCode}")
    ResponseWrapper findByYearAndStatus(@PathVariable("year") String year,@PathVariable("status") String status,@PathVariable("areaCode") String areaCode);




}