package com.unis.accountability.businessmanagement.client;


import java.util.List;

import javax.servlet.http.HttpServletResponse;

import com.unis.accountability.businessmanagement.common.vo.manageRuler.MangerRulesReceviceVO;
import com.unis.accountability.businessmanagement.common.vo.manageRuler.MangerRulesVO;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;
import com.unis.common.utils.ResponseWrapper;


@FeignClient(name = "accountability-service")
@Component
public interface MangerRulesApi {

	//新增
	@PostMapping("/MaterialManagement/save")
	public  ResponseWrapper insert(@RequestBody MangerRulesVO vo);
	
	
	//编辑
	@PostMapping("/MaterialManagement/update")
	public  ResponseWrapper update(@RequestBody MangerRulesVO vo);
	
	
	//下发文件
	@PostMapping("/MaterialManagement/issue")
	public  ResponseWrapper issue(@RequestBody MangerRulesReceviceVO vo);
	
	
	
	//下载
	@PostMapping("/MaterialManagement/downLoad/{realPath}")
	public  ResponseWrapper downLoad(HttpServletResponse response, @PathVariable("realPath") String realPath);
	
	
	//删除
	@GetMapping("/MaterialManagement/delete/{zdbm}")
	public  ResponseWrapper delete(@PathVariable("zdbm") String zdbm);
	
	
	
	//查看
	@GetMapping("/MaterialManagement/getInformation/{zdbm}")
	public  ResponseWrapper getInformation(@PathVariable("zdbm") String zdbm);
	
	
	//获取列表
	@PostMapping("/MaterialManagement/selectList")
	public ResponseWrapper selectList(@RequestParam(value = "pageNum", defaultValue = "1") int pageNum,
                                      @RequestParam(value = "pageSize", defaultValue = "10") int pageSize,
                                      @RequestParam(value = "wjmc", required = false) String wjmc,
                                      @RequestParam(value = "scrq", required = false) String scrq,
									  @RequestParam(value = "orgId", required = false) String orgId,
                                      @RequestBody List<String> orgCode);
	
	 /**
	  * 
	      * @Title: getJsbmByzdbm
	      * @Description: 根据zdbm获取接收部门编码
	      * @param @param zdbm
	      * @param @return 参数
	      * @return ResponseWrapper 返回类型
	      * @throws
	  */
	
	 @GetMapping("/MaterialManagement/getJsbm/{zdbm}")
	 public ResponseWrapper getJsbmByzdbm(@RequestParam("zdbm") String zdbm);
	
}
