package com.unis.accountability.businessmanagement.client;

import com.unis.accountability.businessmanagement.common.vo.DeleteVO;
import com.unis.accountability.businessmanagement.common.vo.cityPhbm.CityPhbmPage;
import com.unis.accountability.businessmanagement.common.vo.cityQtbm.QtbmUpdateVO;
import com.unis.accountability.businessmanagement.common.vo.msgNotice.*;
import com.unis.common.utils.ResponseWrapper;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;

/** 信息报送、资料下载
 * @Auther:张新亮
 * @Date: 2019/11/5 0005 15:00
 * @Description:
 */
@FeignClient(name = "accountability-service")
@Component
public interface MsgNoticeClient {

    /**
     *  信息报送、资料下载----保存
     */
    @RequestMapping(method = RequestMethod.POST, value = "/msgNotice/save")
    ResponseWrapper save( @RequestBody MsgNoticeSaveVO msgNoticeSaveVO);

    /**
     * 信息报送---报送
     */
    @RequestMapping(method = RequestMethod.POST, value = "/msgNotice/publish")
    ResponseWrapper publish( @RequestBody MsgNoticePublishVO publishVO);

    /**
     * 信息报送---批量采用
     */
    @RequestMapping(method = RequestMethod.POST, value = "/msgNotice/publishALL")
    ResponseWrapper publishALL( @RequestBody MsgNoticePublishVO publishVO);

    /**
     * 信息报送----查看
     * @return
     */
    @RequestMapping(method = RequestMethod.POST, value = "/msgNotice/findById/{id}")
    ResponseWrapper findById(@PathVariable("id") String  id);


    /**
     * 信息报送----查看
     * @return
     */
    @RequestMapping(method = RequestMethod.GET, value = "/msgNotice/findByInfo/{id}")
    ResponseWrapper findByInfo(@PathVariable("id") String  id);



    /**
     * 信息报送----分页
     * @param msgNoticePage
     * @param page
     * @param size
     * @return
     */
    @RequestMapping(method = RequestMethod.POST, value = "/msgNotice/findByPage/{page}/{size}")
    ResponseWrapper findByPage(@RequestBody MsgNoticePage msgNoticePage, @PathVariable Integer page, @PathVariable Integer size);


    /**
     * 信息报送----修改
     */
    @RequestMapping(method = RequestMethod.POST, value = "/msgNotice/update")
    ResponseWrapper update(@RequestBody MsgNoticeUpdateVO msgNoticeUpdateVO);

    /**
     * 信息报送---删除
     */
    @RequestMapping(method = RequestMethod.DELETE, value = "/msgNotice/deletes")
    ResponseWrapper deletes(@RequestBody DeleteVO deleteVO);






}