package com.unis.accountability.businessmanagement.common.vo;

import java.io.Serializable;
import java.util.Date;



import lombok.Getter;
import lombok.Setter;

import com.unis.common.utils.UUIDUtils;


/**
 * 基础实体类
 * 所有继承该实体类的实体在映射成表的时候会自动加入该类中的字段
 *
 * @author Garfield
 */
/**
 * @ClassName BaseEntity
 * @Description 基础实体类，所有继承该实体类的实体在映射成表的时候会自动加入该类中的字段
 * @Author tiechanglongd
 * @Date 2019/7/22 17:07
 * @Version 0.0.3
 **/
@Getter
@Setter
public  class BaseVO {

    /**
     * 创建人id
     */
    private String createBy;


    /**
     * 修改人
     */
    private String updateBy;


    /**
     * 删除人
     */

    private String deleteBy;

    /**
     * 组织机构id
     */

    private String orgId;

    /**
     * 部门ID
     */

    private String deptId;

    /**
     * 行政区划
     */
    private String areaCode;

    private Date updateTime;

    private Date deleteTime;

    private Date createTime;


}
