package com.unis.accountability.businessmanagement.common.vo.examinationExcel;

import org.apache.commons.lang.StringUtils;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Auther:张新亮
 * @Date: 2019/9/24 0024 17:43
 * @Description:
 */
public class BizRespExcelVO {


    /**
     * 粮食安全行政首长责任制----考核评分表管理----导入评分表
     * 较验第一行数据是否为省长责任制要导入的标提数据
     *
     * @param list
     * @return
     */
    public static boolean getCheckMainData(List<String> list,List<String> list2) {
        String result1="no";
        String result2="no";
        //考核内容
        String khnr = list.get(0).trim().replaceAll("\r|\n", "");
        //重点考核事项
        String khsx = list.get(1).trim().replaceAll("\r|\n", "");
        //考核指标
        String khzb = list.get(2).trim().replaceAll("\r|\n", "");
        //分值
        String fz = list.get(3).trim().replaceAll("\r|\n", "");
        //评分标准
        String pfbz = list.get(5).trim().replaceAll("\r|\n", "");
        //评分依据
        String pfyj = list.get(6).trim().replaceAll("\r|\n", "");
        //考核方式
        String khfs = list.get(7).trim().replaceAll("\r|\n", "");
        //考核部门
        String khbm = list.get(8).trim().replaceAll("\r|\n", "");

        if (khnr.equals("考核内容") && khsx.equals("重点考核事项") &&
                khzb.equals("考核指标") && fz.equals("分值")
                 && pfbz.equals("评分标准") && pfbz.equals("评分标准") && pfyj.equals("评分依据")
                 && khfs.equals("考核方式") && khbm.equals("考核部门")
                ) {
            result1="yes";
        }



        //农业
        String ny = list2.get(3).trim().replaceAll("\r|\n", "");
        //非农业
        String fny = list2.get(4).trim().replaceAll("\r|\n", "");
        //牵头部门
        String qtbm = list2.get(8).trim().replaceAll("\r|\n", "");
        //配合部门(单位)
        String phbm = list2.get(9).trim().replaceAll("\r|\n", "");

        if (ny.equals("农业") && fny.equals("非农业") &&
                qtbm.equals("牵头部门") && phbm.equals("配合部门(单位)")
                ) {
            result2="yes";
        }

        if(result2.equals("yes") && result1.equals("yes")){
            return true;
        }
        return false;
    }



    /**
     * 整理导入省长责任制的数据
     * @param list
     * @return
     */
    public static Map getCheckExcelData(
            List<List<String>> list,
            List<BizRespExaminationContentExcelVO> excelVOList,
            List<Map> bmList
    ) {
        //考核内容集合
        List<BizRespExaminationContentExcelVO> contentExcelVOList=new ArrayList();
        Map result=new HashMap();
        for(int i=3;i<list.size();i++){
            //考核内容
            BizRespExaminationContentExcelVO contentExcelVO= getContent(list.get(i), contentExcelVOList);
            if(contentExcelVO.getResult().equals("2")){
                result.put("result","2");
                result.put("mes",contentExcelVO.getMes());
                return result;
            }
            //重点考核事项
            result= getItem(list.get(i), contentExcelVO);
            String item=result.get("result").toString();
            if(item.equals("2")){
                return result;
            }
            //考核指标
            result=getQutoa(list.get(i), contentExcelVO);
            String qutoa=result.get("result").toString();
            if(qutoa.equals("2")){
                return result;
            }

            //年度考核目标任务
           // result=getTask(list.get(i), contentExcelVO,bmList);
            String resu=result.get("result").toString();
            if(resu.equals("2")){
                return result;
            }
        }
        System.out.println("考核内容集合:" + contentExcelVOList);
        excelVOList.addAll(contentExcelVOList);
        return result;

    }



    /**
     * 考核内容
     * @param list
     * @return
     */
    public static BizRespExaminationContentExcelVO getContent(
            List<String> list,
            List<BizRespExaminationContentExcelVO> contentExcelVOList
    ) {
        //考核内容
        String name=list.get(0).toString();
        //考核内容分值
        if(name.equals("NULL")){
            Integer contentIndex=contentExcelVOList.size()-1;
            if(contentIndex==-1){
                return null;
            }
            BizRespExaminationContentExcelVO contentExcelVO=contentExcelVOList.get(contentIndex);
            contentExcelVO.setResult("1");
            return contentExcelVO;
        }else{
            BizRespExaminationContentExcelVO contentExcelVO=new BizRespExaminationContentExcelVO();
            if(name.equals("NULL")){
                contentExcelVO.setResult("2");
                contentExcelVO.setMes("考核内容不能为空!");
            }else{
                contentExcelVO.setResult("1");
                contentExcelVO.setName(name);
                contentExcelVOList.add(contentExcelVO);
            }
            return contentExcelVO;
        }

    }


    /**
     *重点考核事项
     */
    public static Map  getItem(List<String> list, BizRespExaminationContentExcelVO contentExcelVO) {
        Map result=new HashMap();
        if(list.size()>=5){
            //重点考核事项
            String name=list.get(1).toString();
            if(!name.equals("NULL")){
                if(name.equals("NULL")){
                    result.put("result","2");
                    result.put("mes","重点考核事项不能为空!");
                    return result;
                }
                //重点考核事项
                BizRespExaminationItemExcelVO itemExcelVO=new BizRespExaminationItemExcelVO();
                itemExcelVO.setName(name);
                //重点考核事项 集合
                List<BizRespExaminationItemExcelVO> itemExcelVOList=contentExcelVO.getItemExcelVOList();
                itemExcelVOList.add(itemExcelVO);
            }
            result.put("result","1");
            result.put("mes", "");
        }else{
            result.put("result","1");
            result.put("mes", "");
        }
        return result;

    }


    /**
     * 考核指标
     * @param list
     * @return
     */
    public static Map getQutoa(List<String> list,BizRespExaminationContentExcelVO contentExcelVO) {
        Map result=new HashMap();
        if(list.size()>=5){
            //考核指标
            String name=list.get(2).toString();
            if(!name.equals("NULL")){
                if(name.equals("NULL")){
                    result.put("result","2");
                    result.put("mes","考核指标不能为空!");
                    return result;
                }
                //考核指标
                BizRespExaminationQuotaExcelVO quotaExcelVO=new BizRespExaminationQuotaExcelVO();
                quotaExcelVO.setName(name);
                //考核指标 集合
                Integer itemIndex=contentExcelVO.getItemExcelVOList().size()-1;
                if(itemIndex==-1){
                    result.put("result","2");
                    result.put("mes","重点考核事项和重点考核事项分值不能为空!");
                    return result;
                }
                List<BizRespExaminationQuotaExcelVO> quotaExcelVOList= contentExcelVO.getItemExcelVOList().get(itemIndex).getQuotaExcelVOList();
                quotaExcelVOList.add(quotaExcelVO);
            }
            result.put("result","1");
            result.put("mes", "");
        }else{
            result.put("result","1");
            result.put("mes", "");
        }

        return result;
    }



    /**
     * 考核目标任务
     * @param list
     */
    public static Map getTask(
            List<String> list,
            List<BizRespExaminationTaskExcelVO> excelVOList,
            List<Map> bmList
    ) {
        Map result=new HashMap();
        if(list.size()>=3){
            //年度考核目标任务
            BizRespExaminationTaskExcelVO taskExcelVO=new BizRespExaminationTaskExcelVO();
            //农业
            String nyfz=list.get(1).toString();
            //非农业
            String fnyfz=list.get(2).toString();
            //评分标准
            String scoreStandard=list.get(0).toString();
            //评分依据
            String pfyj=list.get(5).toString();
            //考核方式
            //String khfs=list.get(7).toString();
            System.out.println("农业="+nyfz);
            System.out.println("非农业="+fnyfz);
            System.out.println("评分标准="+scoreStandard);
            //分值--农业
            if(nyfz.equals("NULL")){
                result.put("result","2");
                result.put("mes","分值-农业不能为空!");
                return result;
            }

            taskExcelVO.setNyfz(nyfz);
            //分值--非农业
            if(fnyfz.equals("NULL")){
                result.put("result","2");
                result.put("mes","分值-非农业不能为空!");
                return result;
            }
            taskExcelVO.setFnyfz(fnyfz);

            //评分标准
            if(scoreStandard.equals("NULL")){
                result.put("result","2");
                result.put("mes","评分标准不能为空!");
                return result;
            }
            taskExcelVO.setScoreStandard(scoreStandard);


            //评分依据
/*            if(pfyj.equals("NULL")){
                result.put("result","2");
                //result.put("mes","评分依据不能为空!");
                result.put("mes","备注不能为空!");
                return result;
            }*/
            taskExcelVO.setPfyj(pfyj);

            //考核方式
/*            if(khfs.equals("NULL")){
                result.put("result","2");
                result.put("mes","考核方式不能为空!");
                return result;
            }
            taskExcelVO.setKhfs(khfs);*/

            //牵头部门
            String qtbm="NULL";
            if(list.size()>=3){
                qtbm=list.get(3)==null?"NULL":list.get(3).toString();
            }
            //配合部门
            String phbm="NULL";
            if(list.size()>=4){
                phbm=list.get(4)==null?"NULL":list.get(4).toString();
            }


            //转换 自评部门 牵头部门 配合部门
            result=getCodeByZpbmQtbmPhbm(qtbm,phbm,bmList,taskExcelVO);
            String resu=result.get("result").toString();
            if(resu.equals("2")){
                return result;
            }

            List<BizRespExaminationTaskExcelVO> taskExcelVOList=excelVOList;
            taskExcelVOList.add(taskExcelVO);
        }else{
            result.put("result","1");
            result.put("mes", "");
        }
        return result;
    }





    /**
     *   //转换 自评部门 牵头部门 配合部门
     * @param qtbm 牵头部门
     * @param phbm  配合部门
     * @param taskExcelVO
     */
    public static Map getCodeByZpbmQtbmPhbm(
            String qtbm,
            String phbm,
            List<Map> bmList,
            BizRespExaminationTaskExcelVO taskExcelVO
    ) {
        Map result=new HashMap();
        //配合部门
        if("".equals(qtbm)){
            qtbm="NULL";
        }
        if(qtbm.equals("NULL")){
            result.put("result","2");
            result.put("mes","牵头部门不能为空!");
            return result;
        }

        //牵头部门
        result=getQtbm(qtbm, bmList);
        String qtresu=result.get("result").toString();
        if(qtresu.equals("1")){
            String qtbmId=result.get("qtbmId").toString();
            taskExcelVO.setLeadDepartment(qtbmId);
        }else{
            return result;
        }

        //配合部门
        if("".equals(phbm)){
            phbm="NULL";
        }

        if(!phbm.equals("NULL")){
            result=getPhbm(phbm, bmList);
            String phresu=result.get("result").toString();
            if(phresu.equals("1")){
                String phbmId=result.get("phbmId").toString();
                taskExcelVO.setCoordinationDepartment(phbmId);
            }else{
                return result;
            }
        }
        return result;
    }


    /**
     * 牵头部门
     * @param qtbm
     * @param pnQtList
     * @return
     */
    public static Map getQtbm(String qtbm, List<Map> pnQtList) {
            Map result=new HashMap();
            String qtbmIdList=null;
            for(Map map:pnQtList){
                String name=map.get("name")==null?"":map.get("name").toString();
                String id=map.get("id")==null?"":map.get("id").toString();
                System.out.println(name);
                System.out.println(qtbm);
                if(name.equals(qtbm.trim())){
                    qtbmIdList=id;
                    break;
                }
            }
        if(StringUtils.isNotEmpty(qtbmIdList)){
            result.put("result","1");
            result.put("qtbmId",qtbmIdList);
            result.put("mes", "");
        } else {
            result.put("result","2");
            result.put("mes", "牵头部门:" + qtbm + ",不存在！");
        }
        System.out.println("qtbm" + qtbm);
        System.out.println(qtbmIdList);
        return result;

    }


    /**
     * 配合部门
     * @param phbm
     * @param pnQtList
     * @return
     */
    public static Map getPhbm(
            String phbm,
            List<Map> pnQtList
    ) {
        Map result=new HashMap();
        StringBuffer sb=new StringBuffer();
        String[] phbmList=phbm.split("\n");
        List<String> phbmIdList=new ArrayList();
        for(String phbmName:phbmList){
            for(Map map:pnQtList){
                String name=map.get("name")==null?"":map.get("name").toString();
                String id=map.get("id")==null?"":map.get("id").toString();
                if(name.equals(phbmName.trim())){
                    phbmIdList.add(id);
                }
            }
        }

        if(phbmList.length==phbmIdList.size()){
            for(String id:phbmIdList){
                sb.append(id).append(",");
            }
            String phid=sb.substring(0,sb.length()-1);
            result.put("result","1");
            result.put("phbmId",phid);
            result.put("mes", "");
        } else {
            result.put("result","2");
            result.put("mes", "配合部门:" + phbm + ",不存在！");
        }
        System.out.println("phbm" + phbm);
        System.out.println(phbmIdList);

        return result;
    }





}