package com.unis.accountability.businessmanagement.controller;

import com.alibaba.fastjson.JSON;
import com.unis.accountability.businessmanagement.common.vo.cityPhbm.PhbmUpdateVO;
import com.unis.accountability.businessmanagement.common.vo.cityZpbm.CityZpbmPage;
import com.unis.accountability.businessmanagement.common.vo.examinationExcel.*;
import com.unis.accountability.businessmanagement.common.vo.provinceTask.ProvinceCityPageVO;
import com.unis.accountability.businessmanagement.service.BizRespExaminationExcelService;
import com.unis.common.utils.ResponseWrapper;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.util.List;

/**excel导入导出
 * @Auther:张新亮
 * @Date: 2018/11/1 0001 15:22
 * @Description:
 */
@RestController
@RequestMapping("/examinationExcel")
@Slf4j
@Api(value = "粮食安全省长责任制--excel导入导出", tags = "粮食安全省长责任制--excel导入导出")
public class BizRespExaminationExcelController {

    @Autowired
    private BizRespExaminationExcelService bizRespExaminationExcelService;



    @ApiOperation(value = "粮食安全行政首长责任制--省级任务考查询(省考核办)---州市评分表导出", notes = "参数：文件")
    @GetMapping(value = "/exportCityExcel/{year}/{shiAreaCode}/{bizRespResponsibilityId}")
    @ResponseBody
    public ResponseWrapper exportCityExcel(
            @PathVariable("year") String year,
            @PathVariable("shiAreaCode") String shiAreaCode,
            @PathVariable("bizRespResponsibilityId") String bizRespResponsibilityId

    ) {
        try {
            List<ProvinceCityPageVO> list= bizRespExaminationExcelService.exportCityExcel(year, shiAreaCode, bizRespResponsibilityId);
            String dataJson= JSON.toJSONString(list);
            return ResponseWrapper.success(200, "查询成功", dataJson);
        } catch (Exception e) {
            e.printStackTrace();
            log.error( "上传文件，发生异常", e.getMessage() );
            return ResponseWrapper.error(500, "活动信息查询失败",null);
        }
    }


    /**
     * 更新--重点考核事项
     *
     * @return ResponseWrapper
     */
    @ApiOperation(value = "粮食安全行政首长责任制----考核评分表管理----导入评分表", notes = "参数：itemVO")
    @PostMapping(value = "/saveExcleData")
    public ResponseWrapper saveExcleData(
            @RequestBody BizRespExcelSaveNewVO excelSaveVO
    ) {
        try {
            boolean flag = bizRespExaminationExcelService.saveExcleData1(excelSaveVO);
            if (flag) {
                return ResponseWrapper.success();
            }
            return ResponseWrapper.error();
        } catch (Exception e) {
            e.printStackTrace();
            log.error( "更新对象，发生异常", e.getMessage() );
            return ResponseWrapper.error( 500, e.getMessage() ,null);
        }
    }




    @ApiOperation(value = "粮食安全行政首长责任制----考核评分表管理----导出评分表", notes = "参数：文件")
    @GetMapping(value = "/exportKhpfbExcel/{bizRespResponsibilityId}")
    public ResponseWrapper exportKhpfbExcel(
            @PathVariable("bizRespResponsibilityId") String bizRespResponsibilityId
    ) {
        try {
            List<BizRespExaminationTaskExcelVO> excelVOS = bizRespExaminationExcelService.exportKhpfbExcel1(bizRespResponsibilityId);
            String dataJson= JSON.toJSONString(excelVOS);
            return ResponseWrapper.success(200, "查询成功", dataJson);
        } catch (Exception e) {
            e.printStackTrace();
            log.error( "上传文件，发生异常", e.getMessage() );
            return ResponseWrapper.error(500, "活动信息查询失败",null);
        }
    }



    @ApiOperation(value = " 粮食安全行政首长责任制--区自评查看（区粮办）---导出", notes = "参数：文件")
    @PostMapping(value = "/exportAreaExcel")
    public ResponseWrapper exportAreaExcel(
            @RequestBody AreeExcelVO areeExcelVO
    ) {
        try {
            List<BizRespExaminationTaskExcelVO> list= bizRespExaminationExcelService.exportAreaExcel1(areeExcelVO);
            String dataJson= JSON.toJSONString(list);
            return ResponseWrapper.success(200, "查询成功", dataJson);
        } catch (Exception e) {
            e.printStackTrace();
            log.error( "上传文件，发生异常", e.getMessage() );
            return ResponseWrapper.error(500, "活动信息查询失败",null);
        }
    }





}