package com.unis.accountability.businessmanagement.domain;

import java.io.UnsupportedEncodingException;
import java.net.URLDecoder;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Date;
import java.util.List;

import javax.servlet.http.HttpServletResponse;

import com.unis.accountability.businessmanagement.common.vo.manageRuler.PageResult;
import com.unis.accountability.businessmanagement.entity.MangerRulesDO;
import com.unis.accountability.businessmanagement.entity.MangerRulesReceviceDO;
import com.unis.accountability.businessmanagement.mapper.MangerRulesDao;
import com.unis.accountability.businessmanagement.mapper.MangerRulesReceviceDao;
import com.unis.accountability.businessmanagement.service.impl.BaseRepository;
import com.unis.common.utils.CurrentUtil;
import com.unis.common.utils.EntityUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.github.pagehelper.Page;
import com.github.pagehelper.PageHelper;
import com.unis.common.utils.FilesUtils;


import tk.mybatis.mapper.entity.Example;
import tk.mybatis.mapper.entity.Example.Criteria;

@Component
public class MangerRulesDomain {

	@Autowired
	private MangerRulesDao mangerRulesMapper;

	@Autowired
	private BaseRepository baseMapper;

	@Autowired
	private MangerRulesReceviceDao mangerRulesReceviceMapper;

	/**
	 * 查看
	 * 
	 * @return
	 */
	public MangerRulesDO getMangerRulesDOInformationByPrimaryKey(String zdbm) {

		Example example = new Example(MangerRulesDO.class);

		Criteria criteria = example.createCriteria();

		criteria.andEqualTo("zdbm", zdbm);
		
		criteria.andEqualTo("status", 1);

		MangerRulesDO mangerRulesDO = mangerRulesMapper.selectOneByExample(example);

		return mangerRulesDO;

	}

	/**
	 * 新增
	 * 
	 * @param entity
	 * @return
	 */
	public void insertToTable(MangerRulesDO entity) {

		entity.buildInsertData();
		
		//entity.setStatus(1);
		String pkCode = baseMapper.selectByTableNameAndAttr(EntityUtil.getTableName(MangerRulesDO.class), "zdbm", "ZD",
				8);
		entity.setZdbm(pkCode);
		entity.setZt(91000004);
		
		int insertCode = mangerRulesMapper.insertSelective(entity);
		
		if(insertCode<0) {
			
			throw new RuntimeException("新增失败");
		}
		
		MangerRulesReceviceDO mangerRulesReceviceDO = new MangerRulesReceviceDO();
		
		mangerRulesReceviceDO.setJsbm(CurrentUtil.getOrgId());
		
		mangerRulesReceviceDO.setZdbm(pkCode);
		
		//順序號
		Integer sxh = baseMapper.selectIdByTableNameAndAttr("ty_wzcbglzdmxb", "sxh");
		
		mangerRulesReceviceDO.setSxh(sxh);
		
		//mangerRulesReceviceDO.setStatus(1);
		
		mangerRulesReceviceDO.buildInsertData();
		
		int insertCode2 = mangerRulesReceviceMapper.insertSelective(mangerRulesReceviceDO);
		
          if(insertCode2<0) {
			
			throw new RuntimeException("新增失败");
		}

	}

	/**
	 * 编辑
	 * 
	 * @param entity
	 */
	public int update(MangerRulesDO entity) {

		entity.buildUpdateData();

		return mangerRulesMapper.updateByPrimaryKeySelective(entity);

	}

	   
	
	/**
	 * 下发文件
	 * 
	 * @param entity
	 * @return
	 */
	public void issue(MangerRulesReceviceDO entity) {
		
        Example receviceExample = new Example(MangerRulesReceviceDO.class);
		
		Criteria criteria = receviceExample.createCriteria();
		
		criteria.andEqualTo("zdbm",entity.getZdbm());
		
		criteria.andEqualTo("status",1);
		
		entity.buildUpdateData();
		
		String jsbm = entity.getJsbm();
		
		if(jsbm!=null&&!jsbm.isEmpty()) {
			
			String orgId = CurrentUtil.getOrgId();
			
			List<String> list = Arrays.asList(jsbm.split(","));
			
			if(!list.contains(orgId)) {
				
				jsbm+=","+orgId;
			}
		}
		entity.setJsbm(jsbm);
		//entity.setStatus(1);
		
		entity.buildUpdateData();
		
		mangerRulesReceviceMapper.updateByExampleSelective(entity, receviceExample);
		
		
		MangerRulesDO entity2=new MangerRulesDO();
		entity2.setZdbm(entity.getZdbm());
		entity2.setZt(91000019);
		entity2.buildUpdateData();
		mangerRulesMapper.updateByPrimaryKeySelective(entity2);
		
	}

	/**
	 * 下载
	 * 
	 * @param response
	 * @param realPath
	 * @throws Exception
	 */
	public void downLoadFile(HttpServletResponse response, String realPath) throws Exception {

		FilesUtils.downloadFile(realPath, response);

	}

	/**
	 * 删除
	 * 
	 * @param zdbm
	 */
	public void delete(String zdbm) {

		Example example = new Example(MangerRulesDO.class);
		Criteria criteria = example.createCriteria();
		criteria.andEqualTo("zdbm", zdbm);
		MangerRulesDO mangerRulesDO = mangerRulesMapper.selectOneByExample(example);
		mangerRulesDO.setStatus(0);
		mangerRulesDO.buildUpdateData();
		
		int updateByPrimaryKeySelective = mangerRulesMapper.updateByPrimaryKeySelective(mangerRulesDO);
		
		if(updateByPrimaryKeySelective<0) {
			
			throw new RuntimeException("删除失败");
		}
		
		//查询并删除从表信息
        Example receviceExample = new Example(MangerRulesReceviceDO.class);
		
		Criteria createCriteria = receviceExample.createCriteria();
		
		createCriteria.andEqualTo("status",1);
		
		createCriteria.andLike("zdbm",zdbm );
		
		List<MangerRulesReceviceDO> mangerRulesReceviceDOs = mangerRulesReceviceMapper.selectByExample(receviceExample);
		
		for (MangerRulesReceviceDO mangerRulesReceviceDO : mangerRulesReceviceDOs) {
			
			mangerRulesReceviceDO.setStatus(0);
			
			mangerRulesReceviceDO.buildUpdateData();
			
			int updateCode = mangerRulesReceviceMapper.updateByPrimaryKeySelective(mangerRulesReceviceDO);
			
			if(updateCode<0) {
				
				throw new RuntimeException("删除失败");
				
			}
		}
	}
	


	/**
	 * 获取列表
	 * 
	 * @return
	 * @throws ParseException 
	 */
	public PageResult<MangerRulesDO> getList(int pageNum, int pageSize, String wjmc, String scrq, List<String> orgCode, String orgId) throws ParseException {

		//查询出当前部门可以查看的数据Id
		Example receviceExample = new Example(MangerRulesReceviceDO.class);
		
		Criteria createCriteria = receviceExample.createCriteria();
		
		createCriteria.andEqualTo("status",1);
		//String orgId = CurrentUtil.getOrgId();
		createCriteria.andLike("jsbm", "%"+orgId+"%");
		
		List<MangerRulesReceviceDO> mangerRulesReceviceDOs = mangerRulesReceviceMapper.selectByExample(receviceExample);

		// 设置主表查询条件
     	Example example = new Example(MangerRulesDO.class);
		
		Criteria criteria = example.createCriteria();
		
		if(mangerRulesReceviceDOs!=null&&mangerRulesReceviceDOs.size()>0) {
			
			List<String> zdbms=new ArrayList<String>();
			
			for (MangerRulesReceviceDO mangerRulesReceviceDO : mangerRulesReceviceDOs) {
				
				String jsbm = mangerRulesReceviceDO.getJsbm();
				
				String[] split = jsbm.split(",");
				
				List<String> list = new ArrayList<>(split.length);
				
				Collections.addAll(list, split);
				//防止部分数据过滤不正确，再加一次判断
				
				if(list.contains(orgId)) {
				
					if(!zdbms.contains(mangerRulesReceviceDO.getZdbm())) {
						
						zdbms.add(mangerRulesReceviceDO.getZdbm());
						
					}
				}
			}
			
	     if(zdbms==null||zdbms.isEmpty()) {
				
				return null;
				
			}
			criteria.andIn("zdbm", zdbms);
		}else {
			
			//没有查到的话直接返回null
			return null;
		}
		//如果scrq不为空且“”，将字符串转换为date,加入查询条件
		
		if(scrq!=null&&!scrq.isEmpty()) {
			
			//判断时间类型不能直接用equal作比较,取当天范围内的时间即可。
			
		    SimpleDateFormat sf=new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		    
		    Date starDate = sf.parse(scrq+" 00:00:00");
		    
		    Date endDate = sf.parse(scrq+" 23:59:59");
			
		    criteria.andGreaterThanOrEqualTo("scrq",starDate );
		    
		    criteria.andLessThanOrEqualTo("scrq", endDate);
			
		}
		criteria.andEqualTo("status", 1);
		
		//如果wjmc不为空或者“”,加入查询条件
		
		if(wjmc!=null&&!wjmc.isEmpty()) {
			
			try {
				String decode = URLDecoder.decode(wjmc,"utf-8");
				System.out.println(decode);
				criteria.andLike("wjmc", "%"+decode+"%");
			} catch (UnsupportedEncodingException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		
		}
		// 开始分页
		PageHelper.startPage(pageNum, pageSize);
		PageHelper.orderBy("refresh_time desc");
		// 分页查询
		Page<MangerRulesDO> pageinfo = (Page<MangerRulesDO>) mangerRulesMapper.selectByExample(example);
		
		List<MangerRulesDO> result = pageinfo.getResult();
		
		//判断当前数据有没有过下发操作,如果下发过，加入下发标识
		for (MangerRulesDO mangerRulesDO : result) {
			
			for (MangerRulesReceviceDO receviceDO : mangerRulesReceviceDOs) {
				
				if(mangerRulesDO.getZdbm().equals(receviceDO.getZdbm())) {
					
					String jsbm = receviceDO.getJsbm();
					//split的长度大于1说明下发过
					String[] split = jsbm.split(",");
					
					if(split.length>1) {
						
						List<String> codes = new ArrayList<>(split.length);
						
						Collections.addAll(codes, split);
						
						if(codes.containsAll(orgCode)) {
							
							mangerRulesDO.setBs(2);
						}else {
							
							mangerRulesDO.setBs(1);
						}
						
					}else {
						
						mangerRulesDO.setBs(0);
					}
					
					
				}
			}
		}
		

		return new PageResult<MangerRulesDO>(pageinfo.getTotal(), pageinfo.getPages(), pageNum, result);
	}
	
	/**
	 * 
	     * @Title: getJsbmByzdbm
	     * @Description: 根据主表id查询接收部门编码
	     * @param @param zdbm
	     * @param @return 参数
	     * @return String 返回类型
	     * @throws
	 */
      public String getJsbmByzdbm(String zdbm) {
    	
    	Example receviceExample = new Example(MangerRulesReceviceDO.class);
  		
  		Criteria criteria = receviceExample.createCriteria();
  		
  		criteria.andEqualTo("zdbm",zdbm);
  		
  		criteria.andEqualTo("status",1);
  		
  		MangerRulesReceviceDO selectOneByExample = mangerRulesReceviceMapper.selectOneByExample(receviceExample);
  		
  		return selectOneByExample.getJsbm();
    	
    }

	
}
