package com.unis.accountability.businessmanagement.entity;

import java.io.Serializable;
import java.util.Date;


import com.unis.common.utils.CurrentUtil;
import lombok.Data;

@Data
public class BaseDO implements Serializable {

	private static final long serialVersionUID = 1L;

	private Integer status; // 状态，1：正常，0：已作废
	
	private String creator; // 创建人
	
	private String creatorCode;// 创建人编码
	
	private Date createDate; // 创建时间
	
	private String refresher; // 更新人
	
	private String refresherCode; // 更新人编码
	
	private Date refreshTime;// 更新时间
	
	private String remark; // 备注

	/**
	 * 后续加上创建人等信息
	 */
	public void buildInsertData(){
		Date date=new Date();
		this.status=1;
		this.createDate=date;
		this.refreshTime=date;
		this.creator= CurrentUtil.getUserName();
		this.creatorCode=CurrentUtil.getUserId();
	}

	/**
	 * 后续加上修改人等信息
	 */
	public void buildUpdateData(){
		Date date=new Date();
		this.refreshTime=date;
		this.refresher=CurrentUtil.getUserName();
		this.refresherCode=CurrentUtil.getUserId();
	}
}
