package com.unis.accountability.businessmanagement.entity;

import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Id;
import javax.persistence.Table;
import javax.persistence.Transient;
import javax.validation.constraints.NotEmpty;

import org.springframework.format.annotation.DateTimeFormat;

import com.fasterxml.jackson.annotation.JsonFormat;

import io.swagger.annotations.ApiModel;
import lombok.Data;


/**
 * ty_wzcbglzd
 * @author liuweilong
 *
 */
@Data
@ApiModel(value = "ty_wzcbglzd--粮食与物资储备管理制度")
@Table(name="ty_wzcbglzd")
public class MangerRulesDO extends BaseDO {
	
	@Id
	private String zdbm;     //db_column:zdbm          	note:ZD+8位顺序号
	
	private String fbr;      //db_column:fbr          	note:发布人
	
	@DateTimeFormat( pattern = "yyyy-MM-dd")
	@JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
	private Date scrq;       //db_column:scrq         	note:上传日期
	
	private  String wjmc;    //db_column:wjmc          	note:文件名称
	
	private  String wjnr;    //db_column:wjnr         	note:文件内容
	
	private String fjid;     //db_column:fjid          	note:附件id
	
	private Integer zt;      //db_column:zt          	note:状态
	
	@Transient
	private Integer bs;      //note:是否下发过的标识  0未下发 1 已下发 2全部下发
	
}