package com.unis.accountability.businessmanagement.mapper;

import com.unis.accountability.businessmanagement.common.vo.cityPhbm.CityPhbmPage;
import com.unis.accountability.businessmanagement.common.vo.cityPhbm.CityPhbmPageVO;
import com.unis.accountability.businessmanagement.common.vo.cityQtbm.CityQtbmPage;
import com.unis.accountability.businessmanagement.common.vo.cityQtbm.CityQtbmPageVO;
import com.unis.accountability.businessmanagement.common.vo.cityZpbm.CityZpbmPage;
import com.unis.accountability.businessmanagement.common.vo.cityZpbm.CityZpbmPageVO;
import com.unis.accountability.businessmanagement.common.vo.cityZpbm.CityZpbmPublishVO;
import com.unis.accountability.businessmanagement.common.vo.cityZpbm.publishAllVO;
import com.unis.accountability.businessmanagement.common.vo.provinceTask.ProvinceCityPageVO;
import com.unis.accountability.businessmanagement.common.vo.provinceTask.ProvinceCityTaskPage;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * @Auther:张新亮
 * @Date: 2019/9/20 0020 19:39
 * @Description:
 */
public interface BizRespCityZpbmServiceMapper {
    /**
     * 粮食安全行政首长责任制----州市自评部门审核----分页
     * @param cityZpbmPage
     * @return
     */
    List<CityZpbmPageVO> findByPage(CityZpbmPage cityZpbmPage);

    /**粮食安全行政首长责任制----州市自评部门审核----根据年份和部门ID查询
     * @Override
     * @param cityZpbmPublishVO
     * @return
     */
    List<publishAllVO> findByZpbmYearAndDeptId(CityZpbmPublishVO cityZpbmPublishVO);

    /**
     * 食安全行政首长责任制----市级配合部门----分页
     * @param cityPhbmPage
     * @return
     */
    List<CityPhbmPageVO> findByPhbmPage(CityPhbmPage cityPhbmPage);

    /**
     * 粮食安全行政首长责任制----市级配合部门---根据年份和部门ID查询
     * @param cityZpbmPublishVO
     * @return
     */
    List<publishAllVO> findByPhbmYearAndDeptId(CityZpbmPublishVO cityZpbmPublishVO);
    /**
     * 粮食安全行政首长责任制----市级牵头部门----分页
     * @param cityQtbmPage
     * @return
     */
    List<CityQtbmPageVO> findByQtbmPage(CityQtbmPage cityQtbmPage);

    /**
     * 粮食安全行政首长责任制----市级牵头部门---批量提交
     * @param cityZpbmPublishVO
     * @return
     */
    List<publishAllVO> findByQtbmYearAndDeptId(CityZpbmPublishVO cityZpbmPublishVO);



    /**
     * 粮食安全行政首长责任制----省级任务考查询(省考核办)----州市考核明细
     * @param provinceTaskPage
     * @return
     */
    List<ProvinceCityPageVO> findCityByPage(ProvinceCityTaskPage provinceTaskPage);


    /**
     * 粮食安全行政首长责任制----省级任务考查询(省考核办)----根据填报设置ID 和州市行政区划果询 taskId inputId 集合
     * @param bizRespResponsibilityId
     * @param areaCode
     * @return
     */
    List<Map> findByTaskIdAndAreaCode(@Param(value="bizRespResponsibilityId")String bizRespResponsibilityId , @Param(value="areaCode")String areaCode);

    /**
     * 根据行政区划查询总分
     * @param bizRespResponsibilityId
     * @param areaCode
     * @return
     */
    Map finyNyfzAndFnyfz(@Param(value="bizRespResponsibilityId")String bizRespResponsibilityId , @Param(value="areaCode")String areaCode);


}