package com.unis.accountability.businessmanagement.mapper;

import com.unis.accountability.businessmanagement.common.vo.examinationTask.BigTaskQueryVO;
import com.unis.accountability.businessmanagement.common.vo.examinationTask.ProvinceLeadVO;
import com.unis.accountability.businessmanagement.common.vo.cityZpbm.CityZpbmPublishVO;
import com.unis.accountability.businessmanagement.common.vo.provincePhbm.ProvincePhbmPublishVO;
import com.unis.accountability.businessmanagement.common.vo.provinceTask.ProvinceCityTaskPage;
import com.unis.accountability.businessmanagement.common.vo.respScoreInput.BizRespScoreInputSmiitVO;
import com.unis.accountability.businessmanagement.entity.BizRespDepartmentalOpinion;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

@Repository
public interface BizRespDepartmentalOpinionMapper {
    /**
     *
     * @mbggenerated 2019-09-19
     */
    int deleteByPrimaryKey(String id);

    /**
     *
     * @mbggenerated 2019-09-19
     */
    int insert(BizRespDepartmentalOpinion record);

    /**
     *
     * @mbggenerated 2019-09-19
     */
    int insertSelective(BizRespDepartmentalOpinion record);

    /**
     *
     * @mbggenerated 2019-09-19
     */
    BizRespDepartmentalOpinion selectByPrimaryKey(String id);

    /**
     *
     * @mbggenerated 2019-09-19
     */
    int updateByPrimaryKeySelective(BizRespDepartmentalOpinion record);

    /**
     *
     * @mbggenerated 2019-09-19
     */
    int updateByPrimaryKey(BizRespDepartmentalOpinion record);

    /**
     * 粮食安全行政首长责任制----州市自评部门审核----查看
     * @param id  评分结果录入ID
     * @param areaCode 行政区划
     * @return
     */
    BizRespDepartmentalOpinion findByZpbmInfo(@Param(value="id")String id, @Param(value="areaCode")String areaCode, @Param(value="zpbm")String zpbm);

    /**
     * 盟市长责任制--省级牵头部门--条件分页查询
     * @author 邹杰利
     * @param bigTaskQueryVO
     * @return
     */
    List<ProvinceLeadVO> getProvinceLeadVO(BigTaskQueryVO bigTaskQueryVO);

    /**
     * 盟市长责任制--省级配合部门--条件分页查询
     * @author 邹杰利
     * @param bigTaskQueryVO
     * @return
     */
    List<ProvinceLeadVO> getProvinceCoordinateVO(BigTaskQueryVO bigTaskQueryVO);

    /**
     * 盟市长责任制--省级牵头部门--根据任务id查询省级配合部门意见
     * @author 邹杰利
     * @param selectMap
     * @return
     */
    List<BizRespDepartmentalOpinion> getProvinceCoordinateOpinion(Map selectMap);
    /**
     * 盟市长责任制--省级牵头部门--根据任务id查询省级牵头部门意见
     * @author 邹杰利
     * @param resultMap
     * @return
     */
    BizRespDepartmentalOpinion getProvinceLeadOpinion(Map resultMap);


    BizRespDepartmentalOpinion findByCityInfo(@Param(value="id")String id, @Param(value="areaCode")String areaCode, @Param(value="deptId")String deptId, @Param(value="type")String type);

    BizRespDepartmentalOpinion findByCityInfoCopy(@Param(value="id")String id, @Param(value="areaCode")String areaCode, @Param(value="deptId")String deptId, @Param(value="type")String type);
    /**
     *  粮食安全行政首长责任制----州市自评部门审核---根据年份部门状态查询明细
     * @param cityZpbmPublishVO
     * @return
     */
    List<BizRespDepartmentalOpinion> fidByYearAndDeptIdAndStatus(CityZpbmPublishVO cityZpbmPublishVO);


    /**
     * 盟市长责任制--省级牵头部门--更新省级牵头部门评分
     * @author 邹杰利
     * @param bizRespDepartmentalOpinion
     */
    void updateLeadOpinion(BizRespDepartmentalOpinion bizRespDepartmentalOpinion);

    /**
     * 更新意见表状态
     * @author 邹杰利
     * @param selectMap
     */
    void updateOpinionStatus(Map selectMap);
    /**
     * 盟市长责任制---省级任务考查询(省考核办)---根据任务ID和市行政区划查询部门评分意见
     * @param taskId
     * @param shiAreaCode
     * @return
     */
    List<BizRespDepartmentalOpinion> findByTaskAndShiAreaCode(@Param(value="taskId")String taskId, @Param(value="shiAreaCode")String shiAreaCode);

    /**
     * 粮食安全行政首长责任制----省级牵头部门
     * @param taskId
     * @param type
     * @return
     */
    BizRespDepartmentalOpinion findByProvinceQtbm(@Param(value="taskId")String taskId, @Param(value="type")String type,@Param(value="areaCode")String areaCode);

    /**
     * 根据任务id查询省级牵头部门复评意见
     * @author 邹杰利
     * @param resultMap
     * @return
     */
    BizRespDepartmentalOpinion getProvinceLeadAgainOpinion(Map<String, Object> resultMap);

    /**
     * 省级牵头部门--批量上报
     * @author 邹杰利
     * @param selectMap
     */
    List<ProvinceLeadVO> getProvinceLeadVOByStatus(Map selectMap);


    /**
     * 粮食安全行政首长责任制----省级配合部门---批量上报
     * @param phbmPublishVO
     * @return
     */
    List<BizRespDepartmentalOpinion> findByOpionInfo(ProvincePhbmPublishVO phbmPublishVO);

    /**
     * 粮食安全行政首长责任制----省级牵头部门----查看配合部门明细
     * @param taskId
     * @param type
     * @return
     */
    List<BizRespDepartmentalOpinion> findByTaskIdAndType(@Param(value="taskId")String taskId, @Param(value="type")String type);

    List<BizRespDepartmentalOpinion> findByIdAndType(@Param(value="taskId")String taskId, @Param(value="type")String type,@Param(value="areacode")String areacode);

    /**
     * 粮食安全行政首长责任制----统计总分
     * @param taskId
     * @param shiAreaCode
     * @return
     */
    List<BizRespDepartmentalOpinion> findByProvinceScore(@Param(value="taskId")String taskId , @Param(value="shiAreaCode")String shiAreaCode);

    /**
     * 州市、外部单位牵头部门、配合部门评分--查询是否可以提交数据
     * @param scoreInputSmiitVO
     * @return
     */
    List<BizRespDepartmentalOpinion> findByIsSubmit(BizRespScoreInputSmiitVO scoreInputSmiitVO);

    /**
     *粮食安全行政首长责任制----评分表分处室考核（市部门）----发布
     * @param inputSmiitVO
     * @return
     */
    List<BizRespDepartmentalOpinion> findByFfList(ProvincePhbmPublishVO inputSmiitVO);

    /**
     * 根据行政区划查询总分
     * @param bilityId
     * @param areaCode
     * @param status 
     * @return
     */
    String findByTotalScore(@Param(value="bilityId")String bilityId, @Param(value="areaCode")String areaCode , @Param(value="type")String type, @Param(value="status")String status);

    /**
     * 粮食安全行政首长责任制----考核结果查看（市局)---抽查分发
     * @param provinceCityTaskPage
     * @return
     */
    List<BizRespDepartmentalOpinion> publishCcFf(ProvinceCityTaskPage provinceCityTaskPage);

    /**
     * 查询综合得分
     * @param taskId
     * @param araeCode
     * @param type
     * @return
     */
    String findByTaskIdAndAreaCodeAndType(@Param(value="taskId")String taskId, @Param(value="araeCode")String araeCode,
    		@Param(value="type")String type, @Param(value="status")String status);

    /**
     * 统计总分
     * @param bilityId
     * @param areaCode
     * @param type
     * @return
     */
    Map findByTaskFnyfzAndNyfzTotal(@Param(value="bilityId")String bilityId, @Param(value="areaCode")String areaCode, @Param(value="type")String type, @Param(value="status")String status);
}