package com.unis.accountability.businessmanagement.mapper;

import com.unis.accountability.businessmanagement.common.vo.cityTaskDistribution.CityTaskPublishVO;
import com.unis.accountability.businessmanagement.common.vo.examinationExcel.AreeExcelVO;
import com.unis.accountability.businessmanagement.common.vo.examinationTask.*;
import com.unis.accountability.businessmanagement.common.vo.opinion.BizRespDepartmentalOpinionVO;
import com.unis.accountability.businessmanagement.common.vo.provinceTask.ProvinceCityPageVO;
import com.unis.accountability.businessmanagement.common.vo.provinceTask.ProvinceCityTaskPage;
import com.unis.accountability.businessmanagement.entity.BizRespExaminationTask;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;

import java.util.List;
import java.util.Map;

@Repository
public interface BizRespExaminationTaskMapper {
    /**
     *
     * @mbggenerated 2019-09-18
     */
    int deleteByPrimaryKey(String id);

    /**
     *
     * @mbggenerated 2019-09-18
     */
    int insert(BizRespExaminationTask record);

    /**
     *
     * @mbggenerated 2019-09-18
     */
    int insertSelective(BizRespExaminationTask record);

    /**
     *
     * @mbggenerated 2019-09-18
     */
    BizRespExaminationTask selectByPrimaryKey(String id);

    /**
     *
     * @mbggenerated 2019-09-18
     */
    int updateByPrimaryKeySelective(BizRespExaminationTask record);

    /**
     *
     * @mbggenerated 2019-09-18
     */
    int updateByPrimaryKey(BizRespExaminationTask record);

    /**
     *
     * @param id
     * @return
     */
    List<Map> findByBizTaskId(String id);

    /**
     * 粮食安全省长责任制--考核目标任务---查询可填分数
     * @param map
     * @return
     */
    Map findBySorce(Map map);

    /**
     * 粮食安全省长责任制--考核目标任务---分页
     * @param taskVO
     * @return
     */
    List<Map> findByPage(TaskPageVO taskVO);

    /**
     * 粮食安全省长责任制--考核目标任务---根据填报设置ID查询所有考核任务
     * @param id
     * @return
     */
    List<BizRespExaminationTask> findByResponsTaskList(String id);

    /**
     * 盟市长责任制--省级牵头部门--条件分页查询
     * @author 邹杰利
     * @param bigTaskQueryVO
     * @return
     */
    List<ProvinceLeadVO> getProvinceLeadVO(BigTaskQueryVO bigTaskQueryVO);

    /**
     * 盟市长责任制--省级牵头部门--根据任务id查询详情
     * @author 邹杰利
     * @param id
     * @return
     */
    BigTaskVO getProvinceLeadDeptDetail(String id);

    /**
     * 省级牵头部门--上报
     * @author 邹杰利
     * @param selectMap
     */
    void updateTaskStatus(Map selectMap);

    /** 盟市长责任制--省级牵头部门--根据任务年分 市行政区划 和填报设置ID 查询信息
     * @param year
     * @param bizRespResponsibilityId
     * @param shiAreaCode
     * @return
     */
    List<BizRespExaminationTask> findByYearAndShiAreaCodeAndBilityId(@Param(value="year")String year, @Param(value="bizRespResponsibilityId")String bizRespResponsibilityId,  @Param(value="shiAreaCode") String shiAreaCode);

    /**
     * 粮食安全省长责任制--考核目标任务---根据填报ID查询考核任务
     * @param bilityId
     * @return
     */
    List<BizRespExaminationTask> findByBilityId(String bilityId);
    List<BizRespExaminationTaskVO> findVOByBilityId(String bilityId);

    /**
     * 粮食安全行政首长责任制----考核评分表管理----考核目标任务
     * @param quotaId
     * @return
     */
    List<BizRespExaminationTask> findByTaskList(String quotaId);

    /**
     * 粮食安全行政首长责任制--区自评查看（区粮办）---导出
     * @param areeExcelVO
     * @return
     */
    List<BizRespExaminationTask> findByTaskExcel(AreeExcelVO areeExcelVO);

    /**
     * 查询考核任务是否考核分发
     * @param cityTaskPublishVO
     * @return
     */
    List<BizRespExaminationTask> findByIsKhff(CityTaskPublishVO cityTaskPublishVO);

    /**
     * 批量发布
     * @param orgId
     */
    void publishAll(String orgId);
}