package com.unis.accountability.businessmanagement.mapper;

import com.unis.accountability.businessmanagement.common.vo.cityTaskDistribution.CityTaskPublishVO;
import com.unis.accountability.businessmanagement.common.vo.provinceTask.ProvinceTaskPage;
import com.unis.accountability.businessmanagement.common.vo.respScoreInput.BizRespScoreInputSmiitVO;
import com.unis.accountability.businessmanagement.common.vo.responsibility.BizRespResponsibilityPageVO;
import com.unis.accountability.businessmanagement.entity.BizRespScoreInput;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

public interface BizRespScoreInputMapper {
    /**
     *
     * @mbggenerated 2019-09-19
     */
    int deleteByPrimaryKey(String id);

    /**
     *
     * @mbggenerated 2019-09-19
     */
    int insert(BizRespScoreInput record);

    /**
     *
     * @mbggenerated 2019-09-19
     */
    int insertSelective(BizRespScoreInput record);

    /**
     *
     * @mbggenerated 2019-09-19
     */
    BizRespScoreInput selectByPrimaryKey(String id);

    /**
     *
     * @mbggenerated 2019-09-19
     */
    int updateByPrimaryKeySelective(BizRespScoreInput record);

    /**
     *
     * @mbggenerated 2019-09-19
     */
    int updateByPrimaryKey(BizRespScoreInput record);

    /**
     * 粮食安全首长责任制--州市考核任务管理  根据年分 状态 行政区划 查询 州市考核录入数据
     * @param cityTaskPublishVO
     * @return
     */
    List<BizRespScoreInput> findByYearAndStatusAndAreaCode(CityTaskPublishVO cityTaskPublishVO);

    /**
     * 粮食安全首长责任制--下发州市考核任务----制定州市考核任务--- 分页查询
     * @param pageVO
     * @return
     */
    List<Map> findTaskByPage(BizRespResponsibilityPageVO pageVO);

    /**
     * 粮食安全行政首长责任制----制定州市考核任务----根据ID和行政区划查询查看
     * @param taskId
     * @param areaCode
     * @return
     */
    BizRespScoreInput findByTaskIdAndAreaCode(@Param(value="taskId")String taskId, @Param(value="areaCode")String areaCode);
    /**
     * 州市、外部单位牵头部门、配合部门评分--查询是否可以提交数据
     * @param scoreInputSmiitVO
     * @return
     */
    List<BizRespScoreInput> findByIsSubmit(BizRespScoreInputSmiitVO scoreInputSmiitVO);

    /**
     * 粮食安全行政首长责任制----区自评查看（市局）---考核分发
     * @param cityTaskPublishVO
     */
    void publishKhff(CityTaskPublishVO cityTaskPublishVO);

    /**
     *
     * 结果汇总查看里的区级发布
     * @param provinceTaskPage
     */
    void updateByArea(ProvinceTaskPage provinceTaskPage);

    /**
     * 根据Id查询
     * @param id
     * @return
     */
    BizRespScoreInput findById(String id);
}