package com.unis.accountability.businessmanagement.service;

import com.github.pagehelper.PageInfo;
import com.unis.accountability.businessmanagement.common.vo.cityPhbm.CityPhbmPage;
import com.unis.accountability.businessmanagement.common.vo.cityPhbm.CityPhbmPageVO;
import com.unis.accountability.businessmanagement.common.vo.cityPhbm.PhbmUpdateVO;
import com.unis.accountability.businessmanagement.common.vo.cityPhbm.PhbmVO;
import com.unis.accountability.businessmanagement.common.vo.cityQtbm.*;
import com.unis.accountability.businessmanagement.common.vo.cityZpbm.CityZpbmPublishVO;

import java.util.List;

/**
 * @Auther:张新亮
 * @Date: 2019/9/21 0021 14:57
 * @Description:
 */
public interface BizRespCityQtbmService {
    /**
     * 粮食安全行政首长责任制----市级牵头部门----分页
     * @param cityQtbmPage
     * @param page
     * @param size
     * @return
     */
    PageInfo<List<CityQtbmPageVO>> findByPage(CityQtbmPage cityQtbmPage, Integer page, Integer size);

    /**
     * 粮食安全行政首长责任制----市级牵头部门----查看
     * @param id
     * @return
     */
    QtbmVO findById(String id, String deptId);

    /**
     * 粮食安全行政首长责任制----市级牵头部门---编辑
     * @param qtbmUpdateVO
     * @return
     */
    boolean update(QtbmUpdateVO qtbmUpdateVO);

    /**
     * 粮食安全行政首长责任制----市级牵头部门---提交
     * @param cityZpbmPublishVO
     */
    void publish(CityZpbmPublishVO cityZpbmPublishVO);


    /**
     * 粮食安全行政首长责任制----市级牵头部门---批量提交
     * @param cityZpbmPublishVO
     */
    void publishALL(CityZpbmPublishVO cityZpbmPublishVO);

    /**
     * 粮食安全行政首长责任制----市级牵头部门---根据年份部门状态查询明细
     * @param cityQtbmPage
     * @return
     */
    List<CityQtbmPageVO> fidByYearAndDeptIdAndStatus(CityQtbmPage cityQtbmPage);

    /**
     * 粮食安全行政首长责任制----市级牵头部门----根据taskId和行政区划查询查看
     * @param taskId
     * @param areaCode
     * @return
     */
    QtbmVO findByTaskIdAndAreaCode(String taskId, String areaCode);


    /**
     * 粮食安全行政首长责任制----市级牵头部门----根据taskId和行政区划查询查看
     * @param taskId
     * @param areaCode
     * @return
     */
    CityTaskinfoVO findByAreaList(String taskId, String areaCode);


}