package com.unis.accountability.businessmanagement.service;

import com.github.pagehelper.PageInfo;
import com.unis.accountability.businessmanagement.common.vo.cityFf.*;
import com.unis.accountability.businessmanagement.common.vo.cityZpbm.CityZpbmPublishVO;
import com.unis.accountability.businessmanagement.common.vo.respScoreInput.BizRespScoreInputSmiitVO;
import com.unis.accountability.businessmanagement.entity.BizRespCityTaskfF;
import com.unis.accountability.businessmanagement.entity.BizRespExaminationTask;

import java.util.List;

/**
 * @Auther:张新亮
 * @Date: 2019/12/13 0013 10:17
 * @Description:
 */
public interface BizRespCityTaskfFService {
    /**
     * 生产牵头部门数据
     * @param taskDO
     * @return
     */
    BizRespCityTaskfF getQtbmDate(BizRespExaminationTask taskDO);
    /**
     * 生产配合部门数据
     * @param taskDO
     * @return
     */
    List<BizRespCityTaskfF> getPhbmDate(BizRespExaminationTask taskDO);

    /**
     * 保存存分发数据
     * @param ffList
     */
    void save(List<BizRespCityTaskfF> ffList);

    /**
     * 粮食安全省长责任制--评分表分处室考核（市部门）---分页
     * @param cityFfPage
     * @param page
     * @param size
     * @return
     */
    PageInfo<List<CityFfPageVO>> findByPage(CityFfPage cityFfPage, Integer page, Integer size);
    /**
     * 粮食安全省长责任制--评分表分处室考核（市部门）---分页
     * @param cityFfPage
     * @param page
     * @param size
     * @return
     */
    PageInfo<List<CityFfPageVO>> findByPageQu(CityFfPage cityFfPage, Integer page, Integer size);
    /**
     * 粮食安全行政首长责任制----评分表分处室考核（市部门）----查看
     * @param id
     * @return
     */
    TaskFfInfoVO findById(String id);

    /**
     * 粮食安全行政首长责任制----评分表分处室考核（市部门）---编辑
     * @param ffUpdateVO
     * @return
     */
    boolean update(FfUpdateVO ffUpdateVO);

    /**
     * 粮食安全行政首长责任制----评分表分处室考核（市部门）---提交
     * @param ffPublishVO
     */
    void publish(FfPublishVO ffPublishVO);

    /**
     * 粮食安全行政首长责任制----评分表分处室考核（市部门）---批量提交
     * @param ffPublishVO
     */
    void publishALL(FfPublishVO ffPublishVO);

    /**
     * 粮食安全行政首长责任制----评分表分处室考核（市部门）--查询是否可以提交数据
     * @param scoreInputSmiitVO
     * @return
     */
    String findByIsSubmit(FfPublishVO ffPublishVO);
}