package com.unis.accountability.businessmanagement.service;

import com.github.pagehelper.PageInfo;
import com.unis.accountability.businessmanagement.common.vo.CityPublishVO;
import com.unis.accountability.businessmanagement.common.vo.cityPhbm.CityPhbmPage;
import com.unis.accountability.businessmanagement.common.vo.cityTaskDistribution.CityTaskDistributionPageVO;
import com.unis.accountability.businessmanagement.common.vo.cityTaskDistribution.CityTaskDistributionVO;
import com.unis.accountability.businessmanagement.common.vo.cityZpbm.*;

import java.util.List;

/**
 * @Auther:张新亮
 * @Date: 2019/9/20 0020 19:33
 * @Description:
 */
public interface BizRespCityZpbmService {

    /**
     * 粮食安全行政首长责任制----州市自评部门审核----分页
     * @param cityZpbmPage
     * @param page
     * @param size
     * @return
     */
    PageInfo<List<CityZpbmPageVO>> findByPage(CityZpbmPage cityZpbmPage, Integer page, Integer size);

    /**
     * 粮食安全行政首长责任制----州市自评部门审核----查看
     * @param id
     * @return
     */
    ZpbmVO findById(String id);

    /**
     * 粮食安全行政首长责任制----州市自评部门审核---编辑
     * @param zpbmUpdateVO
     * @return
     */
    boolean update(ZpbmUpdateVO zpbmUpdateVO);

    /**
     * 粮食安全行政首长责任制----州市自评部门审核---提交
     * @param cityZpbmPublishVO
     */
    void publish(CityZpbmPublishVO cityZpbmPublishVO);

    /**
     * 粮食安全行政首长责任制----州市自评部门审核---批量提交
     * @param cityZpbmPublishVO
     */
    void publishALL(CityZpbmPublishVO cityZpbmPublishVO);

    /**
     * 粮食安全行政首长责任制----州市自评部门审核---根据年份部门状态查询明细
     * @param cityZpbmPage
     * @return
     */
    List<CityZpbmPageVO> fidByYearAndDeptIdAndStatus(CityZpbmPage cityZpbmPage);


    /**
     * 粮食安全行政首长责任制----州市自评部门审核----根据ID和行政区划查询查看
     * @param taskId
     * @param areaCode
     * @return
     */
    ZpbmVO findByTaskIdAndAreaCode(String taskId, String areaCode);

    /**
     * 修改 粮食安全行政首长责任制-----部门评分意见   BIZ_RESP_DEPARTMENTAL_OPINION 的状态
     * @param cityPublishVO
     */
    void updateStatus(CityPublishVO cityPublishVO);
}