package com.unis.accountability.businessmanagement.service;

import com.unis.accountability.businessmanagement.common.vo.cityPhbm.PhbmUpdateVO;
import com.unis.accountability.businessmanagement.common.vo.cityPhbm.PhbmVO;
import com.unis.accountability.businessmanagement.common.vo.cityQtbm.QtbmOpionVO;
import com.unis.accountability.businessmanagement.common.vo.cityQtbm.QtbmUpdateVO;
import com.unis.accountability.businessmanagement.common.vo.cityQtbm.QtbmVO;
import com.unis.accountability.businessmanagement.common.vo.cityTaskDistribution.CityTaskPublishVO;
import com.unis.accountability.businessmanagement.common.vo.cityZpbm.ZpbmUpdateVO;
import com.unis.accountability.businessmanagement.common.vo.cityZpbm.ZpbmVO;
import com.unis.accountability.businessmanagement.common.vo.provincePhbm.ProvincePhbmPublishVO;
import com.unis.accountability.businessmanagement.common.vo.provinceTask.ProvinceCityTaskPage;
import com.unis.accountability.businessmanagement.common.vo.respScoreInput.BizRespRespScoreInputPublishVO;
import com.unis.accountability.businessmanagement.common.vo.respScoreInput.BizRespScoreInputSmiitVO;
import com.unis.accountability.businessmanagement.entity.BizRespDepartmentalOpinion;
import com.unis.accountability.businessmanagement.entity.BizRespExaminationTask;
import com.unis.accountability.businessmanagement.entity.BizRespScoreInput;
import org.apache.ibatis.annotations.Param;

import java.util.List;
import java.util.Map;

/**
 * @Auther:张新亮
 * @Date: 2019/9/19 0019 17:40
 * @Description:
 */
public interface BizRespDepartmentalOpinionService {
    /**
     * 创建考核指标的省级评分意见 --省级配合部门  牵头部门
     * @param taskDO
     * @param inputPublishVO
     */
    void save(BizRespExaminationTask taskDO, BizRespRespScoreInputPublishVO inputPublishVO,String areaCode);

    /**
     * 创建考核指标的州市评分意见---自评部门  配合部门 牵头部门
     * @param input
     * @param cityTaskPublishVO
     * @param areaCode
     */
     void saveCity(BizRespScoreInput input, CityTaskPublishVO cityTaskPublishVO,String areaCode);

    /**
     * 创建考核指标的州市评分意见----自评部门----查看
     * @param bizRespScoreInput
     * @return
     */
    ZpbmVO findByZpbmInfo(BizRespScoreInput bizRespScoreInput);

    /**
     * 创建考核指标的州市评分意见----自评部门----修改
     * @param zpbmUpdateVO
     * @return
     */
    boolean updateZpbm(ZpbmUpdateVO zpbmUpdateVO);

    /**
     * 粮食安全行政首长责任制----市级配合部门----查看
     * @param bizRespScoreInput
     * @return
     */
    PhbmVO findByPhbmInfo(BizRespScoreInput bizRespScoreInput);



    /**
     * 粮食安全行政首长责任制----市级配合部门----查看
     * @param bizRespScoreInput
     * @return
     */
    QtbmOpionVO findByAreaPhbmInfo(BizRespScoreInput bizRespScoreInput,String type);



    /**
     * 粮食安全行政首长责任制----市级配合部门---编辑
     * @param phbmUpdateVO
     * @return
     */
    boolean updatePhbm(PhbmUpdateVO phbmUpdateVO);

    /**
     *  粮食安全行政首长责任制----市级牵头部门----查看
     * @param bizRespScoreInput
     * @return
     */
    QtbmVO findByQtbmInfo(BizRespScoreInput bizRespScoreInput);


    /**
     *  粮食安全行政首长责任制----市级牵头部门----查看
     * @param bizRespScoreInput
     * @return
     */
    QtbmOpionVO findByAreaQtbmInfo(BizRespScoreInput bizRespScoreInput,String type);

    /**
     * 粮食安全行政首长责任制----市级牵头部门---编辑
     * @param qtbmUpdateVO
     * @return
     */
    boolean updateQtbm(QtbmUpdateVO qtbmUpdateVO);

    /**
     * 粮食安全行政首长责任制----省级牵头部门
     * @param taskId
     * @param type
     * @return
     */
    QtbmVO findByProvinceQtbm(String taskId, String type,String areaCode);

    /**
     * 粮食安全行政首长责任制----省级任务考查询(省考核办)---驳回
     * @param taskId
     * @param shiAreaCode
     * @return
     */
    boolean saveReappraisal(String taskId, String shiAreaCode);

    /**
     * 粮食安全行政首长责任制----省级任务考查询(省考核办)---根据考核任务ID 和州市行政区划查询评分意见
     * @param taskId
     * @param shiAreaCode
     * @return
     */
    List<BizRespDepartmentalOpinion> findByProvinceTaskIdAndAreaCode(String taskId, String shiAreaCode);

    /**
     * 粮食安全行政首长责任制----统计总分
     * @param taskId
     * @param areaCode
     * @return
     */
    List<BizRespDepartmentalOpinion> findByProvinceScore(String taskId, String areaCode);

    /**
     * 州市、外部单位牵头部门、配合部门评分--查询是否可以提交数据
     * @param scoreInputSmiitVO
     * @return
     */
    String findByIsSubmit(BizRespScoreInputSmiitVO scoreInputSmiitVO);


    /**
     * 根据行政
     * @param bilityId
     * @param areaCode
     * @return
     */
    String findByTotalScore(String bilityId, String areaCode,String type, String status);


    /**
     * 粮食安全行政首长责任制----评分表分处室考核（市部门）----发布
     * @param inputSmiitVO
     * @return
     */
   List<BizRespDepartmentalOpinion> findByFfList(ProvincePhbmPublishVO inputSmiitVO);

    /**
     * 粮食安全行政首长责任制----考核结果查看（市局)---抽查分发
     * @param provinceCityTaskPage
     */
    void publishCcFf(List<ProvinceCityTaskPage> provinceCityTaskPage);

    /**
     * 查询综合得分
     * @param taskId
     * @param araeCode
     * @param type
     * @return
     */
    String findByTaskIdAndAreaCodeAndType(String taskId, String araeCode, String type, String status);

    /**
     * 统府总分
     * @param bilityId
     * @param areaCode
     * @param type
     * @return
     */
    Map findByTaskFnyfzAndNyfzTotal(String bilityId, String areaCode, String type, String status);
}