package com.unis.accountability.businessmanagement.service;

import com.github.pagehelper.PageInfo;
import com.unis.accountability.businessmanagement.common.vo.DeleteVO;
import com.unis.accountability.businessmanagement.common.vo.SaveVO;
import com.unis.accountability.businessmanagement.common.vo.examinationContent.ContentPage;
import com.unis.accountability.businessmanagement.common.vo.examinationContent.ContentSaveVO;
import com.unis.accountability.businessmanagement.common.vo.examinationContent.ContentUpdateVO;
import com.unis.accountability.businessmanagement.common.vo.examinationExcel.AreeExcelVO;
import com.unis.accountability.businessmanagement.common.vo.examinationExcel.BizRespExaminationContentExcelVO;
import com.unis.accountability.businessmanagement.common.vo.examinationExcel.BizRespExcelSaveVO;
import com.unis.accountability.businessmanagement.entity.BizRespExaminationContent;

import java.util.List;
import java.util.Map;

/**
 * @Auther:张新亮
 * @Date: 2019/9/18 0018 14:51
 * @Description:
 */
public interface BizRespExaminationContentService {
    /**
     * 粮食安全行政首长责任制----考核内容----保存
     * @param contentVO
     * @return
     */
    boolean save(ContentSaveVO saveVO);

    /**
     * 粮食安全行政首长责任制----考核内容----分页
     * @param contentVO
     * @param page
     * @param size
     * @return
     */
    PageInfo<List<Map>> findByPage(ContentPage contentPage, Integer page, Integer size);


    /**
     * 粮食安全行政首长责任制----考核内容----是否可以删除
     * @param id
     * @return
     */
    public List<Map> findIfRelease(String id);

    /**
     * 粮食安全行政首长责任制----考核内容----修改
     * @param updateVO
     * @return
     */
    boolean update(ContentUpdateVO updateVO);

    /**
     *粮食安全行政首长责任制----考核内容----删除
     * @param deleteVO
     * @return
     */
    Boolean deletes(DeleteVO deleteVO);

    /**
     * 粮食安全行政首长责任制----考核内容----根据年份year和组织机构查询好喝内容
     * @param map
     * @return
     */
    List<Map> findByYearAndOrgId(Map map);

    /**
     * 粮食安全行政首长责任制----考核评分表管理----考核内容
     * @param contentExcelVO
     * @param responsibilityId
     * @return
     */
    BizRespExaminationContent getContentData(BizRespExaminationContentExcelVO contentExcelVO, String responsibilityId, SaveVO saveVO);

    /**
     * 粮食安全行政首长责任制----根据 bizRespResponsibilityId 查询考核内容
     * @param bizRespResponsibilityId
     * @return
     */
    List<BizRespExaminationContentExcelVO> findByRespResponsibilityId(String bizRespResponsibilityId);

    /**
     * 粮食安全行政首长责任制----根据 bizRespResponsibilityId 查询考核内容
     * @param bizRespResponsibilityId
     * @return
     */
    List<BizRespExaminationContentExcelVO> findByContentExcel(AreeExcelVO areeExcelVO);




}