package com.unis.accountability.businessmanagement.service;

import com.github.pagehelper.PageInfo;
import com.unis.accountability.businessmanagement.common.vo.DeleteVO;
import com.unis.accountability.businessmanagement.common.vo.SaveVO;
import com.unis.accountability.businessmanagement.common.vo.examinationExcel.AreeExcelVO;
import com.unis.accountability.businessmanagement.common.vo.examinationExcel.BizRespExaminationContentExcelVO;
import com.unis.accountability.businessmanagement.common.vo.examinationExcel.BizRespExaminationItemExcelVO;
import com.unis.accountability.businessmanagement.common.vo.examinationItem.ItemPage;
import com.unis.accountability.businessmanagement.common.vo.examinationItem.ItemSaveVO;
import com.unis.accountability.businessmanagement.common.vo.examinationItem.ItemUpdateVO;
import com.unis.accountability.businessmanagement.entity.BizRespExaminationItem;

import java.util.List;
import java.util.Map;

/**
 * @Auther:张新亮
 * @Date: 2019/9/18 0018 15:39
 * @Description:
 */
public interface BizRespExaminationItemService {
    /**
     * 粮食安全行政首长责任制----重点考核事项---保存
     * @param itemVO
     * @return
     */
    boolean save(ItemSaveVO itemSaveVO);

    /**
     * 粮食安全行政首长责任制----重点考核事项---编辑
     * @param itemUpdateVO
     * @return
     */
    boolean update(ItemUpdateVO itemUpdateVO);

    /**
     * 粮食安全行政首长责任制----重点考核事项---批量删除
     * @param deleteVO
     * @return
     */
    Boolean deletes(DeleteVO deleteVO);

    /**
     * 粮食安全行政首长责任制----重点考核事项---分页
     * @param itemVO
     * @param page
     * @param size
     * @return
     */
    PageInfo<List<Map>> findByPage(ItemPage itemPage, Integer page, Integer size);

    /**
     * 粮食安全行政首长责任制----重点考核事项---是否右以编辑
     * @param id
     * @return
     */
    public List<Map> findIfRelease(String id);

    /**
     * 粮食安全行政首长责任制----重点考核事项---根据年份year和组织机构 orgId 查询重点考核事项
     * @param map
     * @return
     */
    List<Map> findByYearAndOrgId(Map map);

    /**
     * 粮食安全行政首长责任制----考核评分表管理----重点考核事项
     * @param contentId
     * @param itemExcelVO
     * @param responsibilityId
     * @param saveVO
     * @return
     */
    BizRespExaminationItem getItemData(String contentId, BizRespExaminationItemExcelVO itemExcelVO, String responsibilityId, SaveVO saveVO);

    /**
     * 粮食安全行政首长责任制----考核评分表管理----重点考核事项
     * @param countId
     */
    List<BizRespExaminationItemExcelVO> findByItemList(String countId);


    List<BizRespExaminationItemExcelVO> findByItemExcel(AreeExcelVO areeExcelVO);
}