package com.unis.accountability.businessmanagement.service;

import com.github.pagehelper.PageInfo;
import com.unis.accountability.businessmanagement.common.vo.DeleteVO;
import com.unis.accountability.businessmanagement.common.vo.SaveVO;
import com.unis.accountability.businessmanagement.common.vo.examinationExcel.AreeExcelVO;
import com.unis.accountability.businessmanagement.common.vo.examinationExcel.BizRespExaminationQuotaExcelVO;
import com.unis.accountability.businessmanagement.common.vo.examinationQuota.QuotaSaveVO;
import com.unis.accountability.businessmanagement.common.vo.examinationQuota.QuotaUPdateVO;
import com.unis.accountability.businessmanagement.common.vo.examinationQuota.QutoaPage;
import com.unis.accountability.businessmanagement.entity.BizRespExaminationQuota;

import java.util.List;
import java.util.Map;

/**
 * @Auther:张新亮
 * @Date: 2019/9/18 0018 16:34
 * @Description:
 */
public interface BizRespExaminationQuotaService {
    /**
     * 粮食安全省长责任制--考核指标----保存
     * @param quotaVO
     * @return
     */
    boolean save(QuotaSaveVO quotaVO);

    /**
     * 粮食安全省长责任制--考核指标----分页
     * @param quotaVO
     * @param page
     * @param size
     * @return
     */
    PageInfo<List<Map>> findByPage(QutoaPage qutoaPage, Integer page, Integer size);


    /**
     * 粮食安全省长责任制--考核指标----是否可以修改
     * @param id
     * @return
     */
    public List<Map> findIfRelease(String id);

    /**
     * 粮食安全省长责任制--考核指标----根据年份year和组织机构 orgId 查询重点考核事项
     * @param map
     * @return
     */
    List<Map> findByYearAndOrgId(Map map);

    /**
     * 粮食安全省长责任制--考核指标----编辑
     * @param quotaUPdateVO
     * @return
     */
    boolean update(QuotaUPdateVO quotaUPdateVO);

    /**
     * 粮食安全省长责任制--考核指标----批量删除
     * @param deleteVO
     * @return
     */
    Boolean deletes(DeleteVO deleteVO);

    /**
     * 粮食安全行政首长责任制----考核评分表管理----考核指标
     * @param itemId
     * @param quotaExcelVO
     * @param responsibilityId
     * @param saveVO
     * @return
     */
    BizRespExaminationQuota getQutoaData(String itemId, BizRespExaminationQuotaExcelVO quotaExcelVO, String responsibilityId, SaveVO saveVO);

    /**
     * 粮食安全省长责任制--考核指标----集合
     * @param id
     * @return
     */
    List<BizRespExaminationQuotaExcelVO> findByQuotaList(String itemId);


    List<BizRespExaminationQuotaExcelVO> findByQuotaExcel(AreeExcelVO areeExcelVO);
}