package com.unis.accountability.businessmanagement.service;

import com.github.pagehelper.PageInfo;
import com.unis.accountability.businessmanagement.common.vo.DeleteVO;
import com.unis.accountability.businessmanagement.common.vo.SaveVO;
import com.unis.accountability.businessmanagement.common.vo.cityZpbm.CityZpbmPage;
import com.unis.accountability.businessmanagement.common.vo.examinationExcel.AreeExcelVO;
import com.unis.accountability.businessmanagement.common.vo.examinationExcel.BizRespExaminationTaskExcelVO;
import com.unis.accountability.businessmanagement.common.vo.examinationTask.*;
import com.unis.accountability.businessmanagement.entity.BizRespExaminationTask;

import java.util.List;
import java.util.Map;

/**
 * @Auther:张新亮
 * @Date: 2019/9/18 0018 17:08
 * @Description:
 */
public interface BizRespExaminationTaskService {
    /**
     * 粮食安全省长责任制--考核目标任务---查询可填分数
     * @param map
     * @return
     */
    Map findBySorce(Map map);

    /**
     * 粮食安全省长责任制--考核目标任务---保存
     * @param  taskSaveVO
     * @return
     */
    boolean save(TaskSaveVO taskSaveVO);

    /**
     * 粮食安全省长责任制--考核目标任务---根据id查询考核目标任务--明细
     * @param id
     * @return
     */
    BizRespExaminationTaskVO findById(String id);

    /**
     * 粮食安全省长责任制--考核目标任务---编辑
     * @param taskVO
     * @return
     */
    boolean update(TaskUpdateVO taskUpdateVO);

    /**
     * 粮食安全省长责任制--考核目标任务---批量删除
     * @param deleteVO
     * @return
     */
    Boolean deletes(DeleteVO deleteVO);

    /**
     * 粮食安全省长责任制--考核目标任务---分页
     * @param taskVO
     * @param page
     * @param size
     * @return
     */
    PageInfo<List<Map>> findByPage(TaskPageVO taskVO, Integer page, Integer size);

    /**
     * 粮食安全省长责任制--考核目标任务---根据id查询考核目标任务--明细--牵头部门配合部门部门和自评部门专用
     * @param id
     * @return
     */
    TaskInfoVO findByTaskInfo(String id);

    /**
     * 粮食安全行政首长责任制----考核评分表管理----考核目标任务
     * @param quotaId
     * @param taskExcelVO
     * @param responsibilityId
     * @param saveVO
     */
    void getTaskData(String quotaId, BizRespExaminationTaskExcelVO taskExcelVO, String responsibilityId, SaveVO saveVO);

    List<BizRespExaminationTaskExcelVO> findByTaskList(String quotaId);
    String getTaskIdByInputId(String id);
    /**
     * 粮食安全行政首长责任制----考核评分表管理----根据填报时间查询
     * @param id
     * @return
     */
    List<BizRespExaminationTask> findBybilityId(String id);
    List<BizRespExaminationTaskVO> findVOBybilityId(String id);

    /**
     * 粮食安全行政首长责任制--区自评查看（区粮办）---导出
     * @param cityZpbmPage
     * @return
     */
    List<BizRespExaminationTaskExcelVO> findByTaskExcel(AreeExcelVO areeExcelVO);

    BizRespExaminationTaskVO findByInputId(String id);

    /**
     * 批量发布
     * @param orgName
     */
    void publishAll(String orgName);

    /**
     * 粮食安全省长责任制--考核目标任务---根据填报设置ID查询所有考核任务
     * @param bizRespResponsiBilityId
     * @return
     */
	List<BizRespExaminationTask> findTaskListByResponsiBilityId(String bizRespResponsiBilityId);
}