package com.unis.accountability.businessmanagement.service;

import com.github.pagehelper.PageInfo;
import com.unis.accountability.businessmanagement.common.vo.cityPhbm.CityPhbmPageVO;
import com.unis.accountability.businessmanagement.common.vo.cityTaskDistribution.CityTaskPublishVO;
import com.unis.accountability.businessmanagement.common.vo.provinceTask.*;
import com.unis.accountability.businessmanagement.entity.BizRespExaminationTask;

import java.util.List;
import java.util.Map;

/**
 * @Auther:张新亮
 * @Date: 2019/9/23 0023 14:15
 * @Description:
 */
public interface BizRespProvinceTaskService  {

    /**
     * "粮食安全行政首长责任制----省级任务考查询(省考核办)----分页
     * @param provinceTaskPage
     * @param page
     * @param size
     * @return
     */
    PageInfo<List<ProvincePageVO>> findByPage(ProvinceTaskPage provinceTaskPage, Integer page, Integer size);

    /**
     * 粮食安全行政首长责任制----省级任务考查询(省考核办)----州市考核明细
     * @param provinceTaskPage
     * @param page
     * @param size
     * @return
     */
    PageInfo<List<ProvinceCityPageVO>> findCityByPage(ProvinceCityTaskPage provinceTaskPage, Integer page, Integer size);

    /**
     * 粮食安全行政首长责任制----省级任务考查询(省考核办)---驳回
     * @param taskId
     * @param shiAreaCode
     * @return
     */
    boolean saveReappraisal(String taskId, String shiAreaCode);

    /**
     * 粮食安全行政首长责任制----省级任务考查询(省考核办)---省级配合部门和牵头部门评价明细
     * @param taskId
     * @param shiAreaCode
     * @return
     */
    ProvinceTaskVO findByProvinceQtbmAndPhbm(String taskId, String shiAreaCode);



    /**
     * 粮食安全行政首长责任制----省级任务考查询(省考核办)---提交
     * @param provinceCityTaskPage
     */
    void publish(ProvinceCityTaskPage provinceCityTaskPage);

    /**
     * 统计 区牵头部门 市牵头部门 抽查牵头部门分值
     * @param map
     * @param bilityId
     * @param areaCode
     * @param type
     */
    void findByOpionScore(Map map, String bilityId, String areaCode,String year, String type, String status);

    /**
     *
     * @param map
     * @param bilityId
     * @param areaCode
     * @param year
     */
    void findByOpionHzScore(Map map,String bilityId, String areaCode, String year,Integer resultStatus);

    /**
     * 计算比例
     * @param total
     * @param wsb
     * @return
     */
    String getProportion(Integer total, Integer wsb);

    /**
     * 查询考核任务是否考核分发
     * @param cityTaskPublishVO
     * @return
     */
    List<BizRespExaminationTask> findByIsKhff(CityTaskPublishVO cityTaskPublishVO);

    /**
     * 粮食安全行政首长责任制----考核结果查看（市局)---抽查分发
     * @param provinceCityTaskPage
     */
    void publishCcFf(List<ProvinceCityTaskPage> provinceCityTaskPage);

    /**
     * 粮食安全行政首长责任制----结果汇总查看（市局)----分页
     * @param provinceTaskPage
     * @param page
     * @param size
     * @return
     */
    PageInfo<List<ProvincePageVO>> findByHzPage(ProvinceTaskPage provinceTaskPage, Integer page, Integer size);

}