package com.unis.accountability.businessmanagement.service;

import com.github.pagehelper.PageInfo;
import com.unis.accountability.businessmanagement.common.vo.DeleteVO;
import com.unis.accountability.businessmanagement.common.vo.examinationExcel.BizRespExcelSaveNewVO;
import com.unis.accountability.businessmanagement.common.vo.examinationExcel.BizRespExcelSaveVO;
import com.unis.accountability.businessmanagement.common.vo.responsibility.*;
import com.unis.accountability.businessmanagement.entity.BizRespResponsibility;

import java.util.List;
import java.util.Map;

/**
 * @Auther:张新亮
 * @Date: 2019/9/18 0018 11:09
 * @Description:
 */
public interface BizRespResponsibilityService {
    /**
     * 考核评分表管理---分页查询
     * @param pageVO
     * @param page
     * @param size
     * @return
     */
    PageInfo<List<Map>> findByPage(BizRespResponsibilityPageVO pageVO, Integer page, Integer size);



    /**
     * 根据评分表名称查询数据是否存在
     * @param pfbmc
     * @return
     */
    Map findByPfbmc(BizRespResponsibilityPfbmcVO pfbmcVO);


    /**
     * 考核评分表管理---保存
     * @param bilitySaveVO
     * @return
     */
    boolean save(BilitySaveVO bilitySaveVO);



    /**
     * 考核评分表管理------根据年份year和组织机构和ID查询基本信息
     * @param map
     * @return
     */
    BizRespResponsibilityVO findByYearAndOrgId(Map map);


    /**
     * 考核评分表管理---删除责任考核
     * @param deleteVO
     * @return
     */
    Boolean deletes(DeleteVO deleteVO);


    /**
     * 考核评分表管理---发布
     * @param publishVO
     * @return
     */
    String publish(BizRespResponsibilitPublishVO publishVO);

    /**
     * 考核评分表管理---下级州市
     * @param cityVO
     * @return
     */
    List<String> findByRespResponsibilityCity(BizRespResponsibilityCityVO cityVO);

    /**
     * 考核评分表管理------根据ID查询基本信息
     * @param id
     * @return
     */
    BizRespResponsibilityVO findByInfo(String id);

    /**
     * 考核评分表管理---更新评分表
     * @param updateVO
     * @return
     */
    String updatePfb(BizRespResponsibilityUpdateVO updateVO);

    /**
     * 考核评分表管理----根据id查询明细
     * @param id
     * @return
     */
    BizRespResponsibilityVO findByIds(String id);

    /**
     * 考核评分表管理---下发评表明细
     * @param pageVO
     * @return
     */
    Map bizRespResponsibilityService(BizRespResponsibilityPageVO pageVO);

    /**
     * 考核评分表管理---复制评分表
     * @param copyPfbVO
     * @return
     */
    boolean saveCopyPfb(BizRespCopyPfbVO copyPfbVO);

    /**
     * 考核评分表管理---编辑修改评分表名称
     * @param bilityUpdateVO
     * @return
     */
    boolean update(BilityUpdateVO bilityUpdateVO);

    /**
     * 考核评分表管理---保存填报信息
     * @param year
     * @param pfbmc
     * @return
     */
    BizRespResponsibility saveCheckExcelData(BizRespExcelSaveVO excelSaveVO);

    BizRespResponsibility saveCheckExcelData(BizRespExcelSaveNewVO excelSaveVO);

    /**
     * 考核评分表管理------根据年分查询基本信息
     * @param year
     * @return
     */
    BizRespResponsibilityVO findByYear(String year);
}




