package com.unis.accountability.businessmanagement.service;

import com.github.pagehelper.PageInfo;
import com.unis.accountability.businessmanagement.common.vo.cityTaskDistribution.CityTaskPublishVO;
import com.unis.accountability.businessmanagement.common.vo.cityZpbm.ZpbmVO;
import com.unis.accountability.businessmanagement.common.vo.provinceTask.ProvinceTaskPage;
import com.unis.accountability.businessmanagement.common.vo.respScoreInput.BizRespRespScoreInputPublishVO;
import com.unis.accountability.businessmanagement.common.vo.respScoreInput.BizRespScoreInputSmiitVO;
import com.unis.accountability.businessmanagement.common.vo.respScoreInput.BizRespScoreInputVO;
import com.unis.accountability.businessmanagement.common.vo.responsibility.BizRespResponsibilityPageVO;
import com.unis.accountability.businessmanagement.entity.BizRespScoreInput;

import java.util.List;
import java.util.Map;

/**
 * @Auther:张新亮
 * @Date: 2019/9/19 0019 15:44
 * @Description:
 */
public interface BizRespScoreInputService {
    /**
     * 粮食安全首长责任制--下发州市考核任务----发布
     * @param inputPublishVO
     */
    String publish(BizRespRespScoreInputPublishVO inputPublishVO);

    /**
     * 粮食安全首长责任制--州市考核任务管理  根据年分 状态 行政区划 查询 州市考核录入数据
     * @param cityTaskPublishVO
     * @return
     */
    List<BizRespScoreInputVO> findByYearAndStatusAndAreaCode(CityTaskPublishVO cityTaskPublishVO);

    /**
     * 粮食安全首长责任制--下发州市考核任务----保存上传文件
     * @param id
     * @param zpbmVO
     */
    void saveFile(String id, ZpbmVO zpbmVO);

    /**
     * 粮食安全首长责任制--下发州市考核任务----制定州市考核任务--- 分页查询
     * @param pageVO
     * @param page
     * @param size
     * @return
     */
    PageInfo<List<Map>> findTaskByPage(BizRespResponsibilityPageVO pageVO, Integer page, Integer size);

    /**
     * 州市、外部单位牵头部门、配合部门评分--查询是否可以提交数据
     * @param scoreInputSmiitVO
     * @return
     */
    String findByIsSubmit(BizRespScoreInputSmiitVO scoreInputSmiitVO);

    /**
     * 结果汇总发布
     * @param provinceTaskPage
     */
    void updateByArea(ProvinceTaskPage provinceTaskPage);

}