package com.unis.accountability.businessmanagement.service;

import com.github.pagehelper.PageInfo;
import com.unis.accountability.businessmanagement.common.vo.scoringCity.BizRespScoringCityPublishVO;
import com.unis.accountability.businessmanagement.common.vo.scoringCity.BizRespScoringCityVO;
import com.unis.accountability.businessmanagement.common.vo.scoringCity.ScoringCityUpdateVO;
import com.unis.accountability.businessmanagement.common.vo.scoringCity.ScoringPage;
import com.unis.accountability.businessmanagement.entity.BizRespScoringCity;

import java.util.List;
import java.util.Map;

/**
 * @Auther:张新亮
 * @Date: 2019/9/19 0019 18:44
 * @Description:
 */
public interface BizRespScoringCityService {
    /**
     * 粮食安全首长责任制--州市任务填报设置----分页
     * @param scoringPage
     * @param page
     * @param size
     * @return
     */
    PageInfo<List<Map>> findByPage(ScoringPage scoringPage, Integer page, Integer size);

    /**
     * 粮食安全首长责任制--州市任务填报设置----查看
     * @param id
     * @return
     */
    BizRespScoringCityVO findById(String id);

    /**
     * 粮食安全首长责任制--州市任务填报设置---编辑
     * @param scoringCityUpdateVO
     * @return
     */
    boolean update(ScoringCityUpdateVO scoringCityUpdateVO);

    /**
     * 粮食安全首长责任制--州市考核任务管理----发布
     * @param inputPublishVO
     */
    void publish(BizRespScoringCityPublishVO inputPublishVO);

    /**
     * 时间比较
     * @param scoringCity
     * @param type
     * @return
     */
    String weightCompareTo(BizRespScoringCity scoringCity, String type);

    /**
     * 粮食安全首长责任制--州市考核任务管理----根据年份和状态查贸易 州市任务填报设置 信怎
     * @param integer
     * @param status
     * @return
     */
    BizRespScoringCity findByYearAndStatus(String year, String status,String areaCode);

    /**
     * 粮食安全首长责任制--州市任务填报设置----根据年分查询明细
     * @param year
     * @param orgId
     * @return
     */
    BizRespScoringCityVO findByYearAndOrgId(String year, String orgId);
}