package com.unis.accountability.businessmanagement.service;

import com.github.pagehelper.PageInfo;
import com.unis.accountability.businessmanagement.common.vo.DeleteVO;
import com.unis.accountability.businessmanagement.common.vo.scoringWeight.*;
import com.unis.accountability.businessmanagement.entity.BizRespScoringWeight;

import java.util.List;
import java.util.Map;

/**粮食安全行政首长责任制-----考核评分权重
 * @Auther:张新亮
 * @Date: 2019/9/17 0017 15:18
 * @Description:
 */
public interface BizRespScoringWeightService {

    /**
     * 考核评分权重--考核等级设置
     * @param type  save  update
     * @param id
     * @return
     */
    List<BizRespScoringWeightRankVO> findByWeightRank(String type, String id);

    /**
     * 考核评分权重--考核等级设置
     * @param type save 新增 page 分页查询
     * @return
     */
    List<Integer> findByAll(String type);


    /**
     * 考核评分权重--查询复制评分表可选年分
     * @param year
     * @return
     */
    Map findByCopyYear();

    /**
     * 考核评分权重----根据年分和状态---考核评分权重--对象
     * @param year
     * @param status
     * @return
     */
    BizRespScoringWeight findByYearAndStatus(Integer year, Integer status);

    /**
     * 考核评分权重-----保存
     * @param weightSaveVO
     * @return
     */
    boolean save(WeightSaveVO weightSaveVO);

    /**
     * 考核评分权重------分页查询
     * @param pageVO
     * @param page
     * @param size
     * @return
     */
    PageInfo<List<Map>> findByPage(BizRespScoringWeightPageVO pageVO, Integer page, Integer size);

    /**
     *  根据ID查询 考核评分权重 明细
     * @param id
     * @return
     */
    WeightInfoVO findById(String id);

    /**
     * 考核评分权重--考核等级
     * @param id
     * @return
     */
    List<BizRespScoringWeightRankVO> findByRankId(String id);

    /**
     * 核评分权重---修改
     * @param weightUpdateVO
     * @return
     */
    boolean update(WeightUpdateVO weightUpdateVO);

    /**
     * 核评分权重---发布
     * @param publishVO
     */
    void publish(BizRespScoringWeightPublishVO publishVO);

    Boolean delete(DeleteVO deleteVO);

    /**
     * 时间比较
     * @param weightDO
     * @param type
     * @return
     */
    String weightCompareTo(BizRespScoringWeight weightDO, String type);


    /**
     * 根据年分查询
     * @param year
     * @return
     */
    BizRespScoringWeight findByYear(Integer year);
}