package com.unis.accountability.businessmanagement.service;

import com.github.pagehelper.PageInfo;
import com.unis.accountability.businessmanagement.common.vo.DeleteVO;
import com.unis.accountability.businessmanagement.common.vo.msgNotice.*;

import java.util.List;
import java.util.Map;

/**
 * @Auther:张新亮
 * @Date: 2019/11/5 0005 14:36
 * @Description:
 */
public interface MsgNoticeService {
    /**
     * 信息报送----保存
     * @param msgNoticeSaveVO
     * @return
     */
    boolean save(MsgNoticeSaveVO msgNoticeSaveVO);

    /**
     * 信息报送----分页
     * @param msgNoticePage
     * @param page
     * @param size
     * @return
     */
    PageInfo<List<Map>> findByPage(MsgNoticePage msgNoticePage, Integer page, Integer size);

    /**
     * 信息报送---报送
     * @param publishVO
     */
    void publish(MsgNoticePublishVO publishVO);

    /**
     * 信息报送----查看
     * @param msgNoticeReadVO
     * @return
     */
    MsgNoticeVO findById(String id);

    /**
     * 信息报送----修改
     * @param msgNoticeUpdateVO
     * @return
     */
    boolean update(MsgNoticeUpdateVO msgNoticeUpdateVO);

    /**
     * 信息报送----删除
     * @param msgNoticeReadVO
     * @return
     */
    Boolean deletes(DeleteVO deleteVO);

    /**
     * 信息报送----查看
     * @param id
     * @return
     */
    MsgNoticeVO findByInfo(String id);

    /**
     * 信息报送---批量采用
     * @param publishVO
     */
    void publishALL(MsgNoticePublishVO publishVO);
}