package com.unis.accountability.businessmanagement.service;

import com.unis.accountability.businessmanagement.common.vo.examinationTask.BigTaskQueryVO;
import com.unis.accountability.businessmanagement.common.vo.examinationTask.BigTaskVO;
import com.unis.accountability.businessmanagement.common.vo.opinion.BizRespDepartmentalOpinionVO;

import java.util.List;
import java.util.Map;

/**
 * @Author zoujieli
 * @Description
 * @Date 2019/9/20 18:27
 * Version 1.0
 */
public interface ProvinceLeadDeptService {

    /**
     * 盟市长责任制--省级牵头部门--条件分页查询
     * @author 邹杰利
     * @param bigTaskQueryVO
     * @param pageNum
     * @param pageSize
     * @return
     */
    Map getProvinceLeadDept(BigTaskQueryVO bigTaskQueryVO, Integer pageNum, Integer pageSize);

    /**
     * 盟市长责任制--省级牵头部门--根据任务id查询详情
     * @author 邹杰利
     * @param id
     * @return
     */
    BigTaskVO getProvinceLeadDeptDetail(String id);

    /**
     * 盟市长责任制--省级牵头部门--更新省级牵头部门评分
     * @author 邹杰利
     * @param bizRespDepartmentalOpinionVO
     */
    void updateBizRespDepartmentalOpinion(BizRespDepartmentalOpinionVO bizRespDepartmentalOpinionVO);

    /**
     * 盟市长责任制--省级牵头部门--根据任务id查询省级配合部门意见
     * @author 邹杰利
     * @param selectMap
     * @return
     */
    List<BizRespDepartmentalOpinionVO> getProvinceCoordinateOpinion(Map selectMap);

    /**
     * 盟市长责任制--省级牵头部门--根据任务id查询省级牵头部门意见
     * @author 邹杰利
     * @param selectMap
     * @return
     */
    BizRespDepartmentalOpinionVO getProvinceLeadOpinion(Map selectMap);

    /**
     * 盟市长责任制--省级牵头部门--新增省级牵头部门复评分
     * @author 邹杰利
     * @param bizRespDepartmentalOpinionVO
     */
    void insertProvinceLeadOpinion(BizRespDepartmentalOpinionVO bizRespDepartmentalOpinionVO);

    /**
     * 省级牵头/配合部门--上报
     * @author 邹杰利
     * @param selectMap
     */
    void updateTaskStatus(Map selectMap);

    /**
     * 省级配合部门--上报
     * @author 邹杰利
     * @param oids
     */
    //void updateProvinceCoordinateOpinionStatus(String oids);

    /**
     * 根据任务id查询省级牵头部门复评意见
     * @author 邹杰利
     * @param resultMap
     * @return
     */
    BizRespDepartmentalOpinionVO getProvinceLeadAgainOpinion(Map<String, Object> resultMap);
}
