package com.unis.accountability.businessmanagement.service.impl;

import com.github.pagehelper.Page;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;

import com.unis.accountability.businessmanagement.common.vo.cityQtbm.*;
import com.unis.accountability.businessmanagement.common.vo.cityZpbm.CityZpbmPublishVO;
import com.unis.accountability.businessmanagement.common.vo.cityZpbm.publishAllVO;
import com.unis.accountability.businessmanagement.common.vo.examinationTask.BizRespExaminationTaskVO;
import com.unis.accountability.businessmanagement.common.vo.provinceTask.ProvinceCityTaskPage;
import com.unis.accountability.businessmanagement.common.vo.responsibility.BizRespResponsibilityVO;
import com.unis.accountability.businessmanagement.entity.*;
import com.unis.accountability.businessmanagement.mapper.BizRespCityZpbmServiceMapper;
import com.unis.accountability.businessmanagement.mapper.BizRespDepartmentalOpinionMapper;
import com.unis.accountability.businessmanagement.mapper.BizRespExaminationTaskMapper;
import com.unis.accountability.businessmanagement.mapper.BizRespScoreInputMapper;
import com.unis.accountability.businessmanagement.service.*;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;

/**
 * @Auther:张新亮
 * @Date: 2019/9/21 0021 14:57
 * @Description:
 */
@Service
@Transactional
public class BizRespCityQtbmServiceImpl implements BizRespCityQtbmService {
    @Autowired
    private BizRespCityZpbmServiceMapper bizRespCityZpbmServiceMapper;
    @Autowired
    private BizRespScoreInputMapper bizRespScoreInputMapper;
    @Autowired
    private BizRespDepartmentalOpinionService bizRespDepartmentalOpinionService;
    @Autowired
    private BizRespDepartmentalOpinionMapper bizRespDepartmentalOpinionMapper;
    @Autowired
    private BizRespProvinceTaskService bizRespProvinceTaskService;
    @Autowired
    private BizRespResponsibilityService bizRespResponsibilityService;
    @Autowired
    private BizRespExaminationTaskService bizRespExaminationTaskService;
    @Autowired
    private BizRespScoringWeightService bizRespScoringWeightService;
    @Autowired
    private BizRespExaminationTaskMapper bizRespExaminationTaskMapper;
    /**
     * 粮食安全行政首长责任制----市级牵头部门----分页
     * @param cityQtbmPage
     * @param page
     * @param size
     * @return
     */
    @Override
    public PageInfo<List<CityQtbmPageVO>> findByPage(
            CityQtbmPage cityQtbmPage,
            Integer page,
            Integer size
    ) {
        System.out.println("接口参数=="+cityQtbmPage.toString());
        Page<List<CityQtbmPageVO>> listPage = PageHelper.startPage(page, size);
        List<CityQtbmPageVO> mapLists=bizRespCityZpbmServiceMapper.findByQtbmPage(cityQtbmPage);
        String ifpf="no";
        for(CityQtbmPageVO cityPhbmPageVO:mapLists){
            BizRespScoringWeight bizRespScoringWeight=bizRespScoringWeightService.findByYearAndStatus(Integer.valueOf(cityPhbmPageVO.getYear()), 1);
            if(bizRespScoringWeight!=null){
                ifpf= bizRespScoringWeightService.weightCompareTo(bizRespScoringWeight, "qjQtbm");
            }
            cityPhbmPageVO.setIfPf(ifpf);
            //查询市级配合部门和自评部门是否已评完分
            Map mapList=getCityInfo(cityPhbmPageVO);
            cityPhbmPageVO.setMap(mapList);
        }

        return listPage.toPageInfo();
    }

    private Map getCityInfo(CityQtbmPageVO cityPhbmPageVO) {
        List<String> zpbmList=new ArrayList();
        List<String> phbmList=new ArrayList();
        List<BizRespDepartmentalOpinion> opinionList= bizRespDepartmentalOpinionService.findByProvinceScore(cityPhbmPageVO.getTaskId(), cityPhbmPageVO.getAreaCode());
//        for(BizRespDepartmentalOpinion opinion:opinionList){
//            if("30".equals(opinion.getType())){
//                if("10".equals(opinion.getStatus()) || "20".equals(opinion.getStatus())){
//                    zpbmList.add(opinion.getDeptId());
//                }
//            }
//        }
        for(BizRespDepartmentalOpinion opinion:opinionList){
            if("40".equals(opinion.getType())){
                if("10".equals(opinion.getStatus()) || "20".equals(opinion.getStatus())){
                    phbmList.add(opinion.getDeptId());
                }
            }
        }

        Map map=new HashMap();
        map.put("zpbmList",zpbmList);
        map.put("phbmList",phbmList);
        return map;

    }

    /**
     * 粮食安全行政首长责任制----市级牵头部门----查看
     * @param id
     * @return
     */
    @Override
    public QtbmVO findById(String id,String  deptId) {
        BizRespScoreInput bizRespScoreInput=bizRespScoreInputMapper.selectByPrimaryKey(id);
//        bizRespScoreInput.setQtbm(deptId);
        QtbmVO qtbmVO=bizRespDepartmentalOpinionService.findByQtbmInfo(bizRespScoreInput);
        qtbmVO.setOrgId(bizRespScoreInput.getOrgId());
        return qtbmVO;
    }

    /**
     * 粮食安全行政首长责任制----市级牵头部门---编辑
     * @param qtbmUpdateVO
     * @return
     */
    @Override
    @Transactional(isolation = Isolation.READ_COMMITTED,rollbackFor = Exception.class)
    public boolean update(QtbmUpdateVO qtbmUpdateVO) {
        System.out.println("接口参数==" + qtbmUpdateVO.toString());
        return bizRespDepartmentalOpinionService.updateQtbm(qtbmUpdateVO);
    }

    /**
     * 粮食安全行政首长责任制----市级牵头部门---提交
     * @param cityZpbmPublishVO
     */
    @Override
    @Transactional(isolation = Isolation.READ_COMMITTED,rollbackFor = Exception.class)
    public void publish(CityZpbmPublishVO cityZpbmPublishVO) {
        System.out.println("接口参数=="+cityZpbmPublishVO.toString());
        BizRespScoreInput bizRespScoreInput=bizRespScoreInputMapper.selectByPrimaryKey(cityZpbmPublishVO.getId());
        String id=bizRespScoreInput.getId();
        String areaCode=bizRespScoreInput.getAreaCode();
        String deptId=cityZpbmPublishVO.getDeptId();
        if(bizRespScoreInput.getResultStatus()==1){
            throw new RuntimeException("考核结果已发布，不允许自评");
        }
        String type="50";
        BizRespDepartmentalOpinion opinion=bizRespDepartmentalOpinionMapper.findByCityInfo(id, areaCode, deptId, type);
        opinion.setStatus("30");
        opinion.setUpdateBy(cityZpbmPublishVO.getUpdateBy());
        opinion.setUpdateTime(new Date());
        bizRespDepartmentalOpinionMapper.updateByPrimaryKeySelective(opinion);
        bizRespScoreInput.setStatus("3");
        bizRespScoreInputMapper.updateByPrimaryKeySelective(bizRespScoreInput);


        //计算评分
        BizRespExaminationTaskVO bizRespExaminationTaskVO=bizRespExaminationTaskService.findById(bizRespScoreInput.getBizResexaminationTaskId());
        BizRespResponsibilityVO bizRespResponsibilityVO=bizRespResponsibilityService.findByIds(bizRespExaminationTaskVO.getBizRespResponsibilityId());
        ProvinceCityTaskPage provinceCityTaskPage=new ProvinceCityTaskPage();
        provinceCityTaskPage.setAreaCode(areaCode);
        provinceCityTaskPage.setYear(String.valueOf(bizRespResponsibilityVO.getYear()));
        provinceCityTaskPage.setBizRespResponsibilityId(bizRespExaminationTaskVO.getBizRespResponsibilityId());
        bizRespProvinceTaskService.publish(provinceCityTaskPage);



    }

    /**
     * 粮食安全行政首长责任制----市级牵头部门---批量提交
     * @param cityZpbmPublishVO
     */
    @Override
    @Transactional(isolation = Isolation.READ_COMMITTED,rollbackFor = Exception.class)
    public void publishALL(CityZpbmPublishVO cityZpbmPublishVO) {
        System.out.println("接口参数=="+cityZpbmPublishVO.toString());
        //查询州市自评部门已填报的数据
        List<publishAllVO> publishAllVOList=bizRespCityZpbmServiceMapper.findByQtbmYearAndDeptId(cityZpbmPublishVO);
        for(publishAllVO publishAllVO:publishAllVOList){
            BizRespDepartmentalOpinion opinion=bizRespDepartmentalOpinionMapper.selectByPrimaryKey(publishAllVO.getOpinionId());
            opinion.setStatus("30");
            opinion.setUpdateBy(cityZpbmPublishVO.getUpdateBy());
            opinion.setUpdateTime(new Date());
            bizRespDepartmentalOpinionMapper.updateByPrimaryKeySelective(opinion);
            BizRespScoreInput bizRespScoreInput=bizRespScoreInputMapper.selectByPrimaryKey(opinion.getBizRespScoreInputId());
            bizRespScoreInput.setStatus("3");
            bizRespScoreInputMapper.updateByPrimaryKeySelective(bizRespScoreInput);

            //计算评分
            BizRespExaminationTaskVO bizRespExaminationTaskVO=bizRespExaminationTaskService.findById(bizRespScoreInput.getBizResexaminationTaskId());
            BizRespResponsibilityVO bizRespResponsibilityVO=bizRespResponsibilityService.findByIds(bizRespExaminationTaskVO.getBizRespResponsibilityId());
            ProvinceCityTaskPage provinceCityTaskPage=new ProvinceCityTaskPage();
            provinceCityTaskPage.setAreaCode(publishAllVO.getAreaCode());
            provinceCityTaskPage.setYear(String.valueOf(bizRespResponsibilityVO.getYear()));
            provinceCityTaskPage.setBizRespResponsibilityId(bizRespExaminationTaskVO.getBizRespResponsibilityId());
            bizRespProvinceTaskService.publish(provinceCityTaskPage);

        }




    }

    /**
     * 粮食安全行政首长责任制----市级牵头部门---根据年份部门状态查询明细
     * @param cityQtbmPage
     * @return
     */
    @Override
    public List<CityQtbmPageVO> fidByYearAndDeptIdAndStatus(CityQtbmPage cityQtbmPage) {
        System.out.println("接口参数=="+cityQtbmPage.toString());
        return bizRespCityZpbmServiceMapper.findByQtbmPage(cityQtbmPage);
    }


    /**
     * 粮食安全行政首长责任制----市级牵头部门----根据taskId和行政区划查询查看
     * @param taskId
     * @param areaCode
     * @return
     */
    @Override
    public QtbmVO findByTaskIdAndAreaCode(String taskId, String areaCode) {
        BizRespScoreInput bizRespScoreInput=bizRespScoreInputMapper.findByTaskIdAndAreaCode(taskId, areaCode);
        QtbmVO qtbmVO=new QtbmVO();
        if(StringUtils.isNotEmpty(bizRespScoreInput.getQtbm())){
            String[] deptId=bizRespScoreInput.getQtbm().split(",");
            bizRespScoreInput.setQtbm(deptId[0]);
            qtbmVO=bizRespDepartmentalOpinionService.findByQtbmInfo(bizRespScoreInput);
            qtbmVO.setOrgId(bizRespScoreInput.getOrgId());
        }
        return qtbmVO;
    }


    /**
     * 粮食安全行政首长责任制----区级牵头部门 和配合部门----根据taskId和行政区划查询查看
     * @param taskId
     * @param areaCode
     * @return
     */
    @Override
    public  CityTaskinfoVO findByAreaList(String taskId, String areaCode) {
        CityTaskinfoVO cityTaskinfoVO=new CityTaskinfoVO();
        BizRespScoreInput bizRespScoreInput=bizRespScoreInputMapper.findByTaskIdAndAreaCode(taskId, areaCode);
        BizRespExaminationTask bizRespExaminationTask= bizRespExaminationTaskMapper.selectByPrimaryKey(taskId);
        cityTaskinfoVO.setCityQtbm(bizRespExaminationTask.getLeadDepartment());
        cityTaskinfoVO.setCityPhbm(bizRespExaminationTask.getCoordinationDepartment());
        cityTaskinfoVO.setCityAreaCode(bizRespExaminationTask.getAreaCode());
        cityTaskinfoVO.setPhbm(bizRespScoreInput.getPhbm());
        cityTaskinfoVO.setQtbm(bizRespScoreInput.getQtbm());
        cityTaskinfoVO.setAreaCode(bizRespScoreInput.getAreaCode());
        List<QtbmOpionVO> qtbmOpionVOs=new ArrayList();
        //区牵头部门
        if(StringUtils.isNotEmpty(bizRespScoreInput.getQtbm())){
            String[] deptId=bizRespScoreInput.getQtbm().split(",");
            bizRespScoreInput.setQtbm(deptId[0]);
            QtbmOpionVO  opionVO=bizRespDepartmentalOpinionService.findByAreaQtbmInfo(bizRespScoreInput,"50");
            qtbmOpionVOs.add(opionVO);
        }
        //区配合部门
        if(StringUtils.isNotEmpty(bizRespScoreInput.getPhbm())){
            String[] deptList=bizRespScoreInput.getPhbm().split(",");
            for(String deptId:deptList){
                bizRespScoreInput.setPhbm(deptId);
                QtbmOpionVO  opionVO= bizRespDepartmentalOpinionService.findByAreaPhbmInfo(bizRespScoreInput,"40");
                qtbmOpionVOs.add(opionVO);
            }
        }

        List<QtbmOpionVO> cityVOList=new ArrayList();

        //市牵头部门
        if(StringUtils.isNotEmpty(bizRespExaminationTask.getLeadDepartment())){
            String[] deptId=bizRespExaminationTask.getLeadDepartment().split(",");
            bizRespScoreInput.setQtbm(deptId[0]);
            bizRespScoreInput.setId(bizRespExaminationTask.getId());
            QtbmOpionVO  opionVO=bizRespDepartmentalOpinionService.findByAreaQtbmInfo(bizRespScoreInput,"20");
            opionVO.setAreaCode(bizRespExaminationTask.getAreaCode());
            cityVOList.add(opionVO);
        }
        //市配合部门
        if(StringUtils.isNotEmpty(bizRespExaminationTask.getCoordinationDepartment())){
            String[] deptList=bizRespExaminationTask.getCoordinationDepartment().split(",");
            bizRespScoreInput.setId(bizRespExaminationTask.getId());
            for(String deptId:deptList){
                bizRespScoreInput.setPhbm(deptId);
                QtbmOpionVO  opionVO= bizRespDepartmentalOpinionService.findByAreaPhbmInfo(bizRespScoreInput,"10");
                opionVO.setAreaCode(bizRespExaminationTask.getAreaCode());
                cityVOList.add(opionVO);
            }
        }


        List<QtbmOpionVO> ccCityVOList=new ArrayList();

        //抽查--市牵头部门
        if(StringUtils.isNotEmpty(bizRespExaminationTask.getLeadDepartment())){
            String[] deptId=bizRespExaminationTask.getLeadDepartment().split(",");
            bizRespScoreInput.setQtbm(deptId[0]);
            bizRespScoreInput.setId(bizRespExaminationTask.getId());
            QtbmOpionVO  opionVO=bizRespDepartmentalOpinionService.findByAreaQtbmInfo(bizRespScoreInput,"60");
            if(opionVO!=null){
                opionVO.setAreaCode(bizRespExaminationTask.getAreaCode());
                ccCityVOList.add(opionVO);
            }

        }
        //抽查--市配合部门
        if(StringUtils.isNotEmpty(bizRespExaminationTask.getCoordinationDepartment())){
            String[] deptList=bizRespExaminationTask.getCoordinationDepartment().split(",");
            bizRespScoreInput.setId(bizRespExaminationTask.getId());
            for(String deptId:deptList){
                bizRespScoreInput.setPhbm(deptId);
                QtbmOpionVO  opionVO= bizRespDepartmentalOpinionService.findByAreaPhbmInfo(bizRespScoreInput,"70");
                if(opionVO!=null){
                    opionVO.setAreaCode(bizRespExaminationTask.getAreaCode());
                    ccCityVOList.add(opionVO);
                }
            }
        }
        cityTaskinfoVO.setCcCityVOList(ccCityVOList);
        cityTaskinfoVO.setCityVOList(cityVOList);
        cityTaskinfoVO.setOpionVOList(qtbmOpionVOs);
        return cityTaskinfoVO;
    }


}