package com.unis.accountability.businessmanagement.service.impl;

import com.github.pagehelper.Page;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.unis.accountability.businessmanagement.common.vo.cityFf.*;
import com.unis.accountability.businessmanagement.common.vo.cityPhbm.CityPhbmPageVO;
import com.unis.accountability.businessmanagement.common.vo.cityZpbm.CityZpbmPublishVO;
import com.unis.accountability.businessmanagement.common.vo.examinationTask.TaskInfoVO;
import com.unis.accountability.businessmanagement.common.vo.provincePhbm.ProvincePhbmPublishVO;
import com.unis.accountability.businessmanagement.common.vo.respScoreInput.BizRespScoreInputSmiitVO;
import com.unis.accountability.businessmanagement.entity.*;
import com.unis.accountability.businessmanagement.mapper.*;
import com.unis.accountability.businessmanagement.service.BizRespCityTaskfFService;
import com.unis.accountability.businessmanagement.service.BizRespScoringWeightService;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * @Auther:张新亮
 * @Date: 2019/12/13 0013 10:17
 * @Description:
 */
@Service
@Transactional
public class BizRespCityTaskfFServiceImpl implements BizRespCityTaskfFService {
    @Autowired
    private BizRespCityTaskfFMapper bizRespCityTaskfFMapper;
    @Autowired
    private BizRespScoringWeightService bizRespScoringWeightService;
    @Autowired
    private BizRespExaminationQuotaMapper bizRespExaminationQuotaMapper;
    @Autowired
    private BizRespExaminationItemMapper bizRespExaminationItemMapper;
    @Autowired
    private BizRespExaminationContentMapper bizRespExaminationContentMapper;
    @Autowired
    private BizRespExaminationTaskMapper bizRespExaminationTaskMapper;
    @Autowired
    private BizRespResponsibilityMapper bizRespResponsibilityMapper;
    @Autowired
    private BizRespDepartmentalOpinionMapper bizRespDepartmentalOpinionMapper;
    /**
     * 生产牵头部门数据
     * @param taskDO
     * @return
     */
    @Override
    public BizRespCityTaskfF getQtbmDate(BizRespExaminationTask taskDO) {
        BizRespCityTaskfF ff=new BizRespCityTaskfF();
        ff.setOrgId(taskDO.getLeadDepartment());
        ff.setBizRespExaminationTaskId(taskDO.getId());
        ff.setCreateTime(new Date());
        ff.setUpdateTime(new Date());
        ff.setBmType("20");
        ff.setStatus("10");
        return ff;
    }

    @Override
    public List<BizRespCityTaskfF> getPhbmDate(BizRespExaminationTask taskDO) {
        if(StringUtils.isNotEmpty(taskDO.getCoordinationDepartment())){
            List<BizRespCityTaskfF> result=new ArrayList();
            String[] phbmList =taskDO.getCoordinationDepartment().split(",");
            for(String phbm:phbmList){
                BizRespCityTaskfF ff=new BizRespCityTaskfF();
                ff.setCreateTime(new Date());
                ff.setUpdateTime(new Date());
                ff.setOrgId(phbm);
                ff.setBizRespExaminationTaskId(taskDO.getId());
                ff.setBmType("10");
                ff.setStatus("10");
                result.add(ff);
            }
            return result;
        }
        return null;

    }

    /**
     * 保存存分发数据
     * @param ffList
     */
    @Override
    @Transactional(isolation = Isolation.READ_COMMITTED,rollbackFor = Exception.class)
    public void save(List<BizRespCityTaskfF> ffList) {
        for(BizRespCityTaskfF ff:ffList){
            bizRespCityTaskfFMapper.insertSelective(ff);
        }
    }


    /**
     * 粮食安全省长责任制--评分表分处室考核（市部门）---分页
     * @param cityFfPage
     * @param page
     * @param size
     * @return
     */
    @Override
    public PageInfo<List<CityFfPageVO>> findByPage(CityFfPage cityFfPage, Integer page, Integer size) {
        Page<List<CityFfPageVO>> listPage = PageHelper.startPage(page, size);
        System.out.println("接口参数==" + cityFfPage.toString());
        List<CityFfPageVO> cityFfPageVOList=bizRespCityTaskfFMapper.findByPage(cityFfPage);
        String ifpf="no";
        for(CityFfPageVO cityFfPageVO:cityFfPageVOList){
            BizRespScoringWeight bizRespScoringWeight=bizRespScoringWeightService.findByYearAndStatus(Integer.valueOf(cityFfPageVO.getYear()), 1);
            if(bizRespScoringWeight!=null){
                ifpf= bizRespScoringWeightService.weightCompareTo(bizRespScoringWeight, "qjQtbm");
            }
            cityFfPageVO.setIfPf(ifpf);
        }
        return listPage.toPageInfo();
    }
    /**
     * 粮食安全省长责任制--评分表分处室考核（市部门）---分页
     * @param cityFfPage
     * @param page
     * @param size
     * @return
     */
    @Override
    public PageInfo<List<CityFfPageVO>> findByPageQu(CityFfPage cityFfPage, Integer page, Integer size) {
        Page<List<CityFfPageVO>> listPage = PageHelper.startPage(page, size);
        System.out.println("接口参数==" + cityFfPage.toString());
        List<CityFfPageVO> cityFfPageVOList=bizRespCityTaskfFMapper.findByPageQu(cityFfPage);
        return listPage.toPageInfo();
    }

    /**
     * 粮食安全行政首长责任制----评分表分处室考核（市部门）----查看
     * @param id
     * @return
     */
    @Override
    public TaskFfInfoVO findById(String id) {
        TaskFfInfoVO taskInfoVO=new TaskFfInfoVO();
        BizRespCityTaskfF cityTaskfF=bizRespCityTaskfFMapper.selectByPrimaryKey(id);
        BizRespExaminationTask task= bizRespExaminationTaskMapper.selectByPrimaryKey(cityTaskfF.getBizRespExaminationTaskId());
        taskInfoVO.setId(id);
        taskInfoVO.setDeptId(cityTaskfF.getDeptId());
        taskInfoVO.setDeptName(cityTaskfF.getDeptName());
        taskInfoVO.setUserCode(cityTaskfF.getUserCode());
        taskInfoVO.setPfbz(task.getScoreStandard());
        taskInfoVO.setCityAreaCode(task.getAreaCode());
        taskInfoVO.setQtbm(task.getLeadDepartment());
        taskInfoVO.setPhbm(task.getCoordinationDepartment());
        /**
         * 评分依据
         */
        taskInfoVO.setPfyj(task.getPfyj());
        /**
         * 农业分值
         */
        taskInfoVO.setNyfz(task.getNyfz());
        /**
         * 非农业分值
         */
        taskInfoVO.setFnyfz(task.getFnyfz());
        /**
         * 考核方式
         */
        taskInfoVO.setKhfs(task.getKhfs());
        if (null != task.getBizRespExaminationQuotaId()){
            BizRespExaminationQuota quota=bizRespExaminationQuotaMapper.selectByPrimaryKey(task.getBizRespExaminationQuotaId());
            taskInfoVO.setKhzb(quota.getName());
            BizRespExaminationItem item=bizRespExaminationItemMapper.selectByPrimaryKey(quota.getBizRespExaminationItemId());
            taskInfoVO.setKhsx(item.getName());
            BizRespExaminationContent content=bizRespExaminationContentMapper.selectByPrimaryKey(item.getBizRespContentId());
            taskInfoVO.setKhnr(content.getName());
        }

        BizRespResponsibility bizRespResponsibility=bizRespResponsibilityMapper.selectByPrimaryKey(task.getBizRespResponsibilityId());
        taskInfoVO.setYear(String.valueOf(bizRespResponsibility.getYear()));
        return taskInfoVO;
    }


    /**
     * 粮食安全行政首长责任制----评分表分处室考核（市部门）---编辑
     * @param ffUpdateVO
     * @return
     */
    @Override
    @Transactional(isolation = Isolation.READ_COMMITTED,rollbackFor = Exception.class)
    public boolean update(FfUpdateVO ffUpdateVO) {
        BizRespCityTaskfF cityTaskfF=bizRespCityTaskfFMapper.selectByPrimaryKey(ffUpdateVO.getFfVO().getId());
        cityTaskfF.setDeptName(ffUpdateVO.getFfVO().getDeptName());
        cityTaskfF.setDeptId(ffUpdateVO.getFfVO().getDeptId());
        cityTaskfF.setUserCode(ffUpdateVO.getFfVO().getUserCode());
        cityTaskfF.setUpdateTime(new Date());
        cityTaskfF.setUpdateBy(ffUpdateVO.getUpdateBy());
        cityTaskfF.setStatus("20");
        bizRespCityTaskfFMapper.updateByPrimaryKeySelective(cityTaskfF);
        return true;
    }


    /**
     * 粮食安全行政首长责任制----评分表分处室考核（市部门）----发布
     * @param ffPublishVO
     */
    @Override
    @Transactional(isolation = Isolation.READ_COMMITTED,rollbackFor = Exception.class)
    public void publish(FfPublishVO ffPublishVO) {
        BizRespCityTaskfF cityTaskfF=bizRespCityTaskfFMapper.selectByPrimaryKey(ffPublishVO.getId());
        cityTaskfF.setUpdateTime(new Date());
        cityTaskfF.setStatus("30");
        cityTaskfF.setUpdateBy(ffPublishVO.getUpdateBy());
        bizRespCityTaskfFMapper.updateByPrimaryKeySelective(cityTaskfF);
        String taskId=cityTaskfF.getBizRespExaminationTaskId();
        String type=cityTaskfF.getBmType();
        String deptId=cityTaskfF.getOrgId();
        ProvincePhbmPublishVO inputSmiitVO=new ProvincePhbmPublishVO();
        inputSmiitVO.setTaskId(taskId);
        inputSmiitVO.setDeptId(deptId);
        inputSmiitVO.setType(type);
        List<BizRespDepartmentalOpinion> opinionList=bizRespDepartmentalOpinionMapper.findByFfList(inputSmiitVO);
        for(BizRespDepartmentalOpinion opinion:opinionList){
            opinion.setUserCode(cityTaskfF.getUserCode());
            bizRespDepartmentalOpinionMapper.updateByPrimaryKeySelective(opinion);
        }
    }

    /**
     * 粮食安全行政首长责任制----评分表分处室考核（市部门）---批量提交
     * @param
     */
    @Override
    @Transactional(isolation = Isolation.READ_COMMITTED,rollbackFor = Exception.class)
    public void publishALL(FfPublishVO ffPublishVO) {
        List<BizRespCityTaskfF> cityTaskfFList=bizRespCityTaskfFMapper.findByStatus(ffPublishVO);
        for(BizRespCityTaskfF cityTaskfF:cityTaskfFList){
            cityTaskfF.setUpdateTime(new Date());
            cityTaskfF.setStatus("30");
            cityTaskfF.setUpdateBy(ffPublishVO.getUpdateBy());
            bizRespCityTaskfFMapper.updateByPrimaryKeySelective(cityTaskfF);
            String taskId=cityTaskfF.getBizRespExaminationTaskId();
            String type=cityTaskfF.getBmType();
            String deptId=cityTaskfF.getOrgId();
            ProvincePhbmPublishVO inputSmiitVO=new ProvincePhbmPublishVO();
            inputSmiitVO.setTaskId(taskId);
            inputSmiitVO.setDeptId(deptId);
            inputSmiitVO.setType(type);
            List<BizRespDepartmentalOpinion> opinionList=bizRespDepartmentalOpinionMapper.findByFfList(inputSmiitVO);
            for(BizRespDepartmentalOpinion opinion:opinionList){
                opinion.setUserCode(cityTaskfF.getUserCode());
                bizRespDepartmentalOpinionMapper.updateByPrimaryKeySelective(opinion);
            }
        }
    }

    /**
     * 粮食安全行政首长责任制----评分表分处室考核（市部门）--查询是否可以提交数据
     * @param ffPublishVO
     * @return
     */
    @Override
    public String findByIsSubmit(FfPublishVO ffPublishVO) {
        List<BizRespCityTaskfF> cityTaskfFList=bizRespCityTaskfFMapper.findByStatus(ffPublishVO);
        if(cityTaskfFList!=null && cityTaskfFList.size()>0){
            return "yes";
        }else{
            return "no";
        }
    }

}