package com.unis.accountability.businessmanagement.service.impl;

import com.github.pagehelper.Page;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.unis.accountability.businessmanagement.common.vo.CityPublishVO;
import com.unis.accountability.businessmanagement.common.vo.cityTaskDistribution.CityTaskDistributionPageVO;
import com.unis.accountability.businessmanagement.common.vo.cityTaskDistribution.CityTaskDistributionVO;
import com.unis.accountability.businessmanagement.common.vo.cityZpbm.*;
import com.unis.accountability.businessmanagement.common.vo.scoringWeight.BizRespScoringWeightRankVO;
import com.unis.accountability.businessmanagement.entity.BizRespDepartmentalOpinion;
import com.unis.accountability.businessmanagement.entity.BizRespScoreInput;
import com.unis.accountability.businessmanagement.entity.BizRespScoringCity;
import com.unis.accountability.businessmanagement.entity.BizRespScoringWeight;
import com.unis.accountability.businessmanagement.mapper.BizRespCityZpbmServiceMapper;
import com.unis.accountability.businessmanagement.mapper.BizRespDepartmentalOpinionMapper;
import com.unis.accountability.businessmanagement.mapper.BizRespScoreInputMapper;
import com.unis.accountability.businessmanagement.mapper.BizRespScoringWeightRankMapper;
import com.unis.accountability.businessmanagement.service.BizRespCityZpbmService;
import com.unis.accountability.businessmanagement.service.BizRespDepartmentalOpinionService;
import com.unis.accountability.businessmanagement.service.BizRespScoringCityService;
import com.unis.accountability.businessmanagement.service.BizRespScoringWeightService;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Transactional;

import java.math.BigDecimal;
import java.util.Date;
import java.util.List;

/**
 * @Auther:张新亮
 * @Date: 2019/9/20 0020 19:33
 * @Description:
 */
@Service
@Transactional
public class BizRespCityZpbmServiceImpl implements BizRespCityZpbmService {
    @Autowired
    private BizRespCityZpbmServiceMapper bizRespCityZpbmServiceMapper;
    @Autowired
    private BizRespScoreInputMapper bizRespScoreInputMapper;
    @Autowired
    private BizRespDepartmentalOpinionService bizRespDepartmentalOpinionService;
    @Autowired
    private BizRespDepartmentalOpinionMapper bizRespDepartmentalOpinionMapper;
    @Autowired
    private BizRespScoringCityService bizRespScoringCityService;
    @Autowired
    private BizRespScoringWeightService bizRespScoringWeightService;
    @Autowired
    private BizRespScoringWeightRankMapper bizRespScoringWeightRankMapper;

    /**
     * 粮食安全行政首长责任制----州市自评部门审核----分页
     * @param cityZpbmPage
     * @param page
     * @param size
     * @return
     */
    @Override
    public PageInfo<List<CityZpbmPageVO>> findByPage(CityZpbmPage cityZpbmPage, Integer page, Integer size) {
        System.out.println("接口参数=="+cityZpbmPage.toString());
        Page<List<CityZpbmPageVO>> listPage = PageHelper.startPage(page, size);
        List<CityZpbmPageVO> mapLists=bizRespCityZpbmServiceMapper.findByPage(cityZpbmPage);
        for(CityZpbmPageVO cityZpbmPageVO:mapLists){
            String taskId=cityZpbmPageVO.getTaskId();
            String araeCode=cityZpbmPageVO.getAreaCode();
            String year=cityZpbmPageVO.getYear();

            Double zhdf=0.0;
            //区级完成分数
            Double qj_wcfs=0.0;
            //市级完成分数
            Double sj_wcfs=0.0;
            //抽查市级完成分数
            Double cc_sj_wcfs=0.0;

            //区级--牵头综合得分
            String type="50";
            String qj_score=bizRespDepartmentalOpinionService.findByTaskIdAndAreaCodeAndType(taskId, araeCode, type, "50");
            if(StringUtils.isNotEmpty(qj_score)){
                qj_wcfs=Double.valueOf(qj_score);
            }
            //市级--级综牵头得分
            type="20";
            String sj_score=bizRespDepartmentalOpinionService.findByTaskIdAndAreaCodeAndType(taskId,araeCode,type, "30");
            if(StringUtils.isNotEmpty(sj_score)){
                sj_wcfs=Double.valueOf(sj_score);
            }
            //抽查--市级牵头得分
            type="60";
            String cc_score=bizRespDepartmentalOpinionService.findByTaskIdAndAreaCodeAndType(taskId,araeCode,type, "30");
            if(StringUtils.isNotEmpty(cc_score)){
                cc_sj_wcfs=Double.valueOf(cc_score);
            }

            //统计分值
            BizRespScoringWeight bizRespScoringWeight=bizRespScoringWeightService.findByYearAndStatus(Integer.valueOf(year), 1);
            /**
             * 统计综合得分--抽查分值
             */
            if(null != bizRespScoringWeight) {
                if (StringUtils.isNotEmpty(cc_score)) {
                    //区级分值 zsZpbmWeight
                    Double zsZpbmWeight = Double.valueOf(bizRespScoringWeight.getZsZpbmWeight());
                    Double qjScore = (zsZpbmWeight / 100) * qj_wcfs;
                    System.out.println("区级牵头部门总分==" + qj_wcfs + "权重:" + zsZpbmWeight + "统计结果:" + qjScore);
                  
                    //市级分值 zsZpbmWeight
                    Double sjQtbmWeight = Double.valueOf(bizRespScoringWeight.getSjQtbmWeight());
                    Double sjScore = (sjQtbmWeight / 100) * sj_wcfs;
                    System.out.println("市级牵头部门总分==" + sj_wcfs + "权重:" + sjQtbmWeight + "统计结果:" + sjScore);

                    //市级分值 sjQtbmFpWeight
                    Double sjQtbmFpWeight = Double.valueOf(bizRespScoringWeight.getSjQtbmFpWeight());
                    Double ccScore = (sjQtbmFpWeight / 100) * cc_sj_wcfs;
                    System.out.println("市级牵头部门总分==" + cc_sj_wcfs + "权重:" + sjQtbmFpWeight + "统计结果:" + ccScore);

                    BigDecimal bd = new BigDecimal(qjScore + sjScore + ccScore);
                    zhdf = bd.setScale(2, BigDecimal.ROUND_HALF_UP).doubleValue();
                    cityZpbmPageVO.setZhdf(zhdf);
                } else {
                    //区级分值 zsZpbmWeight
                    Double zsZpbmWeight = Double.valueOf(bizRespScoringWeight.getZsZpbmWeight());
                    Double qjScore = (zsZpbmWeight / 100) * qj_wcfs;
                    System.out.println("区级牵头部门总分==" + qj_wcfs + "权重:" + zsZpbmWeight + "统计结果:" + qjScore);
                    //市级分值 zsZpbmWeight
                    Double sjQtbmWeight = Double.valueOf(bizRespScoringWeight.getSjQtbmWeight());
                    Double qtbmWeight = 100 - zsZpbmWeight - Double.valueOf(bizRespScoringWeight.getSjQtbmWeight());
                    System.out.println("==============无抽查数据计算查分比 start==========");
                    System.out.println("==============区级百分比==========" + zsZpbmWeight);
                    System.out.println("==============市级百分比==========" + sjQtbmWeight);
                    System.out.println("==============100-区级百分比-市级百分比==========" + qtbmWeight);
                    System.out.println("==============无抽查数据计算查分比 end ==========");
                    Double sjScore = ((sjQtbmWeight + qtbmWeight) / 100) * sj_wcfs;
                    System.out.println("市级牵头部门总分==" + sj_wcfs + "权重:" + sjQtbmWeight + "统计结果:" + sjScore);
                    BigDecimal bd = new BigDecimal(qjScore + sjScore);
                    zhdf = bd.setScale(2, BigDecimal.ROUND_HALF_UP).doubleValue();
                    cityZpbmPageVO.setZhdf(zhdf);
                }
            }
        }

        return listPage.toPageInfo();
    }

    /**
     * 粮食安全行政首长责任制----州市自评部门审核----查看
     * @param id
     * @return
     */
    @Override
    public ZpbmVO findById(String id) {
        BizRespScoreInput bizRespScoreInput=bizRespScoreInputMapper.selectByPrimaryKey(id);
        ZpbmVO zpbmVO=new ZpbmVO();
        zpbmVO.setOrgId(bizRespScoreInput.getOrgId());
        zpbmVO.setBizResexaminationTaskId(bizRespScoreInput.getBizResexaminationTaskId());
        return zpbmVO;

    }

    /**
     * 粮食安全行政首长责任制----州市自评部门审核---编辑
     * @param zpbmUpdateVO
     * @return
     */
    @Override
    @Transactional(isolation = Isolation.READ_COMMITTED,rollbackFor = Exception.class)
    public boolean update(ZpbmUpdateVO zpbmUpdateVO) {
        return bizRespDepartmentalOpinionService.updateZpbm(zpbmUpdateVO);
    }

    /**
     * 粮食安全行政首长责任制----州市自评部门审核---提交
     * @param cityZpbmPublishVO
     */
    @Override
    @Transactional(isolation = Isolation.READ_COMMITTED,rollbackFor = Exception.class)
    public void publish(CityZpbmPublishVO cityZpbmPublishVO) {
        BizRespScoreInput bizRespScoreInput=bizRespScoreInputMapper.selectByPrimaryKey(cityZpbmPublishVO.getId());
        String id=bizRespScoreInput.getId();
        String areaCode=bizRespScoreInput.getAreaCode();
        String deptId=bizRespScoreInput.getZpbm();
        if(bizRespScoreInput.getResultStatus()==1){
            throw new RuntimeException("考核结果已发布，不允许自评");
        }
        String type="30";
        BizRespDepartmentalOpinion opinion=bizRespDepartmentalOpinionMapper.findByCityInfo(id, areaCode, deptId, type);
        opinion.setStatus("30");
        opinion.setUpdateBy(cityZpbmPublishVO.getUpdateBy());
        opinion.setUpdateTime(new Date());
        bizRespDepartmentalOpinionMapper.updateByPrimaryKeySelective(opinion);
    }
    @Override
    @Transactional(isolation = Isolation.READ_COMMITTED,rollbackFor = Exception.class)
    public void updateStatus(CityPublishVO cityPublishVO){
        BizRespScoreInput bizRespScoreInput=bizRespScoreInputMapper.selectByPrimaryKey(cityPublishVO.getId());
        String id=bizRespScoreInput.getId();
        String areaCode=bizRespScoreInput.getAreaCode();
        String deptId=bizRespScoreInput.getZpbm();
        BizRespDepartmentalOpinion opinion;
        if (cityPublishVO.getType().equals("30")||cityPublishVO.getType().equals("40")||cityPublishVO.getType().equals("50")){
             opinion=bizRespDepartmentalOpinionMapper.findByCityInfo(id, areaCode, deptId, cityPublishVO.getType());
        }else {
             opinion=bizRespDepartmentalOpinionMapper.findByCityInfo(bizRespScoreInput.getBizResexaminationTaskId(), areaCode, deptId, cityPublishVO.getType());
        }
        opinion.setStatus(cityPublishVO.getStatus());
        opinion.setUpdateBy(cityPublishVO.getUpdateBy());
        opinion.setUpdateTime(new Date());
        bizRespDepartmentalOpinionMapper.updateByPrimaryKeySelective(opinion);
    }
    /**
     * 粮食安全行政首长责任制----州市自评部门审核---批量提交
     * @param cityZpbmPublishVO
     */
    @Override
    @Transactional(isolation = Isolation.READ_COMMITTED,rollbackFor = Exception.class)
    public void publishALL(CityZpbmPublishVO cityZpbmPublishVO) {
        if(null == cityZpbmPublishVO.getStatus() || "".equals(cityZpbmPublishVO.getStatus())){
            //查询州市自评部门已填报的数据
            cityZpbmPublishVO.setStatus("20");
            cityZpbmPublishVO.setType("30");
            List<publishAllVO> publishAllVOList=bizRespCityZpbmServiceMapper.findByZpbmYearAndDeptId(cityZpbmPublishVO);
            for(publishAllVO publishAllVO:publishAllVOList){
                BizRespDepartmentalOpinion opinion=bizRespDepartmentalOpinionMapper.selectByPrimaryKey(publishAllVO.getOpinionId());
                opinion.setStatus("30");
                opinion.setUpdateBy(cityZpbmPublishVO.getUpdateBy());
                opinion.setUpdateTime(new Date());
                bizRespDepartmentalOpinionMapper.updateByPrimaryKeySelective(opinion);
            }
        }else {
            String shzt = cityZpbmPublishVO.getStatus();
            cityZpbmPublishVO.setStatus("30");
            cityZpbmPublishVO.setType("50");
            List<publishAllVO> publishAllVOList=bizRespCityZpbmServiceMapper.findByZpbmYearAndDeptId(cityZpbmPublishVO);
            for(publishAllVO publishAllVO:publishAllVOList){
                BizRespDepartmentalOpinion opinion=bizRespDepartmentalOpinionMapper.selectByPrimaryKey(publishAllVO.getOpinionId());
                opinion.setStatus(shzt);
                opinion.setUpdateBy(cityZpbmPublishVO.getUpdateBy());
                opinion.setUpdateTime(new Date());
                bizRespDepartmentalOpinionMapper.updateByPrimaryKeySelective(opinion);
            }
        }
    }

    /**
     * 粮食安全行政首长责任制----州市自评部门审核---根据年份部门状态查询明细
     * @param cityZpbmPage
     * @return
     */
    @Override
    public List<CityZpbmPageVO> fidByYearAndDeptIdAndStatus(CityZpbmPage cityZpbmPage) {
        return bizRespCityZpbmServiceMapper.findByPage(cityZpbmPage);
    }

    /**
     * 粮食安全行政首长责任制----州市自评部门审核----根据ID和行政区划查询查看
     * @param taskId
     * @param areaCode
     * @return
     */
    @Override
    public ZpbmVO findByTaskIdAndAreaCode(String taskId, String areaCode) {
        BizRespScoreInput bizRespScoreInput=bizRespScoreInputMapper.findByTaskIdAndAreaCode(taskId, areaCode);
        ZpbmVO zpbmVO=bizRespDepartmentalOpinionService.findByZpbmInfo(bizRespScoreInput);
        zpbmVO.setOrgId(bizRespScoreInput.getOrgId());
        return zpbmVO;
    }
}