package com.unis.accountability.businessmanagement.service.impl;

import com.github.pagehelper.util.StringUtil;
import com.unis.accountability.businessmanagement.common.vo.cityPhbm.PhbmUpdateVO;
import com.unis.accountability.businessmanagement.common.vo.cityPhbm.PhbmVO;
import com.unis.accountability.businessmanagement.common.vo.cityQtbm.QtbmOpionVO;
import com.unis.accountability.businessmanagement.common.vo.cityQtbm.QtbmUpdateVO;
import com.unis.accountability.businessmanagement.common.vo.cityQtbm.QtbmVO;
import com.unis.accountability.businessmanagement.common.vo.cityTaskDistribution.CityTaskPublishVO;
import com.unis.accountability.businessmanagement.common.vo.cityZpbm.ZpbmUpdateVO;
import com.unis.accountability.businessmanagement.common.vo.cityZpbm.ZpbmVO;
import com.unis.accountability.businessmanagement.common.vo.provincePhbm.ProvincePhbmPublishVO;
import com.unis.accountability.businessmanagement.common.vo.provinceTask.ProvinceCityTaskPage;
import com.unis.accountability.businessmanagement.common.vo.respScoreInput.BizRespRespScoreInputPublishVO;
import com.unis.accountability.businessmanagement.common.vo.respScoreInput.BizRespScoreInputSmiitVO;
import com.unis.accountability.businessmanagement.entity.BizRespExaminationTask;
import com.unis.accountability.businessmanagement.entity.BizRespScoreInput;
import com.unis.accountability.businessmanagement.mapper.BizRespDepartmentalOpinionMapper;
import com.unis.accountability.businessmanagement.service.BizRespDepartmentalOpinionService;
import com.unis.accountability.businessmanagement.entity.BizRespDepartmentalOpinion;
import com.unis.accountability.businessmanagement.service.BizRespScoreInputService;
import com.unis.common.utils.LsBeanUtils;
import com.unis.common.utils.UUIDUtils;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * @Auther:张新亮
 * @Date: 2019/9/19 0019 17:40
 * @Description:
 */
@Service
@Transactional
public class BizRespDepartmentalOpinionServiceImpl implements BizRespDepartmentalOpinionService {
    @Autowired
    private BizRespDepartmentalOpinionMapper bizRespDepartmentalOpinionMapper;
    @Autowired
    private BizRespScoreInputService bizRespScoreInputService;


    /**
     * 创建考核指标的省级评分意见 --省级配合部门  牵头部门
     * @param taskDO
     * @param inputPublishVO
     */
    @Override
    @Transactional(isolation = Isolation.READ_COMMITTED,rollbackFor = Exception.class)
    public void save(BizRespExaminationTask taskDO, BizRespRespScoreInputPublishVO inputPublishVO,String areaCode) {
        List<BizRespDepartmentalOpinion> opinionDOList=new ArrayList();
       //省级牵头部门评分
        //封装-- 牵头部门
        BizRespDepartmentalOpinion opinionDO=new BizRespDepartmentalOpinion();
        //考核目标任务
        opinionDO.setBizResexaminationTaskId(taskDO.getId());
        //部门id  保存 牵头部门
        String[] lead=taskDO.getLeadDepartment().split(",");
        opinionDO.setDeptId(lead[0]);
        //创建人
        opinionDO.setCreateBy(inputPublishVO.getUpdateBy());
        opinionDO.setUpdateBy(inputPublishVO.getUpdateBy());
        //创建时间
        opinionDO.setCreateTime(new Date());
        opinionDO.setUpdateTime(new Date());
        // 类型:10 省配合部门 20 省牵头部门 30 市自评部门 40 市配合部门 50 市牵头部门 60 省级平时配合部门 70 省级平时牵头部门
        opinionDO.setType("20");
        opinionDO.setAreaCode(areaCode);
        opinionDO.setStatus("10");
        opinionDOList.add(opinionDO);



        //省级配合部门填报
        //封装-- 配合部门
        if(StringUtil.isNotEmpty(taskDO.getCoordinationDepartment())){
            String[] phList=taskDO.getCoordinationDepartment().split(",");
            for(int i=0;i<phList.length;i++){
                opinionDO=new BizRespDepartmentalOpinion();
                //考核目标任务
                opinionDO.setBizResexaminationTaskId(taskDO.getId());
                //部门id  保存 牵头部门
                opinionDO.setDeptId(phList[i]);
                // 类型:10 省配合部门 20 省牵头部门 30 市自评部门 40 市配合部门 50 市牵头部门 60 省级平时牵头部门  70 省级平时配合部门
                opinionDO.setType("10");
                //创建人
                opinionDO.setCreateBy(inputPublishVO.getUpdateBy());
                opinionDO.setUpdateBy(inputPublishVO.getUpdateBy());
                //创建时间
                opinionDO.setCreateTime(new Date());
                opinionDO.setUpdateTime(new Date());
                opinionDO.setStatus("10");
                //行政区划
                opinionDO.setAreaCode(areaCode);
                opinionDOList.add(opinionDO);
            }


//            //省级平时牵头部门评分
//            //封装-- 牵头部门
//            BizRespDepartmentalOpinion opinionDO2=new BizRespDepartmentalOpinion();
//            //考核目标任务
//            opinionDO2.setBizResexaminationTaskId(taskDO.getId());
//            //部门id  保存 牵头部门
//            String[] lead1=taskDO.getLeadDepartment().split(",");
//            opinionDO2.setDeptId(lead1[0]);
//            //创建人
//            opinionDO2.setCreateBy(inputPublishVO.getUpdateBy());
//            opinionDO2.setUpdateBy(inputPublishVO.getUpdateBy());
//            //创建时间
//            opinionDO2.setCreateTime(new Date());
//            opinionDO2.setUpdateTime(new Date());
//            // 类型:10 省配合部门 20 省牵头部门 30 市自评部门 40 市配合部门 50 市牵头部门 60 省级平时牵头部门  70 省级平时配合部门
//            opinionDO2.setType("60");
//            opinionDO2.setAreaCode(areaCode);
//            opinionDO2.setStatus("10");
//            opinionDOList.add(opinionDO2);



//            for(int i=0;i<phList.length;i++){
//                opinionDO=new BizRespDepartmentalOpinion();
//                //考核目标任务
//                opinionDO.setBizResexaminationTaskId(taskDO.getId());
//                //部门id  保存 牵头部门
//                opinionDO.setDeptId(phList[i]);
//                //类型:10 省配合部门 20 省牵头部门 30 市自评部门 40 市配合部门 50 市牵头部门 60 省级平时牵头部门  70 省级平时配合部门
//                opinionDO.setType("70");
//                //创建人
//                opinionDO.setCreateBy(inputPublishVO.getUpdateBy());
//                opinionDO.setUpdateBy(inputPublishVO.getUpdateBy());
//                //创建时间
//                opinionDO.setCreateTime(new Date());
//                opinionDO.setUpdateTime(new Date());
//                opinionDO.setStatus("10");
//                //行政区划
//                opinionDO.setAreaCode(areaCode);
//                opinionDOList.add(opinionDO);
//            }
        }



        //保存评分意见
        for(BizRespDepartmentalOpinion opinionDO1:opinionDOList){
            bizRespDepartmentalOpinionMapper.insertSelective(opinionDO1);
        }

    }




    /**
     * 创建考核指标的州市评分意见---自评部门  配合部门 牵头部门
     * @param input
     * @param cityTaskPublishVO
     */
    @Override
    @Transactional(isolation = Isolation.READ_COMMITTED,rollbackFor = Exception.class)
    public void saveCity(BizRespScoreInput input, CityTaskPublishVO cityTaskPublishVO,String areaCode) {
        List<BizRespDepartmentalOpinion> opinionDOList=new ArrayList();
        //封装-- 自评部门
        BizRespDepartmentalOpinion zpbmDo=new BizRespDepartmentalOpinion();
        //考核目标任务
        zpbmDo.setBizRespScoreInputId(input.getId());
        zpbmDo.setDeptId(input.getZpbm());
        //创建人
        zpbmDo.setCreateBy(cityTaskPublishVO.getUpdateBy());
        zpbmDo.setUpdateBy(cityTaskPublishVO.getUpdateBy());
        //创建时间
        zpbmDo.setCreateTime(new Date());
        zpbmDo.setUpdateTime(new Date());
        // 类型:10 省配合部门 20 省牵头部门 30 市自评部门 40 市配合部门 50 市牵头部门
        zpbmDo.setType("30");
        zpbmDo.setAreaCode(areaCode);
        zpbmDo.setStatus("10");
        zpbmDo.setFfzt(10);
        zpbmDo.setBizResexaminationTaskId(input.getBizResexaminationTaskId());
        opinionDOList.add(zpbmDo);


        //封装-- 牵头部门
        BizRespDepartmentalOpinion opinionDO=new BizRespDepartmentalOpinion();
        //考核目标任务
        opinionDO.setBizRespScoreInputId(input.getId());
        //部门id  保存 牵头部门
        String[] lead=input.getQtbm().split(",");
        opinionDO.setDeptId(lead[0]);
        //创建人
        opinionDO.setCreateBy(cityTaskPublishVO.getUpdateBy());
        opinionDO.setUpdateBy(cityTaskPublishVO.getUpdateBy());
        //创建时间
        opinionDO.setCreateTime(new Date());
        opinionDO.setUpdateTime(new Date());
        // 类型:10 省配合部门 20 省牵头部门 30 市自评部门 40 市配合部门 50 市牵头部门
        opinionDO.setType("50");
        opinionDO.setAreaCode(areaCode);
        opinionDO.setStatus("10");
        opinionDO.setFfzt(10);
        opinionDO.setBizResexaminationTaskId(input.getBizResexaminationTaskId());
        opinionDOList.add(opinionDO);


        //封装-- 配合部门
        if(StringUtil.isNotEmpty(input.getPhbm())){
            String[] phList=input.getPhbm().split(",");
            for(int i=0;i<phList.length;i++){
                opinionDO=new BizRespDepartmentalOpinion();
                //考核目标任务
                opinionDO.setBizRespScoreInputId(input.getId());
                //部门id  保存 牵头部门
                opinionDO.setDeptId(phList[i]);
                //类型:10 省配合部门 20 省牵头部门 30 市自评部门 40 市配合部门 50 市牵头部门
                opinionDO.setType("40");
                //创建人
                opinionDO.setCreateBy(cityTaskPublishVO.getUpdateBy());
                opinionDO.setUpdateBy(cityTaskPublishVO.getUpdateBy());
                //创建时间
                opinionDO.setCreateTime(new Date());
                opinionDO.setUpdateTime(new Date());
                opinionDO.setStatus("10");
                opinionDO.setFfzt(10);
                //行政区划
                opinionDO.setAreaCode(areaCode);
                opinionDO.setBizResexaminationTaskId(input.getBizResexaminationTaskId());
                opinionDOList.add(opinionDO);
            }
        }
        //保存评分意见
        for(BizRespDepartmentalOpinion opinionDO1:opinionDOList){
            bizRespDepartmentalOpinionMapper.insertSelective(opinionDO1);
        }

    }



    public void updateByPrimaryKey(BizRespDepartmentalOpinion opinion){
        bizRespDepartmentalOpinionMapper.updateByPrimaryKeySelective(opinion);
    }


    /**
     * 创建考核指标的州市评分意见----自评部门----修改
     * @param zpbmUpdateVO
     * @return
     */
    @Override
    @Transactional(isolation = Isolation.READ_COMMITTED,rollbackFor = Exception.class)
    public boolean updateZpbm(ZpbmUpdateVO zpbmUpdateVO) {
        System.out.println("接口参数=="+zpbmUpdateVO.toString());
        BizRespDepartmentalOpinion  opinion = LsBeanUtils.copyProperties(zpbmUpdateVO.getZpbmVO(), BizRespDepartmentalOpinion.class);
        opinion.setUpdateBy(zpbmUpdateVO.getUpdateBy());
        opinion.setUpdateTime(new Date());
        opinion.setStatus("20");
        bizRespDepartmentalOpinionMapper.updateByPrimaryKeySelective(opinion);
        bizRespScoreInputService.saveFile(opinion.getId(), zpbmUpdateVO.getZpbmVO());
        return true;
    }


    /**
     * 粮食安全行政首长责任制----配合部门---编辑
     * @param phbmUpdateVO
     * @return
     */
    @Override
    public boolean updatePhbm(PhbmUpdateVO phbmUpdateVO) {
        System.out.println("接口参数==" + phbmUpdateVO.toString());
        BizRespDepartmentalOpinion  opinion = LsBeanUtils.copyProperties(phbmUpdateVO.getPhbmVO(), BizRespDepartmentalOpinion.class);
        opinion.setUpdateBy(phbmUpdateVO.getUpdateBy());
        opinion.setUpdateTime(new Date());
        opinion.setStatus("20");
        bizRespDepartmentalOpinionMapper.updateByPrimaryKeySelective(opinion);
        return true;
    }




    /**
     * 创建考核指标的州市评分意见----自评部门----查看
     * @param bizRespScoreInput
     * @return
     */
    @Override
    public ZpbmVO findByZpbmInfo(BizRespScoreInput bizRespScoreInput) {
        System.out.println("接口参数=="+bizRespScoreInput.toString());
        String id=bizRespScoreInput.getId();
        String areaCode=bizRespScoreInput.getAreaCode();
        ZpbmVO zpbmVO =new ZpbmVO();
        if(StringUtils.isNotEmpty(bizRespScoreInput.getZpbm())){
            String deptId=bizRespScoreInput.getZpbm();
            String type="30";
            BizRespDepartmentalOpinion opinion=bizRespDepartmentalOpinionMapper.findByCityInfo(id, areaCode, deptId, type);
            zpbmVO = LsBeanUtils.copyProperties(opinion, ZpbmVO.class);
            zpbmVO.setZpbm(deptId);
            zpbmVO.setBizRespScoreInputId(bizRespScoreInput.getId());
            zpbmVO.setBizResexaminationTaskId(bizRespScoreInput.getBizResexaminationTaskId());
            zpbmVO.setFileId(bizRespScoreInput.getFileId());
        }

        return zpbmVO;
    }

    /**
     * 粮食安全行政首长责任制----市级配合部门----查看
     * @param bizRespScoreInput
     * @return
     */
    @Override
    public PhbmVO findByPhbmInfo(BizRespScoreInput bizRespScoreInput) {
        System.out.println("接口参数=="+bizRespScoreInput.toString());
        String id=bizRespScoreInput.getId();
        String areaCode=bizRespScoreInput.getAreaCode();
        PhbmVO phbmVO =new PhbmVO();
        if(StringUtils.isNotEmpty(bizRespScoreInput.getPhbm())){
            String deptId=bizRespScoreInput.getPhbm();
            String type="40";
            BizRespDepartmentalOpinion opinion=bizRespDepartmentalOpinionMapper.findByCityInfo(id, areaCode, deptId,type);
            phbmVO = LsBeanUtils.copyProperties(opinion, PhbmVO.class);
            phbmVO.setPhbm(deptId);
            phbmVO.setBizRespScoreInputId(bizRespScoreInput.getId());
            phbmVO.setBizResexaminationTaskId(bizRespScoreInput.getBizResexaminationTaskId());
            phbmVO.setAreaCode(areaCode);
        }
        return phbmVO;
    }



    /**
     * 粮食安全行政首长责任制----市级配合部门----查看
     * @param bizRespScoreInput
     * @return
     */
    @Override
    public QtbmOpionVO findByAreaPhbmInfo(BizRespScoreInput bizRespScoreInput,String type) {
        System.out.println("接口参数=="+bizRespScoreInput.toString());
        String id=bizRespScoreInput.getId();
        String areaCode=bizRespScoreInput.getAreaCode();
        QtbmOpionVO phbmVO =new QtbmOpionVO();
        if(StringUtils.isNotEmpty(bizRespScoreInput.getPhbm())){
            String deptId=bizRespScoreInput.getPhbm();
            BizRespDepartmentalOpinion opinion=bizRespDepartmentalOpinionMapper.findByCityInfo(id, areaCode, deptId,type);
            phbmVO = LsBeanUtils.copyProperties(opinion, QtbmOpionVO.class);
        }
        return phbmVO;
    }




    /**
     *  粮食安全行政首长责任制----区级牵头部门----查看
     * @param bizRespScoreInput
     * @return
     */
    @Override
    public QtbmVO findByQtbmInfo(BizRespScoreInput bizRespScoreInput) {
        System.out.println("接口参数=="+bizRespScoreInput.toString());
        String id=bizRespScoreInput.getId();
        String areaCode=bizRespScoreInput.getAreaCode();
        QtbmVO qtbmVO=new QtbmVO();
        if(StringUtils.isNotEmpty(bizRespScoreInput.getQtbm())){
            String deptId=bizRespScoreInput.getQtbm();
            String type="50";
            BizRespDepartmentalOpinion opinion=bizRespDepartmentalOpinionMapper.findByCityInfo(id, areaCode, deptId,type);
            qtbmVO = LsBeanUtils.copyProperties(opinion, QtbmVO.class);
            qtbmVO.setQtbm(deptId);
            qtbmVO.setPhbm(bizRespScoreInput.getPhbm());
            qtbmVO.setBizRespScoreInputId(bizRespScoreInput.getId());
            qtbmVO.setBizResexaminationTaskId(bizRespScoreInput.getBizResexaminationTaskId());
            qtbmVO.setAreaCode(areaCode);
        }
        return qtbmVO;
    }



    /**
     *  粮食安全行政首长责任制----区级牵头部门----查看
     * @param bizRespScoreInput
     * @return
     */
    @Override
    public QtbmOpionVO findByAreaQtbmInfo(BizRespScoreInput bizRespScoreInput,String type) {
        System.out.println("接口参数=="+bizRespScoreInput.toString());
        String id=bizRespScoreInput.getId();
        String areaCode=bizRespScoreInput.getAreaCode();
        QtbmOpionVO qtbmOpionVO=new QtbmOpionVO();
        if(StringUtils.isNotEmpty(bizRespScoreInput.getQtbm())){
            String deptId=bizRespScoreInput.getQtbm();
            BizRespDepartmentalOpinion opinion=bizRespDepartmentalOpinionMapper.findByCityInfo(id, areaCode, deptId,type);
            qtbmOpionVO = LsBeanUtils.copyProperties(opinion, QtbmOpionVO.class);
        }
        return qtbmOpionVO;
    }





    /**
     * 粮食安全行政首长责任制----市级牵头部门---编辑
     * @param qtbmUpdateVO
     * @return
     */
    @Override
    public boolean updateQtbm(QtbmUpdateVO qtbmUpdateVO) {
        System.out.println("接口参数=="+qtbmUpdateVO.toString());
        BizRespDepartmentalOpinion  opinion = LsBeanUtils.copyProperties(qtbmUpdateVO.getQtbmVO(), BizRespDepartmentalOpinion.class);
        opinion.setUpdateBy(qtbmUpdateVO.getUpdateBy());
        opinion.setUpdateTime(new Date());
        opinion.setStatus("20");
        bizRespDepartmentalOpinionMapper.updateByPrimaryKeySelective(opinion);
        return true;
    }

    /**
     * 粮食安全行政首长责任制----省级牵头部门
     * @param taskId
     * @param type
     * @return
     */
    @Override
    public QtbmVO findByProvinceQtbm(String taskId, String type,String areaCode) {
        BizRespDepartmentalOpinion opinion=bizRespDepartmentalOpinionMapper.findByProvinceQtbm(taskId, type,areaCode);
        QtbmVO qtbmVO = LsBeanUtils.copyProperties(opinion, QtbmVO.class);
        return qtbmVO;
    }

    /**
     * 粮食安全行政首长责任制----省级任务考查询(省考核办)---驳回
     * @param taskId
     * @param shiAreaCode
     * @return
     */
    @Override
    @Transactional(isolation = Isolation.READ_COMMITTED,rollbackFor = Exception.class)
    public boolean saveReappraisal(String taskId, String shiAreaCode) {
        String type="20";
        BizRespDepartmentalOpinion opinion=bizRespDepartmentalOpinionMapper.findByProvinceQtbm(taskId, type, shiAreaCode);
        BizRespDepartmentalOpinion coptOpinoin=opinion;
        coptOpinoin.setId(UUIDUtils.uuid());
        coptOpinoin.setStatus("40");
        coptOpinoin.setType("60");
        coptOpinoin.setScoreReason(null);
        coptOpinoin.setScore(null);
        coptOpinoin.setKfyy(null);
        coptOpinoin.setBmshr(null);
        coptOpinoin.setBmtbr(null);
        coptOpinoin.setZgcs(null);
        bizRespDepartmentalOpinionMapper.insertSelective(coptOpinoin);
        return true;
    }

    /**
     *  粮食安全行政首长责任制----省级任务考查询(省考核办)---根据考核任务ID 和州市行政区划查询评分意见
     * @param taskId
     * @param shiAreaCode
     * @return
     */
    @Override
    public List<BizRespDepartmentalOpinion> findByProvinceTaskIdAndAreaCode(String taskId, String shiAreaCode) {
      return   bizRespDepartmentalOpinionMapper.findByTaskAndShiAreaCode(taskId, shiAreaCode);
    }

    /**
     * 粮食安全行政首长责任制----统计总分
     * @param taskId
     * @param shiAreaCode
     * @return
     */
    @Override
    public List<BizRespDepartmentalOpinion> findByProvinceScore(String taskId, String shiAreaCode) {
        return   bizRespDepartmentalOpinionMapper.findByProvinceScore(taskId, shiAreaCode);
    }

    /**
     * 州市、外部单位牵头部门、配合部门评分--查询是否可以提交数据
     * @param scoreInputSmiitVO
     * @return
     */
    @Override
    public String findByIsSubmit(BizRespScoreInputSmiitVO scoreInputSmiitVO) {
        scoreInputSmiitVO.setStatus("20");
        List<BizRespDepartmentalOpinion> opinionList=bizRespDepartmentalOpinionMapper.findByIsSubmit(scoreInputSmiitVO);
        if(opinionList!=null && opinionList.size()>0){
            return "yes";
        }else{
            return "no";
        }
    }

    /**
     * 根据行政区划查询总分
     * @param bilityId
     * @param areaCode
     * @return
     */
    @Override
    public String findByTotalScore(String bilityId, String areaCode,String type, String status) {
        return bizRespDepartmentalOpinionMapper.findByTotalScore(bilityId,areaCode,type,status);

    }

    /**
     * 粮食安全行政首长责任制----评分表分处室考核（市部门）----发布
     * @param inputSmiitVO
     * @return
     */
    @Override
    public List<BizRespDepartmentalOpinion> findByFfList(ProvincePhbmPublishVO inputSmiitVO) {
        return bizRespDepartmentalOpinionMapper.findByFfList( inputSmiitVO);

    }


    /**
     * 粮食安全行政首长责任制----考核结果查看（市局)---抽查分发
     * @param provinceCityTaskPage
     */
    @Override
    @Transactional(isolation = Isolation.READ_COMMITTED,rollbackFor = Exception.class)
    public void publishCcFf(List<ProvinceCityTaskPage> provinceCityTaskPage) {
        List<BizRespDepartmentalOpinion> opinionDOList=new ArrayList();
        for(ProvinceCityTaskPage provinceCityTaskPage1:provinceCityTaskPage){
            List<BizRespDepartmentalOpinion> opinionList=bizRespDepartmentalOpinionMapper.publishCcFf(provinceCityTaskPage1);
            for(BizRespDepartmentalOpinion opinion:opinionList){
                BizRespDepartmentalOpinion opinionDO=new BizRespDepartmentalOpinion();
                //市配全部门
                if("10".equals(opinion.getType())){
                    //省级牵头部门评分
                    //封装-- 牵头部门
                    opinionDO.setBizResexaminationTaskId(opinion.getBizResexaminationTaskId());
                    //部门id  保存 牵头部门
                    opinionDO.setDeptId(opinion.getDeptId());
                    //创建人
                    opinionDO.setCreateBy(opinion.getUpdateBy());
                    opinionDO.setUpdateBy(opinion.getUpdateBy());
                    //创建时间
                    opinionDO.setCreateTime(new Date());
                    opinionDO.setUpdateTime(new Date());
                    // 类型:10 市配合部门  20 市牵头部门  40 区配合部门 50 区牵头部门 60 市平时牵头部门 70 市平时配合部门
                    opinionDO.setType("70");
                    opinionDO.setAreaCode(opinion.getAreaCode());
                    opinionDO.setStatus("10");
                    opinionDO.setUserCode(opinion.getUserCode());
                    opinionDOList.add(opinionDO);

                }
                //市牵头部门
                if("20".equals(opinion.getType())){
                    //省级牵头部门评分
                    //封装-- 牵头部门
                    opinionDO.setBizResexaminationTaskId(opinion.getBizResexaminationTaskId());
                    //部门id  保存 牵头部门
                    opinionDO.setDeptId(opinion.getDeptId());
                    //创建人
                    opinionDO.setCreateBy(opinion.getUpdateBy());
                    opinionDO.setUpdateBy(opinion.getUpdateBy());
                    //创建时间
                    opinionDO.setCreateTime(new Date());
                    opinionDO.setUpdateTime(new Date());
                    // 类型:10 市配合部门  20 市牵头部门  40 区配合部门 50 区牵头部门 60 市平时牵头部门 70 市平时配合部门
                    opinionDO.setType("60");
                    opinionDO.setAreaCode(opinion.getAreaCode());
                    opinionDO.setStatus("10");
                    opinionDO.setUserCode(opinion.getUserCode());
                    opinionDOList.add(opinionDO);
                }
            }
        }





        for(BizRespDepartmentalOpinion opinion:opinionDOList){
            bizRespDepartmentalOpinionMapper.insertSelective(opinion);
        }
    }


    /**
     * 查询综合得分
     * @param taskId
     * @param araeCode
     * @param type
     * @return
     */
    @Override
    public String findByTaskIdAndAreaCodeAndType(String taskId, String araeCode, String type, String status) {
       return bizRespDepartmentalOpinionMapper.findByTaskIdAndAreaCodeAndType(taskId,araeCode,type, status);

    }


    /**
     * 统计总分
     * @param bilityId
     * @param areaCode
     * @param type
     * @return
     */
    @Override
    public Map findByTaskFnyfzAndNyfzTotal(String bilityId, String areaCode, String type, String status) {
        return bizRespDepartmentalOpinionMapper.findByTaskFnyfzAndNyfzTotal(bilityId,areaCode,type, status);
    }


}