package com.unis.accountability.businessmanagement.service.impl;

import com.github.pagehelper.Page;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.unis.accountability.businessmanagement.common.vo.cityPhbm.PhbmUpdateVO;
import com.unis.accountability.businessmanagement.common.vo.cityPhbm.PhbmVO;
import com.unis.accountability.businessmanagement.common.vo.cityQtbm.CityQtbmPageVO;
import com.unis.accountability.businessmanagement.common.vo.cityQtbm.QtbmUpdateVO;
import com.unis.accountability.businessmanagement.common.vo.cityQtbm.QtbmVO;
import com.unis.accountability.businessmanagement.common.vo.examinationTask.BizRespExaminationTaskVO;
import com.unis.accountability.businessmanagement.common.vo.provincePhbm.ProvincePhbmPage;
import com.unis.accountability.businessmanagement.common.vo.provincePhbm.ProvincePhbmPublishVO;
import com.unis.accountability.businessmanagement.common.vo.provincePhbm.PrvoincePhbmPageVO;
import com.unis.accountability.businessmanagement.common.vo.provinceTask.ProvinceCityTaskPage;
import com.unis.accountability.businessmanagement.common.vo.responsibility.BizRespResponsibilityVO;
import com.unis.accountability.businessmanagement.entity.BizRespDepartmentalOpinion;
import com.unis.accountability.businessmanagement.entity.BizRespExaminationTask;
import com.unis.accountability.businessmanagement.entity.BizRespScoringWeight;
import com.unis.accountability.businessmanagement.mapper.BizRespDepartmentalOpinionMapper;
import com.unis.accountability.businessmanagement.mapper.BizRespExaminationTaskMapper;
import com.unis.accountability.businessmanagement.mapper.BizRespProvinceMapper;
import com.unis.accountability.businessmanagement.service.*;
import com.unis.common.utils.LsBeanUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Transactional;

import java.util.*;

/**
 * @Auther:张新亮
 * @Date: 2019/10/8 0008 14:50
 * @Description:
 */
@Service
@Transactional
public class BizRespProvinceQtbmServiceImpl implements BizRespProvinceQtbmService {

    @Autowired
    private BizRespProvinceMapper bizRespProvinceMapper;
    @Autowired
    private BizRespScoringWeightService bizRespScoringWeightService;
    @Autowired
    private BizRespDepartmentalOpinionMapper bizRespDepartmentalOpinionMapper;
    @Autowired
    private BizRespDepartmentalOpinionService bizRespDepartmentalOpinionService;
    @Autowired
    private BizRespResponsibilityService bizRespResponsibilityService;
    @Autowired
    private BizRespExaminationTaskService bizRespExaminationTaskService;
    @Autowired
    private BizRespProvinceTaskService bizRespProvinceTaskService;
    @Autowired
    private BizRespExaminationTaskMapper bizRespExaminationTaskMapper;
    /**
     * 粮食安全行政首长责任制----省级牵头部门----分页
     * @param provincePhbmPage
     * @param page
     * @param size
     * @return
     */
    @Override
    public PageInfo<List<PrvoincePhbmPageVO>> findByPage(
            ProvincePhbmPage provincePhbmPage,
            Integer page,
            Integer size
    ) {
        Page<List<PrvoincePhbmPageVO>> listPage = PageHelper.startPage(page, size);
        System.out.println("接口参数=="+provincePhbmPage.toString());
        // type  20 省级牵头部门 60 省级平时牵头部门
        List<PrvoincePhbmPageVO> mapLists=bizRespProvinceMapper.findByPhbmPage(provincePhbmPage);
        String ifpf="no";
        for(PrvoincePhbmPageVO prvoincePhbmPageVO:mapLists){
            BizRespScoringWeight bizRespScoringWeight=bizRespScoringWeightService.findByYearAndStatus(Integer.valueOf(prvoincePhbmPageVO.getYear()), 1);
            if(bizRespScoringWeight!=null){
                ifpf= bizRespScoringWeightService.weightCompareTo(bizRespScoringWeight, "cityQtbm");
            }
            prvoincePhbmPageVO.setIfPf(ifpf);
            Map cityMap=getCityInfo(prvoincePhbmPageVO);
            prvoincePhbmPageVO.setCityMap(cityMap);
            Map provincePsMap=getProvincePs(prvoincePhbmPageVO);
            prvoincePhbmPageVO.setProvincePsMap(provincePsMap);
            Map provinceNjMap=getProvinceNj(prvoincePhbmPageVO);
            prvoincePhbmPageVO.setProvinceNjMap(provinceNjMap);
        }
        return listPage.toPageInfo();


    }

    /**
     * 查询省级年终评分
     * @param prvoincePhbmPageVO
     * @return
     */
    private Map getProvinceNj(PrvoincePhbmPageVO prvoincePhbmPageVO) {
        List<String> phbmList=new ArrayList();
        List<BizRespDepartmentalOpinion> opinionList= bizRespDepartmentalOpinionService.findByProvinceScore(prvoincePhbmPageVO.getTaskId(), prvoincePhbmPageVO.getAreaCode());
        //省级平时配合部门
        for(BizRespDepartmentalOpinion opinion:opinionList){
            if("10".equals(opinion.getType())){
                if("10".equals(opinion.getStatus()) || "20".equals(opinion.getStatus())){
                    phbmList.add(opinion.getDeptId());
                }
            }
        }

        Map map=new HashMap();
        map.put("phbmList",phbmList);
        return map;
    }

    /**
     * 查询省级平时评分
     * @param prvoincePhbmPageVO
     * @return
     */
    private Map getProvincePs(PrvoincePhbmPageVO prvoincePhbmPageVO) {
        List<String> phbmList=new ArrayList();
        List<String> qtbmList=new ArrayList();
        List<BizRespDepartmentalOpinion> opinionList= bizRespDepartmentalOpinionService.findByProvinceScore(prvoincePhbmPageVO.getTaskId(), prvoincePhbmPageVO.getAreaCode());
        for(BizRespDepartmentalOpinion opinion:opinionList){
            //省级平时牵头部门
            if("60".equals(opinion.getType())){
                if("10".equals(opinion.getStatus()) || "20".equals(opinion.getStatus())){
                    qtbmList.add(opinion.getDeptId());
                }
            }
        }

        //省级平时配合部门
        for(BizRespDepartmentalOpinion opinion:opinionList){
            if("70".equals(opinion.getType())){
                if("10".equals(opinion.getStatus()) || "20".equals(opinion.getStatus())){
                    phbmList.add(opinion.getDeptId());
                }
            }
        }

        Map map=new HashMap();
        map.put("phbmList",phbmList);
        map.put("qtbmList",qtbmList);
        return map;
    }

    /**
     * 市级评分
     * @param prvoincePhbmPageVO
     * @return
     */
    private Map getCityInfo(PrvoincePhbmPageVO prvoincePhbmPageVO) {
        List<String> zpbmList=new ArrayList();
        List<String> phbmList=new ArrayList();
        List<String> qtbmList=new ArrayList();
        List<BizRespDepartmentalOpinion> opinionList= bizRespDepartmentalOpinionService.findByProvinceScore(prvoincePhbmPageVO.getTaskId(), prvoincePhbmPageVO.getAreaCode());
        for(BizRespDepartmentalOpinion opinion:opinionList){
            //市自评部门
            if("30".equals(opinion.getType())){
                if("10".equals(opinion.getStatus()) || "20".equals(opinion.getStatus())){
                    zpbmList.add(opinion.getDeptId());
                }
            }
        }

        //市配合部门
        for(BizRespDepartmentalOpinion opinion:opinionList){
            if("40".equals(opinion.getType())){
                if("10".equals(opinion.getStatus()) || "20".equals(opinion.getStatus())){
                    phbmList.add(opinion.getDeptId());
                }
            }
        }

        //市牵头部门
        for(BizRespDepartmentalOpinion opinion:opinionList){
            if("50".equals(opinion.getType())){
                if("10".equals(opinion.getStatus()) || "20".equals(opinion.getStatus())){
                    qtbmList.add(opinion.getDeptId());
                }
            }
        }

        Map map=new HashMap();
        map.put("zpbmList",zpbmList);
        map.put("phbmList",phbmList);
        map.put("qtbmList",qtbmList);
        return map;

    }







    /**
     * 粮食安全行政首长责任制----省级牵头部门----查看
     * @param id  部门意见ID
     * @return
     */
    @Override
    public QtbmVO findById(String id) {
        BizRespDepartmentalOpinion opinion= bizRespDepartmentalOpinionMapper.selectByPrimaryKey(id);
        BizRespExaminationTask task=bizRespExaminationTaskMapper.selectByPrimaryKey(opinion.getBizResexaminationTaskId());
        QtbmVO qtbmVO = LsBeanUtils.copyProperties(opinion, QtbmVO.class);
        qtbmVO.setQtbm(opinion.getDeptId());
        qtbmVO.setCityAreacode(task.getAreaCode());
        qtbmVO.setBizResexaminationTaskId(opinion.getBizResexaminationTaskId());
        return qtbmVO;
    }


    /**
     * 粮食安全行政首长责任制----省级牵头部门---编辑
     * @param qtbmUpdateVO
     * @return
     */
    @Override
    @Transactional(isolation = Isolation.READ_COMMITTED,rollbackFor = Exception.class)
    public boolean update(QtbmUpdateVO qtbmUpdateVO) {
        System.out.println("接口参数=="+qtbmUpdateVO.toString());
        return bizRespDepartmentalOpinionService.updateQtbm(qtbmUpdateVO);
    }


    /**
     * 粮食安全行政首长责任制----省级牵头部门---上报
     * @param phbmPublishVO
     */
    @Override
    @Transactional(isolation = Isolation.READ_COMMITTED,rollbackFor = Exception.class)
    public void publish(ProvincePhbmPublishVO phbmPublishVO) {
        System.out.println("省级牵头部门---上报=="+phbmPublishVO.toString());
        BizRespDepartmentalOpinion opinion= bizRespDepartmentalOpinionMapper.selectByPrimaryKey(phbmPublishVO.getId());
        opinion.setStatus("30");
        opinion.setUpdateBy(phbmPublishVO.getUpdateBy());
        opinion.setUpdateTime(new Date());
        bizRespDepartmentalOpinionMapper.updateByPrimaryKeySelective(opinion);

//        //计算评分
//        BizRespExaminationTaskVO bizRespExaminationTaskVO=bizRespExaminationTaskService.findById(opinion.getBizResexaminationTaskId());
//        BizRespResponsibilityVO bizRespResponsibilityVO=bizRespResponsibilityService.findByIds(bizRespExaminationTaskVO.getBizRespResponsibilityId());
//        ProvinceCityTaskPage provinceCityTaskPage=new ProvinceCityTaskPage();
//        provinceCityTaskPage.setAreaCode(opinion.getAreaCode());
//        provinceCityTaskPage.setYear(String.valueOf(bizRespResponsibilityVO.getYear()));
//        provinceCityTaskPage.setBizRespResponsibilityId(bizRespExaminationTaskVO.getBizRespResponsibilityId());
//        bizRespProvinceTaskService.publish(provinceCityTaskPage);


    }


    /**
     * 粮食安全行政首长责任制----省级牵头部门---批量上报
     * @param phbmPublishVO
     */
    @Override
    @Transactional(isolation = Isolation.READ_COMMITTED,rollbackFor = Exception.class)
    public void publishALL(ProvincePhbmPublishVO phbmPublishVO) {
        List<BizRespDepartmentalOpinion> phbmList = bizRespDepartmentalOpinionMapper.findByOpionInfo(phbmPublishVO);
        for(BizRespDepartmentalOpinion opinion:phbmList){
            opinion.setStatus("30");
            opinion.setUpdateBy(phbmPublishVO.getUpdateBy());
            opinion.setUpdateTime(new Date());
            bizRespDepartmentalOpinionMapper.updateByPrimaryKeySelective(opinion);

//            //计算评分
//            BizRespExaminationTaskVO bizRespExaminationTaskVO=bizRespExaminationTaskService.findById(opinion.getBizResexaminationTaskId());
//            BizRespResponsibilityVO bizRespResponsibilityVO=bizRespResponsibilityService.findByIds(bizRespExaminationTaskVO.getBizRespResponsibilityId());
//            ProvinceCityTaskPage provinceCityTaskPage=new ProvinceCityTaskPage();
//            provinceCityTaskPage.setAreaCode(opinion.getAreaCode());
//            provinceCityTaskPage.setYear(String.valueOf(bizRespResponsibilityVO.getYear()));
//            provinceCityTaskPage.setBizRespResponsibilityId(bizRespExaminationTaskVO.getBizRespResponsibilityId());
//            bizRespProvinceTaskService.publish(provinceCityTaskPage);

        }
    }

    /**
     * 粮食安全行政首长责任制----省级牵头部门----查看配合部门明细
     * @param taskId
     * @param type
     * @return
     */
    @Override
    public List<PhbmVO> findByPhbmList(String taskId, String type) {
        List<PhbmVO> phbmVOList=new ArrayList();
        List<BizRespDepartmentalOpinion> qtbmList= bizRespDepartmentalOpinionMapper.findByTaskIdAndType(taskId,type);
        for(BizRespDepartmentalOpinion opinion:qtbmList){
            PhbmVO phbmVO = LsBeanUtils.copyProperties(opinion, PhbmVO.class);
            phbmVO.setPhbm(opinion.getDeptId());
            phbmVO.setBizResexaminationTaskId(opinion.getBizResexaminationTaskId());
            phbmVOList.add(phbmVO);
        }
        return phbmVOList;
    }

    @Override
    public List<PhbmVO> selectByEntity(String id, String type,String areacode) {
        List<PhbmVO> phbmVOList=new ArrayList();
        List<BizRespDepartmentalOpinion> qtbmList= bizRespDepartmentalOpinionMapper.findByIdAndType(id,type,areacode);
        for(BizRespDepartmentalOpinion opinion:qtbmList){
            PhbmVO phbmVO = LsBeanUtils.copyProperties(opinion, PhbmVO.class);
            phbmVO.setPhbm(opinion.getDeptId());
            phbmVO.setBizResexaminationTaskId(opinion.getBizResexaminationTaskId());
            phbmVOList.add(phbmVO);
        }
        return phbmVOList;
    }

}