package com.unis.accountability.businessmanagement.service.impl;

import com.github.pagehelper.Page;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;

import com.unis.accountability.businessmanagement.common.vo.cityPhbm.PhbmVO;
import com.unis.accountability.businessmanagement.common.vo.cityQtbm.QtbmVO;
import com.unis.accountability.businessmanagement.common.vo.cityTaskDistribution.CityTaskPage;
import com.unis.accountability.businessmanagement.common.vo.cityTaskDistribution.CityTaskPublishVO;
import com.unis.accountability.businessmanagement.common.vo.cityZpbm.ZpbmVO;
import com.unis.accountability.businessmanagement.common.vo.provincePhbm.ProvincePhbmPublishVO;
import com.unis.accountability.businessmanagement.common.vo.provinceTask.*;
import com.unis.accountability.businessmanagement.common.vo.scoringWeight.BizRespScoringWeightRankVO;
import com.unis.accountability.businessmanagement.entity.*;
import com.unis.accountability.businessmanagement.mapper.*;
import com.unis.accountability.businessmanagement.service.BizRespDepartmentalOpinionService;
import com.unis.accountability.businessmanagement.service.BizRespProvinceTaskService;
import com.unis.accountability.businessmanagement.service.BizRespScoringWeightService;
import com.unis.common.utils.DateUtil;
import com.unis.common.utils.LsBeanUtils;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Transactional;

import java.math.BigDecimal;
import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @Auther:张新亮
 * @Date: 2019/9/23 0023 14:15
 * @Description:
 */
@Service
@Transactional
public class BizRespProvinceTaskServiceImpl implements BizRespProvinceTaskService {
    @Autowired
    private BizRespSummaryMapper bizRespSummaryMapper;
    @Autowired
    private BizRespExaminationTaskMapper bizRespExaminationTaskMapper;
    @Autowired
    private BizRespDepartmentalOpinionMapper bizRespDepartmentalOpinionMapper;
    @Autowired
    private BizRespCityZpbmServiceMapper bizRespCityZpbmServiceMapper;
    @Autowired
    private BizRespDepartmentalOpinionService bizRespDepartmentalOpinionService;
    @Autowired
    private BizRespScoreInputMapper bizRespScoreInputMapper;
    @Autowired
    private BizRespScoringWeightService bizRespScoringWeightService;
    @Autowired
    private BizRespScoringWeightRankMapper bizRespScoringWeightRankMapper;
    @Autowired
    private BizRespCityTaskDistributionMapper bizRespCityTaskDistributionMapper;
    @Autowired
    private BizRespProvinceTaskService bizRespProvinceTaskService;


    /**
     * 粮食安全行政首长责任制----省级任务考查询(省考核办)----分页
     * @param provinceTaskPage
     * @param page
     * @param size
     * @return
     */
    @Override
    public PageInfo<List<ProvincePageVO>> findByPage(ProvinceTaskPage provinceTaskPage, Integer page, Integer size) {
        CityTaskPage cityTaskPage=new CityTaskPage();
        cityTaskPage.setYear(provinceTaskPage.getYear());
        cityTaskPage.setAreaCode(provinceTaskPage.getAreaCode());
        cityTaskPage.setType(provinceTaskPage.getType());
        System.out.println("接口参数=="+provinceTaskPage.toString());
        Page<List<ProvincePageVO>> listPage = PageHelper.startPage(page, size);
        List<Map> mapList=bizRespCityTaskDistributionMapper.findZpCityByPage(cityTaskPage);
        for(Map map:mapList){
            String bilityId=map.get("bilityid").toString();
            String areaCode=map.get("areacode").toString();
            String year=map.get("year").toString();
            //查询市牵头部门总分数
            bizRespProvinceTaskService.findByOpionScore(map, bilityId, areaCode, year, provinceTaskPage.getType(), "30");
            //查询总数
            ProvincePhbmPublishVO inputSmiitVO=new ProvincePhbmPublishVO();
            inputSmiitVO.setYear(year);
            inputSmiitVO.setAreaCode(areaCode);
            inputSmiitVO.setType(provinceTaskPage.getType());
            List<BizRespDepartmentalOpinion>  totalList = bizRespDepartmentalOpinionService.findByFfList(inputSmiitVO);

            map.put("status","2");
            map.put("statusValue","进行中");
            map.put("wcjd","0");


            //已提交数据
            inputSmiitVO=new ProvincePhbmPublishVO();
            inputSmiitVO.setYear(year);
            inputSmiitVO.setAreaCode(areaCode);
            inputSmiitVO.setStatus("30");
            inputSmiitVO.setType(provinceTaskPage.getType());
            List<BizRespDepartmentalOpinion> ytj= bizRespDepartmentalOpinionService.findByFfList(inputSmiitVO);
            if(ytj!=null && ytj.size()>0){
                String wcjd=bizRespProvinceTaskService.getProportion(totalList.size(), ytj.size());
                if("100".equals(wcjd)){
                    map.put("status","3");
                    map.put("statusValue","已完成");
                }
                map.put("wcjd",wcjd);
            }


            //查询是否抽
            inputSmiitVO=new ProvincePhbmPublishVO();
            inputSmiitVO.setYear(year);
            inputSmiitVO.setAreaCode(areaCode);
            inputSmiitVO.setType("60");
            List<BizRespDepartmentalOpinion>  cclList = bizRespDepartmentalOpinionService.findByFfList(inputSmiitVO);
            if(cclList!=null && cclList.size()>0){
                map.put("ifccff","yes");
            }else{
                map.put("ifccff","no");
            }
            if(totalList!=null && totalList.size()>0){
                BizRespDepartmentalOpinion opinion=totalList.get(0);
                String update= DateUtil.DateToStr(opinion.getUpdateTime(), DateUtil.df);
                map.put("updateTime",update);
            }

        }
        return listPage.toPageInfo();
    }



    /**
     * 计算比例
     * @param total
     * @param wsb
     * @return
     */
    @Override
    public String getProportion(Integer total, Integer wsb) {
        // 创建一个数值格式化对象
        NumberFormat numberFormat = NumberFormat.getInstance();
        // 设置精确到小数点后2位
        numberFormat.setMaximumFractionDigits(2);
        String result = numberFormat.format((float) wsb / (float) total * 100);
        return result;
    }

    /**
     * 查询考核任务是否考核分发
     * @param cityTaskPublishVO
     * @return
     */
    @Override
    public List<BizRespExaminationTask> findByIsKhff(CityTaskPublishVO cityTaskPublishVO) {
        return bizRespExaminationTaskMapper.findByIsKhff(cityTaskPublishVO);

    }

    /**
     * 粮食安全行政首长责任制----考核结果查看（市局)---抽查分发
     * @param provinceCityTaskPage
     */
    @Override
    public void publishCcFf(List<ProvinceCityTaskPage> provinceCityTaskPage) {
        bizRespDepartmentalOpinionService.publishCcFf(provinceCityTaskPage);
    }

    /**
     * 粮食安全行政首长责任制----结果汇总查看（市局)----分页
     * @param provinceTaskPage
     * @param page
     * @param size
     * @return
     */
    @Override
    public PageInfo<List<ProvincePageVO>> findByHzPage(
            ProvinceTaskPage provinceTaskPage,
            Integer page,
            Integer size
    ) {
        CityTaskPage cityTaskPage=new CityTaskPage();
        cityTaskPage.setResultStatus(provinceTaskPage.getResultStatus());
        cityTaskPage.setYear(provinceTaskPage.getYear());
        cityTaskPage.setAreaCode(provinceTaskPage.getAreaCode());
        System.out.println("接口参数=="+provinceTaskPage.toString());
        Page<List<ProvincePageVO>> listPage = PageHelper.startPage(page, size);
        List<Map> mapList= bizRespCityTaskDistributionMapper.findZpCityByPage(cityTaskPage);
        for(Map map:mapList){
            String bilityId=map.get("bilityid").toString();
            String areaCode=map.get("areacode").toString();
            String year=map.get("year").toString();
            Integer resultStatus = (Integer) map.get("resultStatus");
            //查询市牵头部门总分数
            bizRespProvinceTaskService.findByOpionHzScore(map,bilityId, areaCode, year,resultStatus);

        }
        return listPage.toPageInfo();


    }

    /**
     * 统计各省市填报数据
     * @param pageVo
     * @param taskList
     * @param shiAreaCode
     */
    private void getstatistics(
            ProvincePageVO pageVo,
            List<BizRespExaminationTask> taskList,
            String shiAreaCode
    ) {
        //考核--未上报
        Integer kh_wsb=0;
        //考核--已上报
        Integer kh_ysb=0;

        //抽查--未上报
        Integer cc_wsb=0;
        //抽查--已上报
        Integer cc_ysb=0;

        /**
         * 农业分值
         */
         Double nyfz=0.0;
        /**
         * 非农业分值
         */
         Double fnyfz=0.0;

         Double kh_khdf=0.0;
         Double cf_khdf=0.0;

        for(BizRespExaminationTask task:taskList){
            fnyfz+=Double.valueOf(task.getFnyfz());
            nyfz+=Double.valueOf(task.getNyfz());
            String taskId=task.getId();
            List<BizRespDepartmentalOpinion> opinionList=bizRespDepartmentalOpinionMapper.findByTaskAndShiAreaCode(taskId,shiAreaCode);
            for(BizRespDepartmentalOpinion opinion:opinionList){
                if(opinion.getType().equals("20")){
                    if(opinion.getStatus().equals("30")){
                        kh_ysb++;
                        kh_khdf+=opinion.getScore();
                    }else{
                        kh_ysb++;
                    }
                }

                if(opinion.getType().equals("60")){
                    if(opinion.getStatus().equals("30")){
                        cc_wsb++;
                        cf_khdf+=opinion.getScore();
                    }else{
                        cc_ysb++;
                    }
                }
            }
            //状态  (0 :未上报 10 已上报 30 已提交）
            if(task.getStatus().equals("30")){
                pageVo.setStatus("30");
                pageVo.setStatusValue("已提交");
            }
        }

        pageVo.setKh_wcfs(kh_khdf);
        pageVo.setKh_khdf(kh_khdf);

        pageVo.setCc_khdf(cf_khdf);
        pageVo.setCc_wcfs(cf_khdf);

        pageVo.setKh_Wsb(kh_wsb);
        pageVo.setKh_Ysb(kh_ysb);

        pageVo.setCc_Wsb(cc_wsb);
        pageVo.setCc_Ysb(cc_ysb);

        pageVo.setFnyfz(fnyfz);
        pageVo.setNyfz(nyfz);

    }







    /**
     * 粮食安全行政首长责任制----省级任务考查询(省考核办)----州市考核明细
     * @param provinceTaskPage
     * @param page
     * @param size
     * @return
     */
    @Override
    public PageInfo<List<ProvinceCityPageVO>> findCityByPage(ProvinceCityTaskPage provinceTaskPage, Integer page, Integer size) {
        System.out.println("接口参数=="+provinceTaskPage.toString());
        Page<List<ProvinceCityPageVO>> listPage = PageHelper.startPage(page, size);
        List<ProvinceCityPageVO> mapLists=bizRespCityZpbmServiceMapper.findCityByPage(provinceTaskPage);
        for(ProvinceCityPageVO pageVO:mapLists){
            BizRespScoreInput bizRespScoreInput=bizRespScoreInputMapper.selectByPrimaryKey(pageVO.getInputId());
            if(!"0".equals(bizRespScoreInput.getStatus())){
                //市自评部门
                ZpbmVO zpbmVO=bizRespDepartmentalOpinionService.findByZpbmInfo(bizRespScoreInput);
                pageVO.setCityZpbmFz(zpbmVO.getScore());
                //市牵头部门
                String[] deptId=bizRespScoreInput.getQtbm().split(",");
                bizRespScoreInput.setQtbm(deptId[0]);
                QtbmVO qtbmVO=bizRespDepartmentalOpinionService.findByQtbmInfo(bizRespScoreInput);
                pageVO.setCityQtbmFz(qtbmVO.getScore());
                //省牵头部门
                QtbmVO provinceQtbm=bizRespDepartmentalOpinionService.findByProvinceQtbm(pageVO.getTaskId(), "20",pageVO.getShiAreaCode());
                pageVO.setProvinceQtbmFz(provinceQtbm.getScore());



            }
        }
        return listPage.toPageInfo();
    }

    /**
     * 粮食安全行政首长责任制----省级任务考查询(省考核办)---驳回
     * @param taskId
     * @param shiAreaCode
     * @return
     */
    @Override
    public boolean saveReappraisal(String taskId, String shiAreaCode) {
        return bizRespDepartmentalOpinionService.saveReappraisal(taskId, shiAreaCode);

    }

    /**
     * 粮食安全行政首长责任制----省级任务考查询(省考核办)---省级配合部门和牵头部门评价明细
     * @param taskId
     * @param shiAreaCode
     * @return
     */
    @Override
    public ProvinceTaskVO findByProvinceQtbmAndPhbm(String taskId, String shiAreaCode) {
        ProvinceTaskVO provinceTaskVO=new ProvinceTaskVO();

        //省配合部门年科填报
        List<PhbmVO> phbmVOList=new ArrayList();
        //省配合部门平时填报
        List<PhbmVO> phbmPsVOList=new ArrayList();

        List<BizRespDepartmentalOpinion> opinionList=bizRespDepartmentalOpinionService.findByProvinceTaskIdAndAreaCode(taskId, shiAreaCode);
        for(BizRespDepartmentalOpinion opinion:opinionList ){
            //省级配合部门年终填报
            if("10".equals(opinion.getType())){
                PhbmVO phbmVO = LsBeanUtils.copyProperties(opinion, PhbmVO.class);
                phbmVO.setPhbm(opinion.getDeptId());
                phbmVOList.add(phbmVO);
            }
            // 省级牵头部门年终填报
            if("20".equals(opinion.getType())){
                QtbmVO qtbmVO = LsBeanUtils.copyProperties(opinion, QtbmVO.class);
                qtbmVO.setQtbm(opinion.getDeptId());
                provinceTaskVO.setQtbm(qtbmVO);
            }

            //省级配合部门平时填报
            if("70".equals(opinion.getType())){
                PhbmVO phbmVO = LsBeanUtils.copyProperties(opinion, PhbmVO.class);
                phbmVO.setPhbm(opinion.getDeptId());
                phbmPsVOList.add(phbmVO);

            }
            // 省级牵头部门平时填报
            if("60".equals(opinion.getType())){
                QtbmVO qtbmVO = LsBeanUtils.copyProperties(opinion, QtbmVO.class);
                qtbmVO.setQtbm(opinion.getDeptId());
                provinceTaskVO.setQtbmPs(qtbmVO);
            }

        }
        provinceTaskVO.setPhbmPsVOList(phbmPsVOList);
        provinceTaskVO.setPhbmVOList(phbmVOList);
        return provinceTaskVO;

    }

    /**
     * 粮食安全行政首长责任制----省级任务考查询(省考核办)---提交
     * @param provinceCityTaskPage
     */
    @Override
    @Transactional(isolation = Isolation.READ_COMMITTED,rollbackFor = Exception.class)
    public void publish(
            ProvinceCityTaskPage provinceCityTaskPage
    ) {
        //省级牵头部门分值
        Double provinceQtbmFz=0.0;
        //省级牵头部门平时分值
        Double provinceQtbmPsFz=0.0;
        //市级牵头部门分值
        Double cityQtbmFz=0.0;
        List<Map> mapList=bizRespCityZpbmServiceMapper.findByTaskIdAndAreaCode(provinceCityTaskPage.getBizRespResponsibilityId(),provinceCityTaskPage.getAreaCode());
        for(Map map:mapList){
            String areaCode=provinceCityTaskPage.getAreaCode();
            String taskId=map.get("taskid").toString();
            //查询省级数据
            List<BizRespDepartmentalOpinion> provinceList=bizRespDepartmentalOpinionService.findByProvinceScore(taskId,areaCode);
            for(BizRespDepartmentalOpinion opinion:provinceList){
                //省级牵头部门分值
                if("20".equals(opinion.getType())){
                    if(opinion.getScore()!=null){
                        provinceQtbmFz+=opinion.getScore();
                    }
                }
                //省级牵头部门平时分值
                if("60".equals(opinion.getType())){
                    if(opinion.getScore()!=null){
                        provinceQtbmPsFz+=opinion.getScore();
                    }
                }
                //市级牵头部门
                if("50".equals(opinion.getType())){
                    if(opinion.getScore()!=null){
                        cityQtbmFz+=opinion.getScore();
                    }
                }
            }
        }


        System.out.println("省级牵头部门分值=="+provinceQtbmFz);
        System.out.println("省级牵头部门平时分值=="+provinceQtbmPsFz);
        System.out.println("市级牵头部门=="+cityQtbmFz);

        //统计分值
        Integer year=Integer.valueOf(provinceCityTaskPage.getYear());
        BizRespScoringWeight bizRespScoringWeight=bizRespScoringWeightService.findByYearAndStatus(year, 1);
        List<BizRespScoringWeightRankVO> weightRankVOList=bizRespScoringWeightRankMapper.findByScoringWeightId(bizRespScoringWeight.getId());

        /**
         * 省级牵头评分权重
         */
        Double sjQtbmWeight=Double.valueOf(bizRespScoringWeight.getSjQtbmWeight());
        Double qtTotalScore=(sjQtbmWeight/100)*provinceQtbmFz;
        System.out.println("省级牵头部门分值=="+provinceQtbmFz+"权重:"+sjQtbmWeight+"统计结果:"+qtTotalScore);
        /**
         * 省级牵头平时评分分权重
         */
        Double sjQtbmPsWeight=Double.valueOf(bizRespScoringWeight.getSjQtbmFpWeight());
        Double qtPsTotalScore=(sjQtbmPsWeight/100)*provinceQtbmPsFz;
        System.out.println("省级牵头平时评分分权重=="+provinceQtbmPsFz+"权重:"+sjQtbmPsWeight+"统计结果:"+qtPsTotalScore);

        /**
         * 州市牵头部门评分权重
         */
        Double zsZpbmWeight=Double.valueOf(bizRespScoringWeight.getZsZpbmWeight());
        Double cityTotalScore=(zsZpbmWeight/100)*cityQtbmFz;
        System.out.println("州市牵头部门评分权重=="+cityQtbmFz+"权重:"+zsZpbmWeight+"统计结果:"+cityTotalScore);
        Double totalScore=cityTotalScore+qtTotalScore+qtPsTotalScore;
        System.out.println("计算总分"+totalScore);
        BigDecimal bd = new BigDecimal(totalScore);
        totalScore=bd.setScale(2, BigDecimal.ROUND_HALF_UP).doubleValue();
        String pj=getWeightQz(weightRankVOList, totalScore);

        Map sumMap=new HashMap();
        sumMap.put("bizRespResponsibilityId",provinceCityTaskPage.getBizRespResponsibilityId());
        sumMap.put("areaCode", provinceCityTaskPage.getAreaCode());
        BizRespSummary summaryDO=bizRespSummaryMapper.findByBilityIdAndAreaCode(sumMap);
        summaryDO.setPj(pj);
        summaryDO.setTotalScore(String.valueOf(totalScore));
        bizRespSummaryMapper.updateByPrimaryKeySelective(summaryDO);

    }


    /**
     *统计 区牵头部门 市牵头部门 抽查牵头部门分值
     * @param map
     * @param bilityId
     * @param areaCode
     * @param type
     */
    @Override
    public void findByOpionScore(Map map, String bilityId, String areaCode, String year,String type, String status) {
        //自评得分 考核得分 抽查得分
        Double zpdfOrKhdfOrCcdf=0.0;
        //农业分值
        Double nyfz=0.0;
        //非农业分值
        Double fnyfz=0.0;

        Map totalFz=bizRespCityZpbmServiceMapper.finyNyfzAndFnyfz(bilityId,areaCode);
        String c_fnyfz=totalFz.get("fnyfz").toString();
        String c_nyfz=totalFz.get("nyfz").toString();
        fnyfz+=Double.valueOf(c_fnyfz);
        nyfz+=Double.valueOf(c_nyfz);
        //查询省级数据 status 原来30 20210425改BUG改成50
//        String status = "50";
        
        String  score=bizRespDepartmentalOpinionService.findByTotalScore(bilityId, areaCode, type, status);
        if(StringUtils.isNotEmpty(score)){
            zpdfOrKhdfOrCcdf=Double.valueOf(score);
        }
        String taskFnyfz="";
        String taskNyfz="";
        Map taskTotalScore=bizRespDepartmentalOpinionService.findByTaskFnyfzAndNyfzTotal(bilityId, areaCode, type, status);
        if(taskTotalScore!=null){
             taskFnyfz=taskTotalScore.get("task_fnyfz")==null?"0":taskTotalScore.get("task_fnyfz").toString();
             taskNyfz=taskTotalScore.get("task_nyfz")==null?"0":taskTotalScore.get("task_nyfz").toString();
        }
        map.put("fnyfz",fnyfz);
        map.put("nyfz",nyfz);
        map.put("taskFnyfz",taskFnyfz);
        map.put("taskNyfz",taskNyfz);
        map.put("zpdfOrKhdfOrCcdf",zpdfOrKhdfOrCcdf);
    }

    /**
     *
     * @param map
     * @param bilityId
     * @param areaCode
     * @param year
     */
    @Override
    public void findByOpionHzScore(Map map,String bilityId, String areaCode, String year,Integer resultStatus) {
        Double zhdf=0.0;
        //区级完成分数
        Double qj_wcfs=0.0;
        //市级完成分数
        Double sj_wcfs=0.0;
        //抽查市级完成分数
        Double cc_sj_wcfs=0.0;
        //农业分值
        Double nyfz=0.0;
        //非农业分值
        Double fnyfz=0.0;

        Map totalFz=bizRespCityZpbmServiceMapper.finyNyfzAndFnyfz(bilityId,areaCode);
        String c_fnyfz=totalFz.get("fnyfz").toString();
        String c_nyfz=totalFz.get("nyfz").toString();
        fnyfz+=Double.valueOf(c_fnyfz);
        nyfz+=Double.valueOf(c_nyfz);
        //查询省级数据
        //区级分值 原來status = 30
        String  qj_score=bizRespDepartmentalOpinionService.findByTotalScore(bilityId, areaCode, "50", "50");
        if(StringUtils.isNotEmpty(qj_score)){
            qj_wcfs=Double.valueOf(qj_score);
        }

        //市级分值
        String  sj_score=bizRespDepartmentalOpinionService.findByTotalScore(bilityId, areaCode, "20", "30");
        if(StringUtils.isNotEmpty(sj_score)){
            sj_wcfs=Double.valueOf(sj_score);
        }

        //抽查_市级分值
        String  cc_score=bizRespDepartmentalOpinionService.findByTotalScore(bilityId, areaCode, "60", "30");
        if(StringUtils.isNotEmpty(cc_score)){
            cc_sj_wcfs=Double.valueOf(cc_score);
        }


        //统计分值
        BizRespScoringWeight bizRespScoringWeight=bizRespScoringWeightService.findByYearAndStatus(Integer.valueOf(year), 1);
        List<BizRespScoringWeightRankVO> weightRankVOList=bizRespScoringWeightRankMapper.findByScoringWeightId(bizRespScoringWeight.getId());


        /**
         * 统计综合得分--抽查分值
         */
        if(StringUtils.isNotEmpty(cc_score)){
            //区级分值 zsZpbmWeight
            Double zsZpbmWeight=Double.valueOf(bizRespScoringWeight.getZsZpbmWeight());
            Double qjScore=(zsZpbmWeight/100)*qj_wcfs;
            System.out.println("区级牵头部门总分=="+qj_wcfs+"权重:"+zsZpbmWeight+"统计结果:"+qjScore);
            //市级分值 zsZpbmWeight
            Double sjQtbmWeight=Double.valueOf(bizRespScoringWeight.getSjQtbmWeight());
            Double sjScore=(sjQtbmWeight/100)*sj_wcfs;
            System.out.println("市级牵头部门总分=="+sj_wcfs+"权重:"+sjQtbmWeight+"统计结果:"+sjScore);

            //市级分值 sjQtbmFpWeight
            Double sjQtbmFpWeight=Double.valueOf(bizRespScoringWeight.getSjQtbmFpWeight());
            Double ccScore=(sjQtbmFpWeight/100)*cc_sj_wcfs;
            System.out.println("市级牵头部门总分=="+cc_sj_wcfs+"权重:"+sjQtbmWeight+"统计结果:"+ccScore);

            BigDecimal bd = new BigDecimal(qjScore+sjScore+ccScore);
            zhdf=bd.setScale(2, BigDecimal.ROUND_HALF_UP).doubleValue();
            String pj=getWeightQz(weightRankVOList, zhdf);
            map.put("zhdf",zhdf);
            map.put("pj",pj);
            map.put("sj_ccdf",cc_sj_wcfs);
        }else{
            //区级分值 zsZpbmWeight
            Double zsZpbmWeight=Double.valueOf(bizRespScoringWeight.getZsZpbmWeight());
            Double qjScore=(zsZpbmWeight/100)*qj_wcfs;
            System.out.println("区级牵头部门总分=="+qj_wcfs+"权重:"+zsZpbmWeight+"统计结果:"+qjScore);
            //市级分值 zsZpbmWeight
            Double sjQtbmWeight=Double.valueOf(bizRespScoringWeight.getSjQtbmWeight());
            Double qtbmWeight=100-zsZpbmWeight-Double.valueOf(bizRespScoringWeight.getSjQtbmWeight());
            System.out.println("==============无抽查数据计算查分比 start==========");
            System.out.println("==============区级百分比=========="+zsZpbmWeight);
            System.out.println("==============市级百分比=========="+sjQtbmWeight);
            System.out.println("==============100-区级百分比-市级百分比=========="+qtbmWeight);
            System.out.println("==============无抽查数据计算查分比 end ==========");
            Double sjScore=((sjQtbmWeight+qtbmWeight)/100)*sj_wcfs;
            System.out.println("市级牵头部门总分=="+sj_wcfs+"权重:"+sjQtbmWeight+"统计结果:"+sjScore);
            BigDecimal bd = new BigDecimal(qjScore+sjScore);
            zhdf=bd.setScale(2, BigDecimal.ROUND_HALF_UP).doubleValue();
            String pj=getWeightQz(weightRankVOList, zhdf);
            map.put("zhdf",zhdf);
            map.put("pj",pj);
            map.put("sj_ccdf","未抽中");
        }

        map.put("fnyfz",fnyfz);
        map.put("nyfz",nyfz);
        map.put("qj_zpdf",qj_wcfs);
        map.put("sj_khdf",sj_wcfs);
        map.put("result_status",resultStatus);
    }


    /**
     *
     * @param weightRankVOList
     * @param totalScore
     * @return
     */
    private String getWeightQz(List<BizRespScoringWeightRankVO> weightRankVOList, Double totalScore) {
        String result="";
        System.out.println("totalScore=="+totalScore);
        for(BizRespScoringWeightRankVO rankVO: weightRankVOList){
            System.out.println("rankVO=="+rankVO.toString());
            if(totalScore>=Double.valueOf(rankVO.getFzStart()) && totalScore<Double.valueOf(rankVO.getFzEnd())){
                result=rankVO.getRankName();
            }
        }
        return result;
    }


}