package com.unis.accountability.businessmanagement.service.impl;

import com.github.pagehelper.Page;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.github.pagehelper.util.StringUtil;
import com.unis.accountability.businessmanagement.common.vo.cityTaskDistribution.CityTaskPublishVO;
import com.unis.accountability.businessmanagement.common.vo.cityZpbm.ZpbmVO;
import com.unis.accountability.businessmanagement.common.vo.provinceTask.ProvinceTaskPage;
import com.unis.accountability.businessmanagement.common.vo.respScoreInput.BizRespRespScoreInputPublishVO;
import com.unis.accountability.businessmanagement.common.vo.respScoreInput.BizRespScoreInputSmiitVO;
import com.unis.accountability.businessmanagement.common.vo.respScoreInput.BizRespScoreInputVO;
import com.unis.accountability.businessmanagement.common.vo.responsibility.BizRespResponsibilityPageVO;
import com.unis.accountability.businessmanagement.entity.*;
import com.unis.accountability.businessmanagement.mapper.*;
import com.unis.accountability.businessmanagement.service.BizRespCityTaskfFService;
import com.unis.accountability.businessmanagement.service.BizRespDepartmentalOpinionService;
import com.unis.accountability.businessmanagement.service.BizRespScoreInputService;
import com.unis.common.utils.LsBeanUtils;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Isolation;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * @Auther:张新亮
 * @Date: 2019/9/19 0019 15:44
 * @Description:
 */
@Service
public class BizRespScoreInputServiceImpl implements BizRespScoreInputService {

    @Autowired
    private BizRespResponsibilityMapper bizRespResponsibilityMapper;
    @Autowired
    private BizRespExaminationTaskMapper bizRespExaminationTaskMapper;
    @Autowired
    private BizRespScoreInputMapper bizRespScoreInputMapper;
    @Autowired
    private BizRespDepartmentalOpinionService bizRespDepartmentalOpinionService;
    @Autowired
    private BizRespSummaryMapper bizRespSummaryMapper;
    @Autowired
    private BizRespScoringCityMapper bizRespScoringCityMapper;
    @Autowired
    private BizRespDepartmentalOpinionMapper bizRespDepartmentalOpinionMapper;
    @Autowired
    private BizRespCityTaskfFService bizRespCityTaskfFService;
        /**
     * 粮食安全首长责任制--下发州市考核任务----发布
     * @param inputPublishVO
     */
    @Override
    @Transactional(isolation = Isolation.READ_COMMITTED,rollbackFor = Exception.class)
    public String publish(BizRespRespScoreInputPublishVO inputPublishVO) {
    	
        BizRespResponsibility bizRespResponsibilityDO=bizRespResponsibilityMapper.selectByPrimaryKey(inputPublishVO.getId());
        bizRespResponsibilityDO.setStatus(1);
        bizRespResponsibilityDO.setFbTime(new Date());
        //查询天津所有市区
        List<BizRespExaminationTask> taskDOList=bizRespExaminationTaskMapper.findByResponsTaskList(inputPublishVO.getId());
        bizRespResponsibilityDO.setShiAreaCode(inputPublishVO.getQuAreaCode());
        for(Map  map:inputPublishVO.getAreaCodeList()){
            String areaCode=map.get("areaCode").toString();
            String areaCodeType=map.get("areaCodeType").toString();
            for(BizRespExaminationTask taskDO:taskDOList){
            	
            	Double fnyfz = Double.valueOf(taskDO.getFnyfz());
            	Double nyfz = Double.valueOf(taskDO.getNyfz());
                if("fnyq".equals(areaCodeType) && !fnyfz.equals(0D)){
                    BizRespScoreInput inputDO=new BizRespScoreInput();
                    //创建人
                    inputDO.setCreateBy(inputPublishVO.getUpdateBy());
                    //创建人
                    inputDO.setUpdateBy(inputPublishVO.getUpdateBy());
                    //创建时间
                    inputDO.setCreateTime(new Date());
                    inputDO.setUpdateTime(new Date());
                    //行政区划
                    inputDO.setAreaCode(areaCode);
                    //状态:未分配 0，,未录入，1 已录入  2 ,上报省级：3
                    inputDO.setStatus("0");
                    inputDO.setBizResexaminationTaskId(taskDO.getId());
                    bizRespScoreInputMapper.insertSelective(inputDO);
                    //创建考核指标的省级评分意见 --省级配合部门  牵头部门
                    bizRespDepartmentalOpinionService.save(taskDO, inputPublishVO, areaCode);
                    // 1 州市填报
                    taskDO.setTaskJd("1");
                    taskDO.setStatus(10);
                    bizRespExaminationTaskMapper.updateByPrimaryKeySelective(taskDO);
                }
                if("nyq".equals(areaCodeType) && !nyfz.equals(0D)){
                    BizRespScoreInput inputDO=new BizRespScoreInput();
                    //创建人
                    inputDO.setCreateBy(inputPublishVO.getUpdateBy());
                    //创建人
                    inputDO.setUpdateBy(inputPublishVO.getUpdateBy());
                    //创建时间
                    inputDO.setCreateTime(new Date());
                    inputDO.setUpdateTime(new Date());
                    //行政区划
                    inputDO.setAreaCode(areaCode);
                    //状态:未分配 0，,未录入，1 已录入  2 ,上报省级：3
                    inputDO.setStatus("0");
                    inputDO.setBizResexaminationTaskId(taskDO.getId());
                    bizRespScoreInputMapper.insertSelective(inputDO);
                    //创建考核指标的省级评分意见 --省级配合部门  牵头部门
                    bizRespDepartmentalOpinionService.save(taskDO, inputPublishVO, areaCode);
                    // 1 州市填报
                    taskDO.setTaskJd("1");
                    taskDO.setStatus(10);
                    bizRespExaminationTaskMapper.updateByPrimaryKeySelective(taskDO);
                }
                if(nyfz.equals(0D) && fnyfz.equals(0D)){
                    BizRespScoreInput inputDO=new BizRespScoreInput();
                    //创建人
                    inputDO.setCreateBy(inputPublishVO.getUpdateBy());
                    //创建人
                    inputDO.setUpdateBy(inputPublishVO.getUpdateBy());
                    //创建时间
                    inputDO.setCreateTime(new Date());
                    inputDO.setUpdateTime(new Date());
                    //行政区划
                    inputDO.setAreaCode(areaCode);
                    //状态:未分配 0，,未录入，1 已录入  2 ,上报省级：3
                    inputDO.setStatus("0");
                    inputDO.setBizResexaminationTaskId(taskDO.getId());
                    bizRespScoreInputMapper.insertSelective(inputDO);
                    //创建考核指标的省级评分意见 --省级配合部门  牵头部门
                    bizRespDepartmentalOpinionService.save(taskDO, inputPublishVO, areaCode);
                    // 1 州市填报
                    taskDO.setTaskJd("1");
                    taskDO.setStatus(10);
                    bizRespExaminationTaskMapper.updateByPrimaryKeySelective(taskDO);
                }
                
                
            }

            //创建汇总数据
            BizRespSummary summaryDO=new BizRespSummary();
            //创建人
            summaryDO.setCreateBy(inputPublishVO.getUpdateBy());
            //创建人
            summaryDO.setUpdateBy(inputPublishVO.getUpdateBy());
            //创建时间
            summaryDO.setCreateTime(new Date());
            summaryDO.setUpdateTime(new Date());
            //市行政区划
            summaryDO.setShiAreaCode(areaCode);
            summaryDO.setBizRespResponsibilityId(bizRespResponsibilityDO.getId());
            summaryDO.setAreaCode(bizRespResponsibilityDO.getAreaCode());
            bizRespSummaryMapper.insertSelective(summaryDO);

//            //创建州市的填报时间数据
//            BizRespScoringCity city=new BizRespScoringCity();
//            //创建人
//            city.setCreateBy(inputPublishVO.getUpdateBy());
//            //创建人
//            city.setUpdateBy(inputPublishVO.getUpdateBy());
//            //创建时间
//            city.setCreateTime(new Date());
//            city.setUpdateTime(new Date());
//            //市行政区划
//            city.setAreaCode(areaCode);
//            city.setYear(bizRespResponsibilityDO.getYear());
//            city.setStatus(0);
//            bizRespScoringCityMapper.insertSelective(city);
        }


        //保存分发数--- 评分表分处室考核（市部门）
        List<BizRespCityTaskfF> ffList=new ArrayList();
        for(BizRespExaminationTask taskDO:taskDOList){
            //牵头部门
            BizRespCityTaskfF qtbm=bizRespCityTaskfFService.getQtbmDate(taskDO);
            ffList.add(qtbm);
            //配合部门
            List<BizRespCityTaskfF> phbmList=bizRespCityTaskfFService.getPhbmDate(taskDO);
            if(phbmList!=null){
                ffList.addAll(phbmList);
            }
        }

        bizRespCityTaskfFService.save(ffList);

        bizRespResponsibilityDO.setStatus(2);
        bizRespResponsibilityDO.setKhrmTime(new Date());
        bizRespResponsibilityMapper.updateByPrimaryKeySelective(bizRespResponsibilityDO);
        return "1";
    }

    /**
     * 粮食安全首长责任制--州市考核任务管理  根据年分 状态 行政区划 查询 州市考核录入数据
     * @param cityTaskPublishVO
     * @return
     */
    @Override
    public List<BizRespScoreInputVO> findByYearAndStatusAndAreaCode(CityTaskPublishVO cityTaskPublishVO) {
        List<BizRespScoreInputVO> result=new ArrayList();
        List<BizRespScoreInput> inputList=bizRespScoreInputMapper.findByYearAndStatusAndAreaCode(cityTaskPublishVO);
        for(BizRespScoreInput input:inputList){
            BizRespScoreInputVO inputVO = LsBeanUtils.copyProperties(input, BizRespScoreInputVO.class);
            result.add(inputVO);
        }
        return result;
    }

    /**
     * 粮食安全首长责任制--下发州市考核任务----保存上传文件
     * @param id
     * @param zpbmVO
     */
    @Override
    public void saveFile(String id, ZpbmVO zpbmVO) {
        BizRespDepartmentalOpinion opinion=bizRespDepartmentalOpinionMapper.selectByPrimaryKey(id);
        String inptId=opinion.getBizRespScoreInputId();
        BizRespScoreInput bizRespScoreInput=bizRespScoreInputMapper.selectByPrimaryKey(inptId);
        bizRespScoreInput.setFileId(zpbmVO.getFileId());
        bizRespScoreInputMapper.updateByPrimaryKeySelective(bizRespScoreInput);
    }


    /**
     * 粮食安全首长责任制--下发州市考核任务----制定州市考核任务--- 分页查询
     * @param pageVO
     * @param page
     * @param size
     * @return
     */
    @Override
    public PageInfo<List<Map>> findTaskByPage(BizRespResponsibilityPageVO pageVO, Integer page, Integer size) {
        Page<List<Map>> listPage = PageHelper.startPage(page, size);
        List<Map> mapList=bizRespScoreInputMapper.findTaskByPage(pageVO);
        for(Map map:mapList){
            String areaList=map.get("SHI_AREA_CODE")==null?"":map.get("SHI_AREA_CODE").toString();
            if(StringUtils.isEmpty(areaList)){
                map.put("NUMBER",0);
            }else{
                String[] are=areaList.split(",");
                map.put("NUMBER",are.length);
            }
        }
        return listPage.toPageInfo();
    }

    /**
     * 州市、外部单位牵头部门、配合部门评分--查询是否可以提交数据
     * @param scoreInputSmiitVO
     * @return
     */
    @Override
    public String findByIsSubmit(BizRespScoreInputSmiitVO scoreInputSmiitVO) {
        if("80".equals(scoreInputSmiitVO.getType())){
            //0:未分配 ，1已分配  2 ,上报省级
            scoreInputSmiitVO.setStatus("1");
            List<BizRespScoreInput> inputList= bizRespScoreInputMapper.findByIsSubmit(scoreInputSmiitVO);
            if(inputList!=null && inputList.size()>0){
                return "yes";
            }else{
                return "no";
            }
        }else{
            return bizRespDepartmentalOpinionService.findByIsSubmit(scoreInputSmiitVO);
        }

    }

    @Override
    public void updateByArea(ProvinceTaskPage provinceTaskPage) {
        bizRespScoreInputMapper.updateByArea(provinceTaskPage);
    }



}