package com.unis.accountability.businessmanagement.service.impl;

import java.text.ParseException;
import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletResponse;

import com.unis.accountability.businessmanagement.common.vo.manageRuler.MangerRulesReceviceVO;
import com.unis.accountability.businessmanagement.common.vo.manageRuler.MangerRulesVO;
import com.unis.accountability.businessmanagement.common.vo.manageRuler.PageResult;
import com.unis.accountability.businessmanagement.domain.MangerRulesDomain;
import com.unis.accountability.businessmanagement.entity.MangerRulesDO;
import com.unis.accountability.businessmanagement.entity.MangerRulesReceviceDO;
import com.unis.accountability.businessmanagement.service.MangerRulesService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.alibaba.fastjson.JSONObject;
import com.unis.common.utils.LsBeanUtils;

/**
 * ty_wzcbglzd -- 粮食与物资储备管理下载接口层
 * 
 * @author liuweilong
 *
 */
@Service
public class MangerRulesServiceImpl implements MangerRulesService {

	@Autowired
	private MangerRulesDomain mangerRulesDomain;

	/**
	 * 新增
	 */
	@Override
	public void insertEntity(MangerRulesVO vo) {

		MangerRulesDO entity = JSONObject.parseObject(JSONObject.toJSONString(vo), MangerRulesDO.class);

		mangerRulesDomain.insertToTable(entity);
	}

	/**
	 * 修改
	 */
	@Override
	public int update(MangerRulesVO vo) {

		MangerRulesDO entity = JSONObject.parseObject(JSONObject.toJSONString(vo), MangerRulesDO.class);

		return mangerRulesDomain.update(entity);
	}

	/**
	 * 下发
	 */
	@Override
	public void issue(MangerRulesReceviceVO vo)  {
		
		MangerRulesReceviceDO entity = JSONObject.parseObject(JSONObject.toJSONString(vo), MangerRulesReceviceDO.class);

		mangerRulesDomain.issue(entity);
	}

	/**
	 * 下载
	 */
	@Override
	public void downLoad(HttpServletResponse response, String realPath) {

		try {
			mangerRulesDomain.downLoadFile(response, realPath);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * 删除
	 */
	@Override
	public void deleteBYPrimaryKey(String zdbm) {

		mangerRulesDomain.delete(zdbm);
	}

	/**
	 * 查看
	 */
	@Override
	public MangerRulesVO getInfomationByPrimarykey(String zdbm) {

		MangerRulesDO mangerRulesDO = mangerRulesDomain.getMangerRulesDOInformationByPrimaryKey(zdbm);

		MangerRulesVO mangerRulesVO = JSONObject.parseObject(JSONObject.toJSONString(mangerRulesDO),
				MangerRulesVO.class);

		return mangerRulesVO;

	}
	
	

	/**
	 * 列表查询
	 * @throws ParseException 
	 */
	@Override
	public PageResult<MangerRulesVO> getList(int pageNum, int pageSize, String wjmc, String scrq,List<String> orgCode, String orgId) throws ParseException {
			List<MangerRulesVO> items = new ArrayList<>();
			PageResult<MangerRulesDO> pageinfo = mangerRulesDomain.getList(pageNum, pageSize, wjmc, scrq,orgCode, orgId);
			
			if(pageinfo==null) {
				
				return null;
			}
		/*parallelstream使用foreach时可能会使原有元素的顺序变乱，由于arraylist线程不安全，会使遍历出的部分数据为null。
		 * pageinfo.getItems().parallelStream().forEach( applyDO -> { MangerRulesVO vo =
		 * new MangerRulesVO(); LsBeanUtils.copyAllProperties(applyDO, vo);
		 * items.add(vo); });
		 */
			List<MangerRulesDO> items2 = pageinfo.getItems();
			
			for (MangerRulesDO mangerRulesDO : items2) {
				
				MangerRulesVO vo = new MangerRulesVO();
				
				LsBeanUtils.copyAllProperties(mangerRulesDO, vo);
				
				items.add(vo);
				
			}
		
		//List<MangerRulesVO> mangerRulesList = new ArrayList<MangerRulesVO>();
		
		return new PageResult<MangerRulesVO>(pageinfo.getTotal(), pageinfo.getTotalPage(), pageNum, items);
		
	}

	@Override
	public String getJsbmByzdbm(String zdbm) {
		
		return mangerRulesDomain.getJsbmByzdbm(zdbm);
	}
	
}
