package com.unis.accountability.businessmanagement.service.impl;

import com.unis.accountability.businessmanagement.common.vo.examinationTask.BigTaskQueryVO;
import com.unis.accountability.businessmanagement.common.vo.examinationTask.BigTaskVO;
import com.unis.accountability.businessmanagement.common.vo.opinion.BizRespDepartmentalOpinionVO;
import com.unis.accountability.businessmanagement.domain.ProvinceLeadDeptDomain;
import com.unis.accountability.businessmanagement.service.ProvinceLeadDeptService;
import io.swagger.annotations.ApiModelProperty;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.List;
import java.util.Map;

/**
 * @Author zoujieli
 * @Description
 * @Date 2019/9/20 18:28
 * Version 1.0
 */
@Transactional
@Service
public class ProvinceLeadDeptServiceImpl implements ProvinceLeadDeptService {

    @Autowired
    private ProvinceLeadDeptDomain provinceLeadDeptDomain;

    @Override
    public Map getProvinceLeadDept(BigTaskQueryVO bigTaskQueryVO, Integer pageNum, Integer pageSize) {
        return provinceLeadDeptDomain.getProvinceLeadDept(bigTaskQueryVO,pageNum,pageSize);
    }

    @Override
    public BigTaskVO getProvinceLeadDeptDetail(String id) {
        return provinceLeadDeptDomain.getProvinceLeadDeptDetail(id);
    }

    @Override
    public void updateBizRespDepartmentalOpinion(BizRespDepartmentalOpinionVO bizRespDepartmentalOpinionVO) {
        provinceLeadDeptDomain.updateBizRespDepartmentalOpinion(bizRespDepartmentalOpinionVO);
    }

    @Override
    public List<BizRespDepartmentalOpinionVO> getProvinceCoordinateOpinion(Map selectMap) {
        return provinceLeadDeptDomain.getProvinceCoordinateOpinion(selectMap);
    }

    @Override
    public BizRespDepartmentalOpinionVO getProvinceLeadOpinion(Map selectMap) {
        return provinceLeadDeptDomain.getProvinceLeadOpinion(selectMap);
    }

    @Override
    public void insertProvinceLeadOpinion(BizRespDepartmentalOpinionVO bizRespDepartmentalOpinionVO) {
        provinceLeadDeptDomain.insertProvinceLeadOpinion(bizRespDepartmentalOpinionVO);
    }

    @Override
    public void updateTaskStatus(Map selectMap) {
        provinceLeadDeptDomain.updateTaskStatus(selectMap);
    }

//    @Override
//    public void updateProvinceCoordinateOpinionStatus(String oids) {
//        provinceLeadDeptDomain.updateProvinceCoordinateOpinionStatus(oids);
//    }

    @Override
    public BizRespDepartmentalOpinionVO getProvinceLeadAgainOpinion(Map<String, Object> resultMap) {
        return provinceLeadDeptDomain.getProvinceLeadAgainOpinion(resultMap);
    }
}
